# -----------------------------------------------------------------------
#Functions to substitute JSBsim tables interpolations
#Tooks vectors as input, gives a value as output

lin_inter=func(xy, x)
{
	y=0;

	if (x<xy[0][0])
	{
		x=xy[0][0];
	}

	if (x>xy[(size(xy)-1)][0])
	{
		x=xy[(size(xy)-1)][0];
	}

	forindex(var i; xy) 
	{
    if (
				(x>=xy[i][0]) and
					(x<=xy[i+1][0])
				)
		{
			b=(xy[i+1][1]-xy[i][1])/(xy[i+1][0]-xy[i][0]);
			a=xy[i+1][1]-b*xy[i+1][0];
			y=a+b*x;
			break;
		}
	}
	
	return(y);
}

sqr_inter=func(xy, x, y)
{
	z=0;

	if (x<xy[1][0])
	{
		x=xy[1][0];
	}

	if (x>xy[(size(xy)-1)][0])
	{
		x=xy[(size(xy)-1)][0];
	}

	if (y<xy[0][1])
	{
		y=xy[0][1];
	}

	if (y>xy[0][(size(xy[0])-1)])
	{
		y=xy[0][(size(xy[0])-1)];
	}

	counted=0;
	forindex(var i; xy) 
	{
		if (
				(i!=0) and
				(x>=xy[i][0]) and
				(x<=xy[i+1][0])
			)
		{
			forindex(var j; xy[i]) 
			{
				if (
						(j!=0) and
						(y>=xy[0][j]) and
						(y<=xy[0][j+1])
					)
				{
					b1=(xy[i+1][j]-xy[i][j])/(xy[i+1][0]-xy[i][0]);
					a1=xy[i+1][j]-b1*xy[i+1][0];
					b2=(xy[i+1][j+1]-xy[i][j+1])/(xy[i+1][0]-xy[i][0]);
					a2=xy[i+1][j+1]-b2*xy[i+1][0];
					z=
						(a1+b1*x)*(xy[0][j+1]-y)/(xy[0][j+1]-xy[0][j])+
						(a2+b2*x)*(y-xy[0][j])/(xy[0][j+1]-xy[0][j]);
					counted=1;
					break;
				}
			}
			if (counted==1)
			{
				break;
			}
		}
	}

	return(z);
}

sps_inter=func(xyz, x, y, z)
{
	f=0;

	if (x<xyz[0][0][0])
	{
		x=xyz[0][0][0];
	}

	if (x>xyz[(size(xyz)-1)][0][0])
	{
		x=xyz[(size(xyz)-1)][0][0];
	}

	if (y<xyz[0][1][0])
	{
		y=xyz[0][1][0];
	}

	if (y>xyz[0][(size(xyz[0])-1)][0])
	{
		y=xyz[0][(size(xyz[0])-1)][0];
	}

	if (z<xyz[0][0][1])
	{
		z=xyz[0][0][1];
	}

	if (z>xyz[0][0][(size(xyz[0][0])-1)])
	{
		z=xyz[0][0][(size(xyz[0][0])-1)];
	}

	counted=0;
	forindex(var i; xyz)
	{
		if (
				(x>=xyz[i][0][0]) and
				(x<=xyz[i+1][0][0])
			)
		{
			forindex(var j; xyz[i]) 
			{
				if (
						(j!=0) and
						(y>=xyz[i][j][0]) and
						(y<=xyz[i][j+1][0])
					)				
				{
					forindex(var k; xyz[i][j]) 
					{
						if (
								(k!=0) and
								(z>=xyz[i][0][k]) and
								(z<=xyz[i][0][k+1])
							)
						{

							b=(xyz[i][j+1][k]-xyz[i][j][k])/(xyz[i][j+1][0]-xyz[i][j][0]);
							a=xyz[i][j+1][k]-b*xyz[i][j+1][0];
							f1=(a+b*y);
							b=(xyz[i][j+1][k+1]-xyz[i][j][k+1])/(xyz[i][j+1][0]-xyz[i][j][0]);
							a=xyz[i][j+1][k+1]-b*xyz[i][j+1][0];
							f2=(a+b*y);
							fa=
								f1*(xyz[i][0][k+1]-z)/(xyz[i][0][k+1]-xyz[i][0][k])+
								f2*(z-xyz[i][0][k])/(xyz[i][0][k+1]-xyz[i][0][k]);
							b=(xyz[i+1][j+1][k]-xyz[i+1][j][k])/(xyz[i+1][j+1][0]-xyz[i+1][j][0]);
							a=xyz[i+1][j+1][k]-b*xyz[i+1][j+1][0];
							f1=(a+b*y);
							b=(xyz[i+1][j+1][k+1]-xyz[i+1][j][k+1])/(xyz[i+1][j+1][0]-xyz[i+1][j][0]);
							a=xyz[i+1][j+1][k+1]-b*xyz[i+1][j+1][0];
							f2=(a+b*y);
							fb=
								f1*(xyz[i+1][0][k+1]-z)/(xyz[i+1][0][k+1]-xyz[i+1][0][k])+
								f2*(z-xyz[i+1][0][k])/(xyz[i+1][0][k+1]-xyz[i+1][0][k]);
							f=
								fa*(xyz[i+1][0][0]-x)/(xyz[i+1][0][0]-xyz[i][0][0])+
								fb*(x-xyz[i][0][0])/(xyz[i+1][0][0]-xyz[i][0][0]);
							counted=1;
							break;
						}
					}
					if (counted==1)
					{
						break;
					}
				}
			}
		}
		if (counted==1)
		{
			break;
		}
	}

	return(f);
}

#Function to substitute kinemaitc
#Meant positions are between 0 and 1 always

kin=func(pos_from, pos_to, time_to, time_pass)
{

	pos=pos_from+
		math.sgn(pos_to-pos_from)*time_pass/time_to;

	if (
		(pos>pos_to)
		and (pos_from<=pos_to)
	)
	{
		pos=pos_to;
	}

	if (
		(pos<pos_to)
		and (pos_from>=pos_to)
	)
	{
		pos=pos_to;
	}

	return(pos);

}

test_example=func()
{

	var testable2 = 
	[	
		[0.0,			-0.261],
		[-100.00,	1.00],
		[0.00,		0.25],
		[100.00,	0.25]
	];

	print("inter "~sqr_inter(testable2, 75));


	var testable1 = 
	[	
		[0.0,			-0.261,	-0.174,	0.00,		0.261,	0.349],
		[-100.00,	1.00,		1.00,		1.00,		0.00,		-0.25],
		[0.00,		0.25,		0.00,		0.00,		0.00,		-0.25],
		[100.00,	0.25,		0.00,		-1.00,	-1.0,		-1.00]
	];

	print("inter "~sqr_inter(testable1, 75, 0.0));

	var testable = 
	[	
		[
			[0.5,			-0.261,	-0.174,	0.00,		0.261,	0.349],
			[-100.00,	1.00,		1.00,		1.00,		0.00,		-0.25],
			[0.00,		0.25,		0.00,		0.00,		0.00,		-0.25],
			[100.00,	0.25,		0.00,		-1.00,	-1.0,		-1.00]
		],
		[
			[1.00,		-0.261,	-0.174,	0.0,		0.261,	0.349],
			[-100.0,	0.025,	0.025,	0.025,	0.0,		-0.025],
			[0.0,			0.01,		0.0,		0.0,		0.0,		-0.01],
			[100.0,		0.01,		0.0,		-0.01,	-0.01,	-0.01],
		]
	];

	print("inter "~sps_inter(testable, 1.0, 75, 0.0));

	return (0);
}
