# (c) Victor Slavutinsky

# MPClash, multiplayer missiles tournoi de chevalerie protocol.

# MPClash do not account objects flight, collisions, etc.
# To code object on itself is matter of plane modeller.
# Protocol only shows flying objects of player and other players
# where it told to, and transfers messages about sights 
# and catches of these.

#	basic encoding functions	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

# Such limitation is result of 
# what in current FG multiplayer protocol
# sum of length of all multiplayer stings sent by
# player gotta be below 128 symbols mark,
# and it limited to printable chars,
# while symbols printable for sure is 
#	at 33..126 range at ascii table.

# That's all gotta be bug as whole, ...,
# but it's only option presented, while to deal
# with protocol itself is to get into that ...
# with head. Do it Yourself if You might.

# make string out of type index ---------------------------------------

type_to_string=func(type)
{
	return_value="";
	if (type < 0)
	{
		type=0;
	}
	b_cont=1;
	while (b_cont == 1)
	{
		return_value=return_value~chr(math.mod(type, 92)+33);
		type=(type-math.mod(type, 92))/92;
		if (type == 0)
		{
			b_cont=0;
		}
	}
	return return_value;
}

# make type index out of string ------------------------------------------

# string gotta be one char long

string_to_type=func(string)
{
	return_value=0;
	pos=0;
	while (pos < size(string))
	{
		return_value=return_value+(int(string[pos])-33)*(math.pow(92, pos));
		pos=pos+1;
	}
	return return_value;
}

# makes value in 0..360 range out of value in degrees----------------------

deg_in_range=func(deg)
{
	return_value=math.mod(deg, 360);
	if (return_value < 0)
	{
		return_value=return_value+360;
	}
	return return_value;
}

# make string out of deg in int 0..360 range------------------------------

deg_to_string=func(deg)
{
	deg=int(deg_in_range(deg));
	first_char=(deg-math.mod(deg, 92))/92;
	second_char=math.mod(deg, 92);
	return_value=chr(first_char+33)~chr(second_char+33);
	return return_value;
}

# make type index out of string ---------------------------------------

# string gotta be two chars long

string_to_deg=func(string)
{
	if (size(string) <2)
	{
		return_value=0;
	}
	else
	{
		return_value=(int(string[0])-33)*92+(int(string[1])-33);
	}
	return return_value;
}

# make string out of geo altitude in feets---------------------------------

# with 1/100 of feet precision, treats values less than 0 as 0 

geo_alt_to_string=func(alt)
{
	return_value="";
	if (alt < 0)
	{
		alt=0;
	}
	alt=int(alt*100);
	b_cont=1;
	while (b_cont == 1)
	{
		return_value=return_value~chr(math.mod(alt, 92)+33);
		alt=(alt-math.mod(alt, 92))/92;
		if (alt == 0)
		{
			b_cont=0;
		}
	}
	return return_value;
}

# make geo altitude out of string	----------------------------------

string_to_geo_alt=func(string)
{
	return_value=0;
	pos=0;
	while (pos < size(string))
	{
		return_value=return_value+(int(string[pos])-33)*(math.pow(92, pos));
		pos=pos+1;
	}
	return_value=return_value/100;
	return return_value;
}

# make string out of geo degree ---------------------------------

# with 1/100 of feet precision

geo_deg_to_string=func(deg)
{
	return_value="";
	deg=deg_in_range(deg);
	deg=int(deg*36521900);
	b_cont=1;
	while (b_cont == 1)
	{
		return_value=return_value~chr(math.mod(deg, 92)+33);
		deg=(deg-math.mod(deg, 92))/92;
		if (deg == 0)
		{
			b_cont=0;
		}
	}
	return return_value;
}

# make geo degree out of string	----------------------------------

string_to_geo_deg=func(string)
{
	return_value=0;
	pos=0;
	while (pos < size(string))
	{
		return_value=return_value+(int(string[pos])-33)*(math.pow(92, pos));
		pos=pos+1;
	}
	return_value=return_value/36521900;
	return return_value;
}

#	main functions	!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

# make string out of player data -------------------------------------

construct_output_strings=func()
{
	mpclash_node=props.globals.getNode("mpclash");	

	if (props.globals.getNode("sim/multiplay/callsign") == nil)
	{
		callsign="callsign";
	}
	else
	{
		callsign=props.globals.getNode("sim/multiplay/callsign").getValue();
	}

# construct string of targets visible to radar,
# to send them message that they are screened,

# and string of targets which was catch already,
# to send them message that they was catch

	var catches_str="&mpc";
	var sights_str="";

	models_node=props.globals.getNode("ai/models", 1);
	if (models_node.getChildren("multiplayer") != nil)
	{
		foreach (var node; models_node.getChildren("multiplayer"))
		{
			if (node.getNode("id") != nil)
			{
				if (node.getNode("id").getValue() != -1)
				{

					if (node.getNode("mpc-sight") != nil)
					{
						if (node.getNode("mpc-sight").getValue() == 1)
						{
							coord=geo.aircraft_position();
							mp_coord=geo.Coord.new();
							mp_coord.set_latlon(
								node.getNode("position/latitude-deg").getValue(),
								node.getNode("position/longitude-deg").getValue(),
								(node.getNode("position/altitude-ft").getValue()*0.3048));
							course_deg=coord.course_to(mp_coord)-180;
							if (sights_str == "")
							{
								sights_str=node.getNode("callsign").getValue()~" "~
									deg_to_string(course_deg);
							}
							else
							{
								sights_str=sights_str~" "~node.getNode("callsign").getValue()~" "~
									deg_to_string(course_deg);
							}
						}
					}

					if (node.getNode("mpc-catch") != nil)
					{
						foreach (var mpc_node; node.getNode("mpc-catch").getChildren("unit"))
						{
							catches_str=catches_str~" "~
								type_to_string(mpc_node.getNode("type-id").getValue())~" "~
								node.getNode("callsign").getValue();
						}
					}
				}
			}
		}
	}

	mpclash_node.getNode("output/catches-str").setValue(catches_str);
	mpclash_node.getNode("output/sights-str").setValue(sights_str);

# construct strings of flying objects launched by player
# to show these to others

	var object=0;
	var object_str="";

	if (mpclash_node.getNode("objects", 1) != nil)
	{
		foreach (var node; mpclash_node.getNode("objects").getChildren("unit"))
		{
			if ((node.getNode("callsign").getValue() == 
					props.globals.getNode("sim/multiplay/callsign").getValue())
				and (node.getNode("mp-id").getValue() == 0)
				and (object<4))
			{
				object_str=
					type_to_string(node.getNode("type-id").getValue())~" "~
					geo_deg_to_string(node.getNode("lat-deg").getValue())~" "~
					geo_deg_to_string(node.getNode("lon-deg").getValue())~" "~
					geo_alt_to_string(node.getNode("alt-ft").getValue())~" "~
					deg_to_string(node.getNode("pitch-deg").getValue())~" "~
					deg_to_string(node.getNode("roll-deg").getValue())~" "~
					deg_to_string(node.getNode("yaw-deg").getValue());
				foreach (var effect_node; node.getNode("effects").getChildren("unit"))
				{
					object_str=object_str~" "~type_to_string(effect_node.getNode("id").getValue());
				}
				mpclash_node.getNode("output/obj"~object~"-str").setValue(object_str);
				object=object+1;
			}
		}
	}

	if (object<3)
	{
		for (i=object; i<4; i+=1)
		{
			mpclash_node.getNode("output/obj"~i~"-str").setValue("");
		}
	}

}

# add sight to nodes if needed -------------------------------------

add_sight=func(sight, mp_callsign, mp_id, course_deg)
{
	mpclash_node=props.globals.getNode("mpclash");
	index=0;
	if (mpclash_node.getNode("sights") != nil)
	{
		foreach (var node; mpclash_node.getNode("sights").getChildren("unit"))
		{
			if ((node.getNode("mp-id").getValue() == mp_id)
				and (node.getNode("callsign").getValue() == mp_callsign))
			{
				if (index == sight)
				{
					node.getNode("course-deg").setValue(course_deg);
					return;
				}	
				else
				{
					index=index+1;
				}
			}
		}
	}
# if function not exited yet then it's needed to add sight
	sight_node=mpclash_node.getNode("sights", 1).addChild("unit");
	sight_node.getNode("callsign", 1).setValue(mp_callsign);
	sight_node.getNode("mp-id", 1).setValue(mp_id);
	sight_node.getNode("course-deg", 1).setValue(course_deg);
}

# remove excessive sights  -------------------------------------

remove_sights=func(sight, mp_callsign, mp_id)
{
	mpclash_node=props.globals.getNode("mpclash");
	index=0;
	if (mpclash_node.getNode("sights") != nil)
	{
		foreach (var node; mpclash_node.getNode("sights").getChildren("unit"))
		{
			if ((node.getNode("mp-id").getValue() == mp_id)
				and (node.getNode("callsign").getValue() == mp_callsign))
			{
				if (index == sight)
				{
					node.remove();
				}	
				else
				{
					index=index+1;
				}
			}
		}
	}
}

# add catch to nodes if needed -------------------------------------

add_catch=func(catch, mp_callsign, mp_id, type_id)
{
	mpclash_node=props.globals.getNode("mpclash");
	index=0;
	if (mpclash_node.getNode("catches") != nil)
	{
		foreach (var node; mpclash_node.getNode("catches").getChildren("unit"))
		{
			if ((node.getNode("mp-id").getValue() == mp_id)
				and (node.getNode("callsign").getValue() == mp_callsign))
			{
				if (index == catch)
				{
					node.getNode("type-id").setValue(type_id);
					return;
				}	
				else
				{
					index=index+1;
				}
			}
		}
	}
# if function not exited yet then it's needed to add catch
	catch_node=mpclash_node.getNode("catches", 1).addChild("unit");
	catch_node.getNode("callsign", 1).setValue(mp_callsign);
	catch_node.getNode("mp-id", 1).setValue(mp_id);
	catch_node.getNode("type-id", 1).setValue(type_id);

	if (props.globals.getNode("sim/multiplay/callsign") == nil)
	{
		callsign="callsign";
	}
	else
	{
		callsign=props.globals.getNode("sim/multiplay/callsign").getValue();
	}

	if (mpclash_node.getNode("types/unit["~type_id~"]/name") == nil)
	{
		print("MPClash: "~mp_callsign~" catched "~callsign~
			" by empty object substituting one with id="~type_id);
	}
	else
	{
		print("MPClash: "~mp_callsign~" catched "~callsign~" by "~
			mpclash_node.getNode("types/unit["~type_id~"]/name").getValue());
	}

}

# remove excessive catches  -------------------------------------

remove_catches=func(catch, mp_callsign, mp_id)
{
	mpclash_node=props.globals.getNode("mpclash");
	index=0;
	if (mpclash_node.getNode("catches") != nil)
	{
		foreach (var node; mpclash_node.getNode("catches").getChildren("unit"))
		{
			if ((node.getNode("mp-id").getValue() == mp_id)
				and (node.getNode("callsign").getValue() == mp_callsign))
			{
				if (index == catch)
				{
					node.remove();
				}	
				else
				{
					index=index+1;
				}
			}
		}
	}
}

# update object model effects if needed----------------------------

set_object_effects=func(object_node)
{
	mpclash_node=props.globals.getNode("mpclash");
	models_node=props.globals.getNode("models", 1);

	var effects_array=[];

	i=0;
	if (object_node.getNode("effects") != nil)
	{
		foreach (var node; object_node.getNode("effects").getChildren("unit"))
		{
			append(effects_array, node.getNode("id").getValue());
			i=i+1;
		}
	}

	if (models_node.getChildren("model") != nil)
	{
		foreach (var node; models_node.getChildren("model"))
		{
			if (node.getNode("legend") != nil)
			{
				added=0;
				for (i=0; i<size(effects_array); i+=1)
				{
					if (node.getNode("legend").getValue() == "mpc_"~
						object_node.getNode("callsign").getValue()~"_"~
						object_node.getNode("mp-id").getValue()~"_"~
						object_node.getNode("type-id").getValue()~"_"~
						object_node.getNode("id").getValue()~"_"~
						effects_array[i])
					{
							effects_array[i]=-1;
							added=1;
					}
				}

				if ((added ==0) and
					(find(
						"mpc_"~
						object_node.getNode("callsign").getValue()~"_"~
						object_node.getNode("mp-id").getValue()~"_"~
						object_node.getNode("type-id").getValue()~"_"~
						object_node.getNode("id").getValue()~"_",
						node.getNode("legend").getValue()) != -1))
				{
						node.remove();
				}
			}
		}
	}

	for (i=0; i<size(effects_array); i+=1)
	{
		if (effects_array[i] != -1) 
		{
			if (mpclash_node.getNode(
				"types/unit["~effects_array[i]~"]/type") == nil)
			{
					model_node=models_node.addChild("model");
					model_node.getNode("path", 1).setValue(
						mpclash_node.getNode("types/unit[0]/model-path").getValue());
	
					model_node.getNode("legend", 1).setValue("mpc_"~
						object_node.getNode("callsign").getValue()~"_"~
						object_node.getNode("mp-id").getValue()~"_"~
						object_node.getNode("type-id").getValue()~"_"~
						object_node.getNode("id").getValue()~"_"~
						effects_array[i]);
					model_node.getNode("latitude-deg-prop", 1).setValue(
						object_node.getNode("lat-deg").getPath());
					model_node.getNode("longitude-deg-prop", 1).setValue(
						object_node.getNode("lon-deg").getPath());
					model_node.getNode("elevation-ft-prop", 1).setValue(
						object_node.getNode("alt-ft").getPath());
					model_node.getNode("heading-deg-prop", 1).setValue(
						object_node.getNode("yaw-deg").getPath());
					model_node.getNode("pitch-deg-prop", 1).setValue(
						object_node.getNode("pitch-deg").getPath());
					model_node.getNode("roll-deg-prop", 1).setValue(
						object_node.getNode("roll-deg").getPath());
					model_node.getNode("load", 1).remove();

					print("MPClash: effect with id="~effects_array[i]~" is not found at set file. "~
						"Empty object added instead");
			}
			else
			{
				if (mpclash_node.getNode(
					"types/unit["~effects_array[i]~"]/type").getValue()
					!= 0)
				{
					model_node=models_node.addChild("model");
					model_node.getNode("path", 1).setValue(
						mpclash_node.getNode(
							"types/unit["~effects_array[i]~"]/model-path").getValue());
	
					model_node.getNode("legend", 1).setValue("mpc_"~
						object_node.getNode("callsign").getValue()~"_"~
						object_node.getNode("mp-id").getValue()~"_"~
						object_node.getNode("type-id").getValue()~"_"~
						object_node.getNode("id").getValue()~"_"~
						effects_array[i]);
					model_node.getNode("latitude-deg-prop", 1).setValue(
						object_node.getNode("lat-deg").getPath());
					model_node.getNode("longitude-deg-prop", 1).setValue(
						object_node.getNode("lon-deg").getPath());
					model_node.getNode("elevation-ft-prop", 1).setValue(
						object_node.getNode("alt-ft").getPath());
					model_node.getNode("heading-deg-prop", 1).setValue(
						object_node.getNode("yaw-deg").getPath());
					model_node.getNode("pitch-deg-prop", 1).setValue(
						object_node.getNode("pitch-deg").getPath());
					model_node.getNode("roll-deg-prop", 1).setValue(
						object_node.getNode("roll-deg").getPath());
					model_node.getNode("load", 1).remove();
		
					print("MPClash: "~
							mpclash_node.getNode(
								"types/unit["~effects_array[i]~"]/name").getValue()~
						" added to "~
							mpclash_node.getNode("types/unit["~
								object_node.getNode("type-id").getValue()~
								"]/name").getValue()~
						" of "~
						object_node.getNode("callsign").getValue());
				}
			}
		}
	}
}

# add object model if needed--------------------------------------

add_object_model=func(object_node)
{
	mpclash_node=props.globals.getNode("mpclash");
	models_node=props.globals.getNode("models", 1);

	already_added=0;

	if (models_node.getChildren("model") != nil)
	{
		foreach (var node; models_node.getChildren("model"))
		{
			if (node.getNode("legend") != nil)
			{
				if (node.getNode("legend").getValue() == "mpc_"~
					object_node.getNode("callsign").getValue()~"_"~
					object_node.getNode("mp-id").getValue()~"_"~
					object_node.getNode("type-id").getValue()~"_"~
					object_node.getNode("id").getValue())
				{
					already_added=1;
				}
			}
		}
	}

	if (already_added==0)
	{

		if (mpclash_node.getNode(
			"types/unit["~object_node.getNode("type-id").getValue()~"]/type") == nil)
		{
				model_node=models_node.addChild("model");
				model_node.getNode("path", 1).setValue(
					mpclash_node.getNode("types/unit[0]/model-path").getValue());

				model_node.getNode("legend", 1).setValue("mpc_"~
					object_node.getNode("callsign").getValue()~"_"~
					object_node.getNode("mp-id").getValue()~"_"~
					object_node.getNode("type-id").getValue()~"_"~
					object_node.getNode("id").getValue()~"_"~
					effects_array[i]);
				model_node.getNode("latitude-deg-prop", 1).setValue(
					object_node.getNode("lat-deg").getPath());
				model_node.getNode("longitude-deg-prop", 1).setValue(
					object_node.getNode("lon-deg").getPath());
				model_node.getNode("elevation-ft-prop", 1).setValue(
					object_node.getNode("alt-ft").getPath());
				model_node.getNode("heading-deg-prop", 1).setValue(
					object_node.getNode("yaw-deg").getPath());
				model_node.getNode("pitch-deg-prop", 1).setValue(
					object_node.getNode("pitch-deg").getPath());
				model_node.getNode("roll-deg-prop", 1).setValue(
					object_node.getNode("roll-deg").getPath());
				model_node.getNode("load", 1).remove();

				print("MPClash: object with id="~object_node.getNode("type-id").getValue()~" is not found at set file. "~
					"Empty object added instead");
		}
		else
		{
			model_node=models_node.addChild("model");
			model_node.getNode("path", 1).setValue(
				mpclash_node.getNode("types/unit["~
					object_node.getNode("type-id").getValue()~
					"]/model-path").getValue()
				);

			model_node.getNode("legend", 1).setValue("mpc_"~
				object_node.getNode("callsign").getValue()~"_"~
				object_node.getNode("mp-id").getValue()~"_"~
				object_node.getNode("type-id").getValue()~"_"~
				object_node.getNode("id").getValue());
			model_node.getNode("latitude-deg-prop", 1).setValue(
				object_node.getNode("lat-deg").getPath());
			model_node.getNode("longitude-deg-prop", 1).setValue(
				object_node.getNode("lon-deg").getPath());
			model_node.getNode("elevation-ft-prop", 1).setValue(
				object_node.getNode("alt-ft").getPath());
			model_node.getNode("heading-deg-prop", 1).setValue(
				object_node.getNode("yaw-deg").getPath());
			model_node.getNode("pitch-deg-prop", 1).setValue(
				object_node.getNode("pitch-deg").getPath());
			model_node.getNode("roll-deg-prop", 1).setValue(
				object_node.getNode("roll-deg").getPath());
			model_node.getNode("load", 1).remove();

			print("MPClash: "~
				mpclash_node.getNode("types/unit["~
					object_node.getNode("type-id").getValue()~
					"]/name").getValue()~
				" of "~object_node.getNode("callsign").getValue()~" is added");

			set_object_effects(object_node);
		}
	}
}

# set object effects ids, or update its data---------------------------------

set_object_effects_ids=func(node, effects_array)
{
	effects_ids_node=node.getNode("effects" ,1);
	for	(i=0;  i<size(effects_array); i+=1)
	{
		effects_ids_node.getNode("unit["~i~"]" ,1).
			getNode("id", 1).setValue(effects_array[i]);
	}
	foreach (var effect_id_node; node.getNode("effects").getChildren("unit"))
	{
		index=effect_id_node.getIndex();
		if (index == nil)
		{
			index=0;
		}
		if (index >= size(effects_array))
		{
			effect_id_node.remove();
		}
	}
}

# get object effects ids ----------------------------------------------------

get_object_effects_ids=func(node)
{
	return_array=[];
	effects_ids_node=node.getNode("effects" ,1);
	foreach (var effect_id_node; node.getNode("effects").getChildren("unit"))
	{
		append(return_array, effect_id_node.getNode("id").getValue());
	}
	return return_array;
}

# add object nodes if needed, or update its data------------------------------

add_object=func(object_array, effects_array)
{
	mpclash_node=props.globals.getNode("mpclash");
	id=0;
	if (mpclash_node.getNode("objects") != nil)
	{
		foreach (var node; mpclash_node.getNode("objects").getChildren("unit"))
		{
			if ((node.getNode("mp-id").getValue() == object_array[1])
				and (node.getNode("callsign").getValue() == object_array[0])
				and (node.getNode("type-id").getValue() == object_array[2]))
			{
				if (node.getNode("updated").getValue() == 0)
				{
					interpolate(node.getNode("lat-deg").getPath(),	object_array[3], 0.2);
					interpolate(node.getNode("lon-deg").getPath(),	object_array[4], 0.2);
					interpolate(node.getNode("alt-ft").getPath(),	object_array[5], 0.2);
					node.getNode("pitch-deg").setValue(object_array[6]);
					node.getNode("roll-deg").setValue(object_array[7]);
					node.getNode("yaw-deg").setValue(object_array[8]);
					node.getNode("id").setValue(id);
					node.getNode("updated").setValue(1);
					set_object_effects_ids(node, effects_array);
					set_object_effects(node);
					return;
				}
				else
				{
					id=id+1;
				}
			}	
		}
	}
# if function not exited yet then it's needed to add object
	node=mpclash_node.getNode("objects", 1).addChild("unit");
	node.getNode("callsign", 1).setValue(object_array[0]);
	node.getNode("mp-id", 1).setValue(object_array[1]);
	node.getNode("type-id", 1).setValue(object_array[2]);
	node.getNode("lat-deg", 1).setValue(object_array[3]);
	node.getNode("lon-deg", 1).setValue(object_array[4]);
	node.getNode("alt-ft", 1).setValue(object_array[5]);
	node.getNode("pitch-deg", 1).setValue(object_array[6]);
	node.getNode("roll-deg", 1).setValue(object_array[7]);
	node.getNode("yaw-deg", 1).setValue(object_array[8]);
	node.getNode("id", 1).setValue(id);
	node.getNode("updated", 1).setValue(1);

	add_object_model(node);
	set_object_effects_ids(node, effects_array);
	set_object_effects(node);
}

# remove object models --------------------------------------------

remove_object_model=func(object_node)
{
	mpclash_node=props.globals.getNode("mpclash");
	models_node=props.globals.getNode("models", 1);

	if (models_node.getChildren("model") != nil)
	{
		foreach (var node; models_node.getChildren("model"))
		{
			if (node.getNode("legend") != nil)
			{
				if (node.getNode("legend").getValue() == "mpc_"~
					object_node.getNode("callsign").getValue()~"_"~
					object_node.getNode("mp-id").getValue()~"_"~
					object_node.getNode("type-id").getValue()~"_"~
					object_node.getNode("id").getValue())
				{
					var effects_array=[];
					set_object_effects_ids(object_node, effects_array);
					set_object_effects(object_node, effects_array);
					node.remove();

					if (mpclash_node.getNode("types/unit["~
						object_node.getNode("type-id").getValue()~"]/name") == nil)
					{
						print("MPClash: empty object substituting one with id="~
							object_node.getNode("type-id").getValue()~
							" of "~object_node.getNode("callsign").getValue()~" is finished");
					}
					else
					{
						print("MPClash: "~
							mpclash_node.getNode("types/unit["~
								object_node.getNode("type-id").getValue()~
								"]/name").getValue()~
							" of "~object_node.getNode("callsign").getValue()~" is finished");
					}
				}
			}
		}
	}
}

# timed removal to avoid segmentation errors --------------------------

timed_object_removal=func(node)
{
	node.remove();
}

# remove excessive objects  -------------------------------------

remove_objects=func(mp_callsign, mp_id)
{
	mpclash_node=props.globals.getNode("mpclash");
	index=0;
	if (mpclash_node.getNode("objects") != nil)
	{
		foreach (var node; mpclash_node.getNode("objects").getChildren("unit"))
		{
			if ((node.getNode("mp-id").getValue() == mp_id)
				and (node.getNode("callsign").getValue() == mp_callsign))
			{
				if (node.getNode("updated").getValue() == 0)
				{
					remove_object_model(node);
					node.getNode("mp-id").setValue(-1);
					settimer(func timed_object_removal(node), 10);
				}	
				else
				{
					node.getNode("updated").setValue(0);
				}
			}
		}
	}
}

# make objects out of string sent by other player-----------------------------

deconstruct_input_strings=func(
	mp_callsign,
	mp_id,
	catches_str,
	objects_str_arr,
	sights_str)
{
	mpclash_node=props.globals.getNode("mpclash");

# check if something received trough protocol more or less correctly

	if (catches_str == nil)
	{
		return;
	}

	if (catches_str == "")
	{
		return;
	}

	input_array=split(" ", catches_str);

	if (input_array[0] != "&mpc")
	{
		return;
	}

# check cathes

	catch=0;
	if (size(input_array) > 1)
	{
# that guy catch someone with object, check if that 
# someone was player
		pos=1;
		while (pos < size(input_array))
		{
			if (input_array[pos+1]==
				props.globals.getNode("sim/multiplay/callsign").getValue())
			{
# he catch player
					add_catch(catch, mp_callsign, mp_id, string_to_type(input_array[pos]));
					catch=catch+1;
			}
			pos=pos+2;
		}
	}

# remove excessive catches

	remove_catches(catch, mp_callsign, mp_id);

# check sights

	input_array=split(" ", sights_str);

	pos=0;
	sight=0;

	while (pos < size(input_array))
	{
# that guy at other side sees someone, check if he sees player
		if (input_array[pos] ==
			props.globals.getNode("sim/multiplay/callsign").getValue())
		{
# he sees player
			add_sight(sight, mp_callsign, mp_id, string_to_deg(input_array[pos+1]));
			sight=sight+1;
		}
		pos=pos+2;
	}

# remove excessive sights of that player

	remove_sights(sight, mp_callsign, mp_id);

# check objects

	var object_array=["", 0, 0, 0, 0, 0, 0, 0, 0, 0];
	var effects_array=[];

	for (i=0; i<4; i+=1)
	{

		if (objects_str_arr[i] != "")
		{
			input_array=split(" ", objects_str_arr[i]);

# that one making some objects flying

			object_array[0]=mp_callsign;
			object_array[1]=mp_id;
			object_array[2]=string_to_type(input_array[0]);	#type
			object_array[3]=string_to_geo_deg(input_array[1]);	#lat-deg
			object_array[4]=string_to_geo_deg(input_array[2]);	#lon-deg
			object_array[5]=string_to_geo_alt(input_array[3]);	#alt-ft
			object_array[6]=string_to_deg(input_array[4]);	#pitch-deg
			object_array[7]=string_to_deg(input_array[5]);	#roll-deg
			object_array[8]=string_to_deg(input_array[6]);	#yaw-deg
			effects_array=[];
			if (size(input_array) > 7)
			{
				for (j=7; j<size(input_array); j+=1)
				{
					#effects	types
					append(effects_array, string_to_type(input_array[j]));
				}
			}
# add that object, or change its data

			add_object(object_array, effects_array);
		}
	}

# remove excessive objects

	remove_objects(mp_callsign, mp_id);

}

# main procedure ###############################################

# Note that not multiplayer id is used but index in list.
# Since id changes to -1 at connection end it's only way
# to remove objects launched by other player on that
# player going off.

mpclash=func()
{
	mpclash_node=props.globals.getNode("mpclash");
	models_node=props.globals.getNode("ai/models", 1);
	var objects_str_arr=["", "", "", ""];
	if ((models_node.getChildren("multiplayer") != nil) and
		(mpclash_node.getNode("control/receive").getValue()	==	1))
	{
		foreach (var node; models_node.getChildren("multiplayer"))
		{
			index=node.getIndex();
			if (index == nil)
			{
				index=0;
			}
			if (node.getNode("id") != nil)
			{
				if (node.getNode("id").getValue() != -1)
				{
					if (node.getNode("sim/multiplay/generic/string[14]").getValue() != nil)
					{
						if (node.getNode("sim/multiplay/generic/string[14]").getValue() != "")
						{
							objects_str_arr[0]=
								node.getNode("sim/multiplay/generic/string[15]").getValue();
							objects_str_arr[1]=
								node.getNode("sim/multiplay/generic/string[16]").getValue();
							objects_str_arr[2]=
								node.getNode("sim/multiplay/generic/string[17]").getValue();
							objects_str_arr[3]=
								node.getNode("sim/multiplay/generic/string[18]").getValue();
							deconstruct_input_strings(
								node.getNode("callsign").getValue(),
								index,
								node.getNode("sim/multiplay/generic/string[14]").getValue(),
								objects_str_arr,
								node.getNode("sim/multiplay/generic/string[19]").getValue());
						}
					}
				}
				else
				{
					if (node.getNode("sim/multiplay/generic/string[14]").getValue() != nil)
					{
						if (node.getNode("sim/multiplay/generic/string[14]").getValue() != "")
						{
							remove_objects(
								node.getNode("callsign").getValue(),
								index);
							remove_catches(0,
								node.getNode("callsign").getValue(),
								index);
							remove_sights(0,
								node.getNode("callsign").getValue(),
								index);
						}
					}
				}
			}
		}
	}
	if	(mpclash_node.getNode("control/send").getValue()	==	1)
	{
		construct_output_strings();
	}
	settimer(func mpclash(), 0.2);
}

# Next functions are used to control users part of protocol.

# add user object node if needed------------------------------------

add_user_object=func(user_object_array)
{
	mpclash_node=props.globals.getNode("mpclash");

	if (props.globals.getNode("sim/multiplay/callsign") == nil)
	{
		callsign="callsign";
	}
	else
	{
		callsign=props.globals.getNode("sim/multiplay/callsign").getValue();
	}

	if (mpclash_node.getNode("objects") != nil)
	{
		foreach (var node; mpclash_node.getNode("objects").getChildren("unit"))
		{
			if ((node.getNode("mp-id").getValue() == 0)
				and (node.getNode("callsign").getValue() == callsign)
				and (node.getNode("type-id").getValue() == user_object_array[0])
				and (node.getNode("id").getValue() == user_object_array[1]))
			{
				var effects_array=[];
				if (size(user_object_array) > 8)
				{
					for (i=8; i<size(user_object_array); i+=1)
					{
						#effects	types
						append(effects_array, user_object_array[i]);
					}
				}
				set_object_effects_ids(node, effects_array);
				set_object_effects(node);
				return;
			}	
		}
	}
# if function not exited yet then it's needed to add users object
	node=mpclash_node.getNode("objects", 1).addChild("unit");
	node.getNode("callsign", 1).setValue(callsign);
	node.getNode("mp-id", 1).setValue(0);
	node.getNode("type-id", 1).setValue(user_object_array[0]);
	node.getNode("id", 1).setValue(user_object_array[1]);
	node.getNode("lat-deg", 1).alias(user_object_array[2]);
	node.getNode("lon-deg", 1).alias(user_object_array[3]);
	node.getNode("alt-ft", 1).alias(user_object_array[4]);
	node.getNode("pitch-deg", 1).alias(user_object_array[5]);
	node.getNode("roll-deg", 1).alias(user_object_array[6]);
	node.getNode("yaw-deg", 1).alias(user_object_array[7]);
	var effects_array=[];
	if (size(user_object_array) > 8)
	{
		for (i=8; i<size(user_object_array); i+=1)
		{
			#effects	types
			append(effects_array, user_object_array[i]);
		}
	}
	set_object_effects_ids(node, effects_array);
	set_object_effects(node);
	add_object_model(node);
}

# updates user object model effects if needed------------------------

set_user_object_effects=func(type_id, id, effects_array)
{
	mpclash_node=props.globals.getNode("mpclash");

	if (props.globals.getNode("sim/multiplay/callsign") == nil)
	{
		callsign="callsign";
	}
	else
	{
		callsign=props.globals.getNode("sim/multiplay/callsign").getValue();
	}

	if (mpclash_node.getNode("objects") != nil)
	{
		foreach (var node; mpclash_node.getNode("objects").getChildren("unit"))
		{
			if ((node.getNode("mp-id").getValue() == 0)
				and (node.getNode("callsign").getValue() == callsign)
				and (node.getNode("type-id").getValue() == type_id)
				and (node.getNode("id").getValue() == id))
			{
				set_object_effects_ids(node, effects_array);
				set_object_effects(node);
				return;
			}
		}
	}

}

# remove user object  -------------------------------------

remove_user_object=func(type_id, id)
{
	mpclash_node=props.globals.getNode("mpclash");
	index=0;

	if (props.globals.getNode("sim/multiplay/callsign") == nil)
	{
		callsign="callsign";
	}
	else
	{
		callsign=props.globals.getNode("sim/multiplay/callsign").getValue();
	}

	if (mpclash_node.getNode("objects") != nil)
	{
		foreach (var node; mpclash_node.getNode("objects").getChildren("unit"))
		{
			if ((node.getNode("mp-id").getValue() == 0)
				and (node.getNode("callsign").getValue() == callsign)
				and (node.getNode("type-id").getValue() == type_id)
				and (node.getNode("id").getValue() == id))
			{
				remove_object_model(node);
				node.remove();
			}
		}
	}
}

# check if user was catched by object of some type------------------------------

check_catch=func(type_id)
{
	mpclash_node=props.globals.getNode("mpclash");
	return_value=0;
	if (mpclash_node.getNode("catches") != nil)
	{
		foreach (var node; mpclash_node.getNode("catches").getChildren("unit"))
		{
			if ((node.getNode("type-id").getValue() == type_id) or
				(type_id == -1))
			{
				return_value=return_value+1;
			}
		}
	}
	return return_value;
}

# say that radar sights, and so lights or not lights some target-----------------------------

set_sight=func(node, value)
{
	node.getNode("mpc-sight", 1).setValue(value);
}

# say that radar sights, and so lights or not lights some target-----------------------------

check_sight=func(node)
{
	return_value=0;
	if (node.getNode("mpc-sight") == nil)
	{
		node.getNode("mpc-sight", 1).setValue(0);
	}
	else
	{
		return_value=node.getNode("mpc-sight").getValue();
	}
	return return_value;
}

# chech is someone see player with radar -------------------------------------

check_sights=func()
{
	return_array=[];
	mpclash_node=props.globals.getNode("mpclash");
	if (mpclash_node.getNode("sights") != nil)
	{
		foreach (var node; mpclash_node.getNode("sights").getChildren("unit"))
		{
			append(return_array, node.getNode("course-deg").getValue());
		}
	}
	return return_array;
}

# check is some object sees player with radar -------------------------------------

check_objects_sights=func()
{
	return_hash={};
	return_hash.course_to_deg=[];
	return_hash.pitch_to_deg=[];
	return_hash.pitch_from_deg=[];
	return_hash.yaw_from_deg=[];

	if (props.globals.getNode("sim/multiplay/callsign") == nil)
	{
		callsign="callsign";
	}
	else
	{
		callsign=props.globals.getNode("sim/multiplay/callsign").getValue();
	}

	mpclash_node=props.globals.getNode("mpclash");
	if (mpclash_node.getNode("objects") != nil)
	{
		foreach (var node; mpclash_node.getNode("objects").getChildren("unit"))
		{
			if (node.getNode("callsign").getValue() != callsign)
			{
				effects_array=get_object_effects_ids(node);
				active_radar=0;
				for (i=0; i<size(effects_array); i+=1)
				{
					if (effects_array[i] == 7)	#id of active radar of missile
					{
						active_radar=1;
					}
				}
				if (active_radar	==	1)
				{
					coord=geo.aircraft_position();
					mp_coord=geo.Coord.new();
					mp_coord.set_latlon(
						node.getNode("lat-deg").getValue(),
						node.getNode("lon-deg").getValue(),
						(node.getNode("alt-ft").getValue()*0.3048));
					course_to_deg=coord.course_to(mp_coord);
					course_from_deg=mp_coord.course_to(coord);
					heights_rad=math.atan2((coord.alt()-mp_coord.alt()), 
					mp_coord.direct_distance_to(coord));
					heights_from_deg=heights_rad/math.pi*180;
					heights_to_deg=-heights_rad/math.pi*180;
					pitch_from_deg=heights_from_deg-node.getNode("pitch-deg").getValue();
					pitch_to_deg=heights_to_deg-props.globals.getNode("orientation/pitch-deg").getValue();
					yaw_from_deg=deg_in_range(course_from_deg-node.getNode("yaw-deg").getValue());
					if (yaw_from_deg>180)
					{
						yaw_from_deg=yaw_from_deg-360;
					}
					append(return_hash.course_to_deg, course_to_deg);
					append(return_hash.pitch_to_deg, pitch_to_deg);
					append(return_hash.pitch_from_deg, pitch_from_deg);
					append(return_hash.yaw_from_deg, yaw_from_deg);
				}
			}
		}
	}
	return return_hash;
}

# say that object catched or not catched some craft----------------------------

set_catch=func(node, type_id, id, value)
{
	catch_nodes=node.getNode("mpc-catch", 1);
	already_added=0;
	if (catch_nodes.getChildren("unit") != nil)
	{
		foreach (var node; catch_nodes.getChildren("unit"))
		{
			if ((node.getNode("type-id").getValue() == type_id) and
				(node.getNode("id").getValue() == id))
			{
				if (value == 1)
				{
					already_added=1;
				}
				else
				{
					node.remove();
				}
			}
		}
	}
	if ((value == 1)
		and (already_added == 0))
	{
		node=catch_nodes.addChild("unit");
		node.getNode("type-id", 1).setValue(type_id);
		node.getNode("id", 1).setValue(id);
	}
}

# remove all catches made by some object previously launched by user------------

remove_user_catches=func(type_id, id)
{
	models_node=props.globals.getNode("ai/models", 1);
	if (models_node.getChildren("multiplayer") != nil)
	{
		foreach (var node; models_node.getChildren("multiplayer"))
		{
			catch_nodes=node.getNode("mpc-catch", 0);
			if (catch_nodes!=nil)
			{
				if (catch_nodes.getChildren("unit") != nil)
				{
					foreach (var catch_node; catch_nodes.getChildren("unit"))
					{
						if ((catch_node.getNode("type-id").getValue() == type_id) and
							(catch_node.getNode("id").getValue() == id))
						{
							catch_node.remove();
						}
					}
				}
			}
		}
	}
}

# start main procedure-----------------------------------------------------------

mpclash();
