# -----------------------------------------------------------------------
# Su-15 JSBSim electrical system simplified nasal analog

electrical=func()
{

	fdm_node=props.globals.getNode("fdm/jsbsim");

	time_sec=props.globals.getNode("sim/time/elapsed-sec").getValue();
	time_sec_prev=fdm_node.getNode("systems/electrical/time-sec").getValue();
	tick_sec=time_sec-time_sec_prev;
	fdm_node.getNode("systems/electrical/time-sec").setValue(time_sec);

	#Serviceability

	if (
		(fdm_node.getNode("breakage/broken").getValue()==1) and
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{
		fdm_node.getNode("systems/electrical/serviceable").setValue(0);
	}

	if (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
	{
		fdm_node.getNode("systems/electrical/serviceable").setValue(1);
	}

	#Energy consumption for constant current

	fdm_node.getNode("systems/electrical/const-cons-a").setValue(
		fdm_node.getNode("systems/rightpanel/gears-control-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/gears-signal-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/brake-chute-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/drop-switch").getValue()*
		10+
		fdm_node.getNode("systems/rightpanel/emergency-drop-switch").getValue()*
		10+
		fdm_node.getNode("systems/rightpanel/hanger-signal-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/heating-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/pump-second-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/control-instrumentation-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/engine-start-switch").getValue()*
		25+
		fdm_node.getNode("systems/rightpanel/airstart-left-switch").getValue()*
		10+
		fdm_node.getNode("systems/rightpanel/airstart-right-switch").getValue()*
		10+
		fdm_node.getNode("systems/rightpanel/reheat-left-switch").getValue()*
		15+
		fdm_node.getNode("systems/rightpanel/reheat-right-switch").getValue()*
		15+
		fdm_node.getNode("systems/rightpanel/pump-first-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/transfer-pump-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/converter-switch").getValue()*
		2+
		fdm_node.getNode("systems/rightpanel/power-control-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/generator-first-switch").getValue()*
		2+
		fdm_node.getNode("systems/rightpanel/generator-second-switch").getValue()*
		2+
		fdm_node.getNode("systems/leftpanel/emergency-pump-start-switch").getValue()*
		10
	);

	fdm_node.getNode("systems/electrical/const-cons-norm").setValue(
		(
			fdm_node.getNode("systems/electrical/const-cons-a").getValue()/
			(
				5+
				5+
				5+
				10+
				10+
				5+
				5+
				5+
				5+
				25+
				10+
				10+
				15+
				15+
				5+
				5+
				2+
				5+
				2+
				2+
				10
			)
		)*
		(-1)
	);

	fdm_node.getNode("systems/electrical/const-cons-half-pers").setValue(
		fdm_node.getNode("systems/electrical/const-cons-norm").getValue()/
		2
	);

	fdm_node.getNode("systems/electrical/const-cons-v").setValue(
		interpol.sqr_inter(
			[
				[0.0,	0.0,	1.0],
				[0.0,	0.0,	29.0],
				[1.0,	0.0,	27.0]
			],
			fdm_node.getNode("systems/electrical/const-cons-norm").getValue(),
			fdm_node.getNode("systems/electrical/on").getValue()
		)
	);

	#First alternate current, 115 volts, energy consumption

	fdm_node.getNode("systems/electrical/alt-first-cons-a").setValue(
		fdm_node.getNode("systems/rightpanel/radio-switch").getValue()*
		15+
		fdm_node.getNode("systems/rightpanel/blcs-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/hydrosystem-control-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/fire-control-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/fire-left-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/fire-right-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/radiocompass-switch").getValue()*
		10+
		fdm_node.getNode("systems/rightpanel/radar-switch").getValue()*
		10+
		fdm_node.getNode("systems/rightpanel/blcs-signal-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/intake-left-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/intake-right-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/fuelometer-switch").getValue()*
		5+
		fdm_node.getNode("systems/rightpanel/light-switch").getValue()*
		10
	);

	fdm_node.getNode("systems/electrical/alt-first-cons-norm").setValue(
		fdm_node.getNode("systems/electrical/alt-first-cons-a").getValue()/
		(
			15+
			5+
			5+
			5+
			5+
			5+
			10+
			10+
			5+
			5+
			5+
			5+
			10
		)
	);

	fdm_node.getNode("systems/electrical/alt-first-cons-half-pers").setValue(
		fdm_node.getNode("systems/electrical/alt-first-cons-norm").getValue()/
		2
	);

	fdm_node.getNode("systems/electrical/alt-first-cons-v").setValue(
		interpol.sqr_inter(
			[
				[0.0,	0.0,	1.0],
				[0.0,	0.0,	112.0],
				[1.0,	0.0,	118.0]
			],
			fdm_node.getNode("systems/electrical/alt-first-cons-norm").getValue(),
			fdm_node.getNode("systems/electrical/some-alt-gen-on").getValue()
		)
	);

	#Second alternate current, 36 volts, energy consumption

	fdm_node.getNode("systems/electrical/alt-second-cons-a").setValue(
		fdm_node.getNode("systems/rightpanel/arthorizon-switch").getValue()*
		20+
		fdm_node.getNode("systems/rightpanel/course-system-switch").getValue()*
		15
	);

	fdm_node.getNode("systems/electrical/alt-second-cons-norm").setValue(
		fdm_node.getNode("systems/electrical/alt-second-cons-a").getValue()/
		(
			20+
			15
		)
	);

	fdm_node.getNode("systems/electrical/alt-second-cons-half-pers").setValue(
		fdm_node.getNode("systems/electrical/alt-second-cons-norm").getValue()/
		2
	);

	fdm_node.getNode("systems/electrical/alt-second-cons-v").setValue(
		interpol.sqr_inter(
			[
				[0.0,	0.0,	1.0],
				[0.0,	0.0,	34.0],
				[1.0,	0.0,	38.0]
			],
			fdm_node.getNode("systems/electrical/alt-second-cons-norm").getValue(),
			fdm_node.getNode("systems/electrical/conv-on").getValue()
		)
	);

	#Generators

	if (
		(fdm_node.getNode("systems/powerpanel/const-gen-first-switch").getValue()==1) and
		(fdm_node.getNode("propulsion/engine[0]/n1").getValue()>=fdm_node.getNode("systems/electrical/min-n").getValue())
	)
	{
		fdm_node.getNode("systems/electrical/gen-first-on").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/electrical/gen-first-on").setValue(0);
	}

	if (
		(fdm_node.getNode("systems/powerpanel/const-gen-second-switch").getValue()==1) and
		(fdm_node.getNode("propulsion/engine[1]/n1").getValue()>=fdm_node.getNode("systems/electrical/min-n").getValue())
	)
	{
		fdm_node.getNode("systems/electrical/gen-sec-on").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/electrical/gen-sec-on").setValue(0);
	}

	if (
		(fdm_node.getNode("systems/electrical/gen-first-on").getValue()==1) or
		(fdm_node.getNode("systems/electrical/gen-sec-on").getValue()==1)
	)
	{
		fdm_node.getNode("systems/electrical/some-gen-on").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/electrical/some-gen-on").setValue(0);
	}

	if (
		(fdm_node.getNode("systems/powerpanel/alt-gen-first-switch").getValue()==1) and
		(fdm_node.getNode("systems/powerpanel/gen-relay-first-switch").getValue()==0) and
		(fdm_node.getNode("propulsion/engine[0]/n1").getValue()>=fdm_node.getNode("systems/electrical/min-n").getValue())
	)
	{
		fdm_node.getNode("systems/electrical/alt-gen-first-on").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/electrical/alt-gen-first-on").setValue(0);
	}

	fdm_node.getNode("systems/electrical/alt-gen-first-cons").setValue(
		fdm_node.getNode("systems/electrical/alt-first-cons-norm").getValue()*
		interpol.sqr_inter(
			[
				[0.0,	0.0,	1.0],
				[0.0,	0.0,	0.0],
				[1.0,	2.0,	1.0]
			],
			fdm_node.getNode("systems/electrical/alt-gen-first-on").getValue(),
			fdm_node.getNode("systems/electrical/alt-gen-second-on").getValue()
		)
	);

	fdm_node.getNode("systems/electrical/alt-gen-first-v").setValue(
		fdm_node.getNode("systems/electrical/alt-first-cons-v").getValue()*
		fdm_node.getNode("systems/electrical/alt-gen-first-on").getValue()
	);

	if (
		(fdm_node.getNode("systems/powerpanel/alt-gen-second-switch").getValue()==1) and
		(fdm_node.getNode("systems/powerpanel/gen-relay-second-switch").getValue()==0) and
		(fdm_node.getNode("propulsion/engine[1]/n1").getValue()>=fdm_node.getNode("systems/electrical/min-n").getValue())
	)
	{
		fdm_node.getNode("systems/electrical/alt-gen-second-on").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/electrical/alt-gen-second-on").setValue(0);
	}

	fdm_node.getNode("systems/electrical/alt-gen-second-cons").setValue(
		fdm_node.getNode("systems/electrical/alt-first-cons-norm").getValue()*
		interpol.sqr_inter(
			[
				[0.0,	0.0,	1.0],
				[0.0,	0.0,	2.0],
				[1.0,	0.0,	1.0]
			],
			fdm_node.getNode("systems/electrical/alt-gen-first-on").getValue(),
			fdm_node.getNode("systems/electrical/alt-gen-second-on").getValue()
		)
	);

	fdm_node.getNode("systems/electrical/alt-gen-second-v").setValue(
		fdm_node.getNode("systems/electrical/alt-first-cons-v").getValue()*
		fdm_node.getNode("systems/electrical/alt-gen-second-on").getValue()
	);

	#Both generators feeds first alt current system

	if (
		(fdm_node.getNode("systems/electrical/alt-gen-first-on").getValue()==1) or
		(fdm_node.getNode("systems/electrical/alt-gen-second-on").getValue()==1)
	)
	{
		fdm_node.getNode("systems/electrical/some-alt-gen-on").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/electrical/some-alt-gen-on").setValue(0);
	}

	#Second alt current system is feed by converter

	if (
		(fdm_node.getNode("systems/electrical/on").getValue()==1) and
		(fdm_node.getNode("systems/rightpanel/converter-switch").getValue()==1) and
		(fdm_node.getNode("systems/powerpanel/conv-relay-switch").getValue()==0)
	)
	{
		fdm_node.getNode("systems/electrical/conv-on").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/electrical/conv-on").setValue(0);
	}

	fdm_node.getNode("systems/electrical/conv-cons").setValue(
		fdm_node.getNode("systems/electrical/conv-on").getValue()*
		fdm_node.getNode("systems/electrical/alt-second-cons-norm").getValue()
	);

	fdm_node.getNode("systems/electrical/conv-v").setValue(
		fdm_node.getNode("systems/electrical/conv-on").getValue()*
		fdm_node.getNode("systems/electrical/alt-second-cons-v").getValue()
	);

	#Common accumulator heating calculation

	fdm_node.getNode("systems/electrical/heat-pers").setValue(
		fdm_node.getNode("systems/electrical/const-cons-norm").getValue()*
		(-4)
	);

	fdm_node.getNode("systems/electrical/heat-half-pers").setValue(
		fdm_node.getNode("systems/electrical/heat-pers").getValue()/
		2
	);

	#Common power

	if (
		(fdm_node.getNode("systems/powerpanel/acc-first-switch").getValue()==1) or
		(fdm_node.getNode("systems/powerpanel/acc-second-switch").getValue()==1) or
		(fdm_node.getNode("systems/electrical/some-gen-on").getValue()==1)
	)
	{
		fdm_node.getNode("systems/electrical/on").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/electrical/on").setValue(0);
	}

	#First accumulatior recharge/charge

	fdm_node.getNode("systems/electrical/acc-first-return-pers").setValue(
		(
			(
				100-
				fdm_node.getNode("systems/electrical/acc-first-pers").getValue()
			)
			/100
		)*
		99
	);

	input_pers=0;

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==1) or
		(fdm_node.getNode("systems/refill/on-switch").getValue()==1)
	)
	{
		input_pers=fdm_node.getNode("systems/electrical/acc-first-return-pers").getValue();
	}

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/refill/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/electrical/serviceable").getValue()==1) and
		(fdm_node.getNode("systems/powerpanel/acc-first-switch").getValue()==1) and
		(fdm_node.getNode("systems/powerpanel/acc-second-switch").getValue()==0) and
		(fdm_node.getNode("systems/electrical/gen-first-on").getValue()==0) and
		(fdm_node.getNode("systems/electrical/gen-sec-on").getValue()==0) and
		(fdm_node.getNode("systems/electrical/acc-first-pers").getValue()>1)
	)
	{
		input_pers=fdm_node.getNode("systems/electrical/const-cons-norm").getValue();
	}

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/refill/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/electrical/serviceable").getValue()==1) and
		(fdm_node.getNode("systems/powerpanel/acc-first-switch").getValue()==1) and
		(fdm_node.getNode("systems/powerpanel/acc-second-switch").getValue()==1) and
		(fdm_node.getNode("systems/electrical/gen-first-on").getValue()==0) and
		(fdm_node.getNode("systems/electrical/gen-sec-on").getValue()==0) and
		(fdm_node.getNode("systems/electrical/acc-first-pers").getValue()>1)
	)
	{
		input_pers=fdm_node.getNode("systems/electrical/const-cons-half-pers").getValue();
	}

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/refill/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/electrical/serviceable").getValue()==1) and
		(fdm_node.getNode("systems/electrical/some-gen-on").getValue()==1) and
		(fdm_node.getNode("systems/electrical/acc-first-pers").getValue()<99)
	)
	{
		input_pers=0.1;
	}

	fdm_node.getNode("systems/electrical/acc-first-input-pers").setValue(input_pers);

	#pids substitute, rough integrator

	fdm_node.getNode("systems/electrical/acc-first-pers").setValue(
		fdm_node.getNode("systems/electrical/acc-first-pers").getValue()+
		fdm_node.getNode("systems/electrical/acc-first-input-pers").getValue()*tick_sec
	);

	#First accumulatior heating

	fdm_node.getNode("systems/electrical/acc-first-heat-return").setValue(
		(
			fdm_node.getNode("systems/electrical/acc-first-heat").getValue()
			/100
		)*
		(-99)
	);

	heat_input=0;

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==1) or
		(fdm_node.getNode("systems/refill/on-switch").getValue()==1)
	)
	{
		heat_input=fdm_node.getNode("systems/electrical/acc-first-heat-return").getValue();
	}

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/refill/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/electrical/serviceable").getValue()==1) and
		(fdm_node.getNode("systems/powerpanel/acc-first-switch").getValue()==1) and
		(fdm_node.getNode("systems/powerpanel/acc-second-switch").getValue()==0) and
		(fdm_node.getNode("systems/electrical/gen-first-on").getValue()==0) and
		(fdm_node.getNode("systems/electrical/gen-sec-on").getValue()==0) and
		(fdm_node.getNode("systems/electrical/acc-first-pers").getValue()<99)
	)
	{
		heat_input=fdm_node.getNode("systems/electrical/heat-pers").getValue();
	}

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/refill/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/electrical/serviceable").getValue()==1) and
		(fdm_node.getNode("systems/powerpanel/acc-first-switch").getValue()==1) and
		(fdm_node.getNode("systems/powerpanel/acc-second-switch").getValue()==1) and
		(fdm_node.getNode("systems/electrical/gen-first-on").getValue()==0) and
		(fdm_node.getNode("systems/electrical/gen-sec-on").getValue()==0) and
		(fdm_node.getNode("systems/electrical/acc-first-pers").getValue()<99)
	)
	{
		heat_input=fdm_node.getNode("systems/electrical/heat-half-pers").getValue();
	}

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/electrical/serviceable").getValue()==1) and
		(fdm_node.getNode("systems/electrical/acc-first-heat").getValue()>1) and
		(fdm_node.getNode("systems/powerpanel/acc-first-switch").getValue()==1) and
		(fdm_node.getNode("systems/electrical/some-gen-on").getValue()==1)
	)
	{
		heat_input=-1;
	}

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/refill/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/electrical/serviceable").getValue()==1) and
		(fdm_node.getNode("systems/electrical/acc-first-heat").getValue()>1) and
		(fdm_node.getNode("systems/powerpanel/acc-first-switch").getValue()==0)
	)
	{
		heat_input=-1;
	}

	fdm_node.getNode("systems/electrical/acc-first-heat-input").setValue(heat_input);

	#pids substitute, rough integrator

	fdm_node.getNode("systems/electrical/acc-first-heat").setValue(
		fdm_node.getNode("systems/electrical/acc-first-heat").getValue()+
		fdm_node.getNode("systems/electrical/acc-first-heat-input").getValue()*tick_sec
	);

	if (
		(fdm_node.getNode("systems/electrical/serviceable").getValue()==1) and
		(fdm_node.getNode("systems/electrical/acc-first-heat").getValue()>50) and
		(fdm_node.getNode("systems/electrical/on").getValue()==1)
	)
	{
		fdm_node.getNode("systems/electrical/acc-first-heat-lamp").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/electrical/acc-first-heat-lamp").setValue(0);
	}

	#Second accumulatior recharge/charge

	fdm_node.getNode("systems/electrical/acc-second-return-pers").setValue(
		(
			(
				100-
				fdm_node.getNode("systems/electrical/acc-second-pers").getValue()
			)
			/100
		)*
		99
	);

	input_pers=0;

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==1) or
		(fdm_node.getNode("systems/refill/on-switch").getValue()==1)
	)
	{
		input_pers=fdm_node.getNode("systems/electrical/acc-second-return-pers").getValue();
	}

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/refill/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/electrical/serviceable").getValue()==1) and
		(fdm_node.getNode("systems/powerpanel/acc-first-switch").getValue()==0) and
		(fdm_node.getNode("systems/powerpanel/acc-second-switch").getValue()==1) and
		(fdm_node.getNode("systems/electrical/gen-first-on").getValue()==0) and
		(fdm_node.getNode("systems/electrical/gen-sec-on").getValue()==0) and
		(fdm_node.getNode("systems/electrical/acc-second-pers").getValue()>1)
	)
	{
		input_pers=fdm_node.getNode("systems/electrical/const-cons-norm").getValue();
	}

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/refill/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/electrical/serviceable").getValue()==1) and
		(fdm_node.getNode("systems/powerpanel/acc-first-switch").getValue()==1) and
		(fdm_node.getNode("systems/powerpanel/acc-second-switch").getValue()==1) and
		(fdm_node.getNode("systems/electrical/gen-first-on").getValue()==0) and
		(fdm_node.getNode("systems/electrical/gen-sec-on").getValue()==0) and
		(fdm_node.getNode("systems/electrical/acc-second-pers").getValue()>1)
	)
	{
		input_pers=fdm_node.getNode("systems/electrical/const-cons-half-pers").getValue();
	}

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/refill/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/electrical/serviceable").getValue()==1) and
		(fdm_node.getNode("systems/electrical/some-gen-on").getValue()==1) and
		(fdm_node.getNode("systems/electrical/acc-second-pers").getValue()<99)
	)
	{
		input_pers=0.1;
	}

	fdm_node.getNode("systems/electrical/acc-second-input-pers").setValue(input_pers);

	#pids substitute, rough integrator

	fdm_node.getNode("systems/electrical/acc-second-pers").setValue(
		fdm_node.getNode("systems/electrical/acc-second-pers").getValue()+
		fdm_node.getNode("systems/electrical/acc-second-input-pers").getValue()*tick_sec
	);

	#Second accumulatior heating

	fdm_node.getNode("systems/electrical/acc-second-heat-return").setValue(
		(
			fdm_node.getNode("systems/electrical/acc-second-heat").getValue()
			/100
		)*
		(-99)
	);

	heat_input=0;

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==1) or
		(fdm_node.getNode("systems/refill/on-switch").getValue()==1)
	)
	{
		heat_input=fdm_node.getNode("systems/electrical/acc-second-heat-return").getValue();
	}

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/refill/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/electrical/serviceable").getValue()==1) and
		(fdm_node.getNode("systems/powerpanel/acc-first-switch").getValue()==0) and
		(fdm_node.getNode("systems/powerpanel/acc-second-switch").getValue()==1) and
		(fdm_node.getNode("systems/electrical/gen-first-on").getValue()==0) and
		(fdm_node.getNode("systems/electrical/gen-sec-on").getValue()==0) and
		(fdm_node.getNode("systems/electrical/acc-second-pers").getValue()<99)
	)
	{
		heat_input=fdm_node.getNode("systems/electrical/heat-pers").getValue();
	}

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/refill/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/electrical/serviceable").getValue()==1) and
		(fdm_node.getNode("systems/powerpanel/acc-first-switch").getValue()==1) and
		(fdm_node.getNode("systems/powerpanel/acc-second-switch").getValue()==1) and
		(fdm_node.getNode("systems/electrical/gen-first-on").getValue()==0) and
		(fdm_node.getNode("systems/electrical/gen-sec-on").getValue()==0) and
		(fdm_node.getNode("systems/electrical/acc-second-pers").getValue()<99)
	)
	{
		heat_input=fdm_node.getNode("systems/electrical/heat-half-pers").getValue();
	}

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/electrical/serviceable").getValue()==1) and
		(fdm_node.getNode("systems/electrical/acc-second-heat").getValue()>1) and
		(fdm_node.getNode("systems/powerpanel/acc-second-switch").getValue()==1) and
		(fdm_node.getNode("systems/electrical/some-gen-on").getValue()==1)
	)
	{
		heat_input=-1;
	}

	if (
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/refill/on-switch").getValue()==0) and
		(fdm_node.getNode("systems/electrical/serviceable").getValue()==1) and
		(fdm_node.getNode("systems/electrical/acc-second-heat").getValue()>1) and
		(fdm_node.getNode("systems/powerpanel/acc-second-switch").getValue()==0)
	)
	{
		heat_input=-1;
	}

	fdm_node.getNode("systems/electrical/acc-second-heat-input").setValue(heat_input);

	#pids substitute, rough integrator

	fdm_node.getNode("systems/electrical/acc-second-heat").setValue(
		fdm_node.getNode("systems/electrical/acc-second-heat").getValue()+
		fdm_node.getNode("systems/electrical/acc-second-heat-input").getValue()*tick_sec
	);

	if (
		(fdm_node.getNode("systems/electrical/serviceable").getValue()==1) and
		(fdm_node.getNode("systems/electrical/acc-second-heat").getValue()>50) and
		(fdm_node.getNode("systems/electrical/on").getValue()==1)
	)
	{
		fdm_node.getNode("systems/electrical/acc-second-heat-lamp").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/electrical/acc-second-heat-lamp").setValue(0);
	}

	settimer(func electrical(), 1.0); 

}

# initialisation  -------------------------------------------------

#timer is used to asyncronize fps load with other nasal systems

settimer(func electrical(), 0.5);
