# -----------------------------------------------------------------------
# Su-15 JSBSim hydraulic system simplified nasal analog

hydraulic=func()
{

	fdm_node=props.globals.getNode("fdm/jsbsim");

	time_sec=props.globals.getNode("sim/time/elapsed-sec").getValue();
	time_sec_prev=fdm_node.getNode("systems/hydraulic/time-sec").getValue();
	tick_sec=time_sec-time_sec_prev;
	fdm_node.getNode("systems/hydraulic/time-sec").setValue(time_sec);

	#Serviceability

	if (
		(fdm_node.getNode("breakage/broken").getValue()==1) and
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{
		fdm_node.getNode("systems/hydraulic/serviceable").setValue(0);
	}

	if (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
	{
		fdm_node.getNode("systems/hydraulic/serviceable").setValue(1);
	}

	#First system, powers left engine intake and nozzle

	#pump

	pump_on=0;

	if (
		(fdm_node.getNode("systems/hydraulic/serviceable").getValue()==1) and
		(fdm_node.getNode("propulsion/engine[0]/broken").getValue()==0) and
		(
			fdm_node.getNode("propulsion/engine[0]/n1").getValue()>=
			fdm_node.getNode("systems/hydraulic/min-engine-n").getValue()
		) and
		(fdm_node.getNode("systems/rightpanel/pump-second-switch").getValue()==1) and
		(
			fdm_node.getNode("systems/hydraulic/unit[0]/tank-press").getValue()<
			fdm_node.getNode("systems/hydraulic/pressure-min").getValue()
		)
	)
	{
		pump_on=1;
	}

	if (
		(fdm_node.getNode("systems/hydraulic/serviceable").getValue()==0) or
		(fdm_node.getNode("propulsion/engine[0]/broken").getValue()==1) or
		(
			fdm_node.getNode("propulsion/engine[0]/n1").getValue()<
			fdm_node.getNode("systems/hydraulic/min-engine-n").getValue()
		) or
		(fdm_node.getNode("systems/rightpanel/pump-second-switch").getValue()<1) and
		(
			fdm_node.getNode("systems/hydraulic/unit[0]/tank-press").getValue()>
			fdm_node.getNode("systems/hydraulic/pressure-max").getValue()
		)
	)
	{
		pump_on=0;
	}

	fdm_node.getNode("systems/hydraulic/unit[0]/pump-on").setValue(pump_on);

	#system floats

	int_trans=
		fdm_node.getNode("systems/hydraulic/unit[0]/system-press").getValue()-
		fdm_node.getNode("systems/hydraulic/unit[0]/tank-press").getValue();

	if (int_trans<
		(-1)*fdm_node.getNode("systems/hydraulic/trans-max").getValue()
	)
	{
		int_trans=
			(-1)*fdm_node.getNode("systems/hydraulic/trans-max").getValue();
	}

	if (int_trans>
		fdm_node.getNode("systems/hydraulic/trans-max").getValue()
	)
	{
		int_trans=
			fdm_node.getNode("systems/hydraulic/trans-max").getValue();
	}

	fdm_node.getNode("systems/hydraulic/unit[0]/int-trans").setValue(int_trans);

	fdm_node.getNode("systems/hydraulic/unit[0]/system-input-calc").setValue(
		(-1)*
		(
			fdm_node.getNode("systems/hydraulic/rel-ext").getValue()+
			(
				fdm_node.getNode("propulsion/engine[0]/intake-moving").getValue()*
				fdm_node.getNode("systems/hydraulic/intake-ext").getValue()
			)+
			(
				fdm_node.getNode("propulsion/engine[0]/nozzle-moving").getValue()*
				fdm_node.getNode("systems/hydraulic/nozzle-ext").getValue()
			)+
			fdm_node.getNode("systems/hydraulic/unit[0]/int-trans").getValue()
		)
	);

	if (
		(
			(fdm_node.getNode("systems/hydraulic/unit[0]/system-input-calc").getValue()<0) and
			(fdm_node.getNode("systems/hydraulic/unit[0]/system-press").getValue()>0)
		) or
		(fdm_node.getNode("systems/hydraulic/unit[0]/system-input-calc").getValue()>0)
	)
	{
		fdm_node.getNode("systems/hydraulic/unit[0]/system-input").setValue(
			fdm_node.getNode("systems/hydraulic/unit[0]/system-input-calc").getValue()
		);
	}
	else
	{
		fdm_node.getNode("systems/hydraulic/unit[0]/system-input").setValue(0);
	}

	#tank floats

	fdm_node.getNode("systems/hydraulic/unit[0]/tank-input-calc").setValue(
		fdm_node.getNode("systems/hydraulic/unit[0]/int-trans").getValue()+
		(
			fdm_node.getNode("systems/hydraulic/pump-add").getValue()*
			fdm_node.getNode("systems/hydraulic/unit[0]/pump-on").getValue()*
			interpol.lin_inter(
				[
					[0.0,		0.0],
					[10.0,	0.0],
					[15.0,	0.05],
					[20.0,	0.1],
					[25.0,	0.25],
					[30.0,	1.0]
				],
				fdm_node.getNode("propulsion/engine[0]/n1").getValue()
			)
		)
	);

	fdm_node.getNode("systems/hydraulic/unit[0]/tank-return").setValue(
		fdm_node.getNode("systems/hydraulic/pressure-max").getValue()-
		fdm_node.getNode("systems/hydraulic/unit[0]/tank-press").getValue()
	);

	if (
		(
			(fdm_node.getNode("systems/hydraulic/unit[0]/tank-input-calc").getValue()<0) and
			(fdm_node.getNode("systems/hydraulic/unit[0]/tank-press").getValue()>0) and
			(fdm_node.getNode("systems/refill/on-switch").getValue()==0)
		) or
		(
			(fdm_node.getNode("systems/hydraulic/unit[0]/tank-input-calc").getValue()>0) and
			(fdm_node.getNode("systems/refill/on-switch").getValue()==0)
		)
	)
	{
		fdm_node.getNode("systems/hydraulic/unit[0]/tank-input").setValue(
			fdm_node.getNode("systems/hydraulic/unit[0]/tank-input-calc").getValue()
		);
	}
	else
	{
		if (fdm_node.getNode("systems/refill/on-switch").getValue()==1)
		{
			fdm_node.getNode("systems/hydraulic/unit[0]/tank-input").setValue(
				fdm_node.getNode("systems/hydraulic/unit[0]/tank-return").getValue()
			);
		}
		else
		{
			fdm_node.getNode("systems/hydraulic/unit[0]/tank-input").setValue(0);
		}
	}

	#pids substitutes, rough integrals

	fdm_node.getNode("systems/hydraulic/unit[0]/system-press").setValue(
		fdm_node.getNode("systems/hydraulic/unit[0]/system-press").getValue()+
		fdm_node.getNode("systems/hydraulic/unit[0]/system-input").getValue()*tick_sec
	);

	fdm_node.getNode("systems/hydraulic/unit[0]/tank-press").setValue(
		fdm_node.getNode("systems/hydraulic/unit[0]/tank-press").getValue()+
		fdm_node.getNode("systems/hydraulic/unit[0]/tank-input").getValue()*tick_sec
	);

	#Second system, powers right engine intake and nozzle, gears and flaps

	#pump

	pump_on=0;

	if (
		(fdm_node.getNode("systems/hydraulic/serviceable").getValue()==1) and
		(fdm_node.getNode("propulsion/engine[1]/broken").getValue()==0) and
		(
			fdm_node.getNode("propulsion/engine[1]/n1").getValue()>=
			fdm_node.getNode("systems/hydraulic/min-engine-n").getValue()
		) and
		(fdm_node.getNode("systems/rightpanel/pump-first-switch").getValue()==1) and
		(
			fdm_node.getNode("systems/hydraulic/unit[1]/tank-press").getValue()<
			fdm_node.getNode("systems/hydraulic/pressure-min").getValue()
		)
	)
	{
		pump_on=1;
	}

	if (
		(fdm_node.getNode("systems/hydraulic/serviceable").getValue()==0) or
		(fdm_node.getNode("propulsion/engine[1]/broken").getValue()==1) or
		(
			fdm_node.getNode("propulsion/engine[1]/n1").getValue()<
			fdm_node.getNode("systems/hydraulic/min-engine-n").getValue()
		) or
		(fdm_node.getNode("systems/rightpanel/pump-first-switch").getValue()<1) and
		(
			fdm_node.getNode("systems/hydraulic/unit[1]/tank-press").getValue()>
			fdm_node.getNode("systems/hydraulic/pressure-max").getValue()
		)
	)
	{
		pump_on=0;
	}

	fdm_node.getNode("systems/hydraulic/unit[1]/pump-on").setValue(pump_on);

	#system floats

	int_trans=
		fdm_node.getNode("systems/hydraulic/unit[1]/system-press").getValue()-
		fdm_node.getNode("systems/hydraulic/unit[1]/tank-press").getValue();

	if (int_trans<
		(-1)*fdm_node.getNode("systems/hydraulic/trans-max").getValue()
	)
	{
		int_trans=
			(-1)*fdm_node.getNode("systems/hydraulic/trans-max").getValue();
	}

	if (int_trans>
		fdm_node.getNode("systems/hydraulic/trans-max").getValue()
	)
	{
		int_trans=
			fdm_node.getNode("systems/hydraulic/trans-max").getValue();
	}

	fdm_node.getNode("systems/hydraulic/unit[1]/int-trans").setValue(int_trans);

	if (
		(fdm_node.getNode("gear/unit[0]/broken").getValue()==1) or
		(fdm_node.getNode("gear/unit[1]/broken").getValue()==1) or
		(fdm_node.getNode("gear/unit[2]/broken").getValue()==1) or
		(fdm_node.getNode("surfaces/flap/unit[0]/broken").getValue()==1) or
		(fdm_node.getNode("surfaces/flap/unit[1]/broken").getValue()==1)
	)
	{
		fdm_node.getNode("systems/hydraulic/unit[1]/leaking").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/hydraulic/unit[1]/leaking").setValue(0);
	}

	fdm_node.getNode("systems/hydraulic/unit[1]/system-input-calc").setValue(
		(-1)*
		(
			fdm_node.getNode("systems/hydraulic/rel-ext").getValue()+
			(
				fdm_node.getNode("propulsion/engine[1]/intake-moving").getValue()*
				fdm_node.getNode("systems/hydraulic/intake-ext").getValue()
			)+
			(
				fdm_node.getNode("propulsion/engine[1]/nozzle-moving").getValue()*
				fdm_node.getNode("systems/hydraulic/nozzle-ext").getValue()
			)+
			(
				(
					fdm_node.getNode("gear/unit[0]/doors-moving").getValue()*
					fdm_node.getNode("systems/hydraulic/door-ext").getValue()
				)+
				(
					fdm_node.getNode("gear/unit[1]/doors-moving").getValue()*
					fdm_node.getNode("systems/hydraulic/door-ext").getValue()
				)+
				(
					fdm_node.getNode("gear/unit[2]/doors-moving").getValue()*
					fdm_node.getNode("systems/hydraulic/door-ext").getValue()
				)+
				(
					fdm_node.getNode("gear/unit[0]/strut-moving").getValue()*
					fdm_node.getNode("systems/hydraulic/strut-ext").getValue()
				)+
				(
					fdm_node.getNode("gear/unit[1]/strut-moving").getValue()*
					fdm_node.getNode("systems/hydraulic/strut-ext").getValue()
				)+
				(
					fdm_node.getNode("gear/unit[2]/strut-moving").getValue()*
					fdm_node.getNode("systems/hydraulic/strut-ext").getValue()
				)
			)*
			(
				1-	
				fdm_node.getNode("systems/gearsemergencyhandle/handle-switch").getValue()
			)+
			(
				fdm_node.getNode("surfaces/flap/unit[0]/moving").getValue()*
				fdm_node.getNode("systems/hydraulic/strut-ext").getValue()
			)+
			(
				fdm_node.getNode("surfaces/flap/unit[1]/moving").getValue()*
				fdm_node.getNode("systems/hydraulic/strut-ext").getValue()
			)+
			(
				fdm_node.getNode("systems/hydraulic/unit[1]/leaking").getValue()*
				fdm_node.getNode("systems/hydraulic/broken-ext").getValue()
			)+
			fdm_node.getNode("systems/hydraulic/unit[1]/int-trans").getValue()
		)
	);

	if (
		(
			(fdm_node.getNode("systems/hydraulic/unit[1]/system-input-calc").getValue()<0) and
			(fdm_node.getNode("systems/hydraulic/unit[1]/system-press").getValue()>0)
		) or
		(fdm_node.getNode("systems/hydraulic/unit[1]/system-input-calc").getValue()>0)
	)
	{
		fdm_node.getNode("systems/hydraulic/unit[1]/system-input").setValue(
			fdm_node.getNode("systems/hydraulic/unit[1]/system-input-calc").getValue()
		);
	}
	else
	{
		fdm_node.getNode("systems/hydraulic/unit[1]/system-input").setValue(0);
	}

	#tank floats

	fdm_node.getNode("systems/hydraulic/unit[1]/tank-input-calc").setValue(
		fdm_node.getNode("systems/hydraulic/unit[1]/int-trans").getValue()+
		(
			fdm_node.getNode("systems/hydraulic/pump-add").getValue()*
			fdm_node.getNode("systems/hydraulic/unit[1]/pump-on").getValue()*
			interpol.lin_inter(
				[
					[0.0,		0.0],
					[10.0,	0.0],
					[15.0,	0.05],
					[20.0,	0.1],
					[25.0,	0.25],
					[30.0,	1.0]
				],
				fdm_node.getNode("propulsion/engine[1]/n1").getValue()
			)
		)
	);

	fdm_node.getNode("systems/hydraulic/unit[1]/tank-return").setValue(
		fdm_node.getNode("systems/hydraulic/pressure-max").getValue()-
		fdm_node.getNode("systems/hydraulic/unit[1]/tank-press").getValue()
	);

	if (
		(
			(fdm_node.getNode("systems/hydraulic/unit[1]/tank-input-calc").getValue()<0) and
			(fdm_node.getNode("systems/hydraulic/unit[1]/tank-press").getValue()>0) and
			(fdm_node.getNode("systems/refill/on-switch").getValue()==0)
		) or
		(
			(fdm_node.getNode("systems/hydraulic/unit[1]/tank-input-calc").getValue()>0) and
			(fdm_node.getNode("systems/refill/on-switch").getValue()==0)
		)
	)
	{
		fdm_node.getNode("systems/hydraulic/unit[1]/tank-input").setValue(
			fdm_node.getNode("systems/hydraulic/unit[1]/tank-input-calc").getValue()
		);
	}
	else
	{
		if (fdm_node.getNode("systems/refill/on-switch").getValue()==1)
		{
			fdm_node.getNode("systems/hydraulic/unit[1]/tank-input").setValue(
				fdm_node.getNode("systems/hydraulic/unit[1]/tank-return").getValue()
			);
		}
		else
		{
			fdm_node.getNode("systems/hydraulic/unit[1]/tank-input").setValue(0);
		}
	}

	#pids substitutes, rough integrals

	fdm_node.getNode("systems/hydraulic/unit[1]/system-press").setValue(
		fdm_node.getNode("systems/hydraulic/unit[1]/system-press").getValue()+
		fdm_node.getNode("systems/hydraulic/unit[1]/system-input").getValue()*tick_sec
	);

	fdm_node.getNode("systems/hydraulic/unit[1]/tank-press").setValue(
		fdm_node.getNode("systems/hydraulic/unit[1]/tank-press").getValue()+
		fdm_node.getNode("systems/hydraulic/unit[1]/tank-input").getValue()*tick_sec
	);

	#Third system, powers ailerons, elevator, also rudder and speedbrakes

	#pump

	pump_on=0;

	if (
		(
			(fdm_node.getNode("systems/hydraulic/serviceable").getValue()==1) and
			(fdm_node.getNode("propulsion/engine[0]/broken").getValue()==0) and
			(
				fdm_node.getNode("propulsion/engine[0]/n1").getValue()>=
				fdm_node.getNode("systems/hydraulic/min-engine-n").getValue()
			) and
			(fdm_node.getNode("systems/rightpanel/pump-second-switch").getValue()==1) and
			(
				fdm_node.getNode("systems/hydraulic/unit[2]/tank-press").getValue()<
				fdm_node.getNode("systems/hydraulic/pressure-min").getValue()
			)
		) or
		(
			(fdm_node.getNode("systems/hydraulic/serviceable").getValue()==1) and
			(fdm_node.getNode("systems/electrical/on").getValue()==1) and
			(fdm_node.getNode("systems/leftpanel/emergency-pump-start-switch").getValue()==1) and
			(
				fdm_node.getNode("systems/hydraulic/unit[2]/tank-press").getValue()<
				fdm_node.getNode("systems/hydraulic/pressure-min").getValue()
			)
		)
	)
	{
		pump_on=1;
	}

	if (
		(fdm_node.getNode("systems/hydraulic/serviceable").getValue()==0) or
		(
			fdm_node.getNode("systems/hydraulic/unit[2]/tank-press").getValue()>
			fdm_node.getNode("systems/hydraulic/pressure-max").getValue()
		) or
		(
			(
				(fdm_node.getNode("systems/rightpanel/pump-second-switch").getValue()<1) or
				(fdm_node.getNode("propulsion/engine[0]/broken").getValue()==1) or
				(
					fdm_node.getNode("propulsion/engine[0]/n1").getValue()<
					fdm_node.getNode("systems/hydraulic/min-engine-n").getValue()
				)
			) and
			(
				(fdm_node.getNode("systems/electrical/on").getValue()<1) or
				(fdm_node.getNode("systems/leftpanel/emergency-pump-start-switch").getValue()<1)
			)
		)
	)
	{
		pump_on=0;
	}

	fdm_node.getNode("systems/hydraulic/unit[2]/pump-on").setValue(pump_on);

	#system floats

	int_trans=
		fdm_node.getNode("systems/hydraulic/unit[2]/system-press").getValue()-
		fdm_node.getNode("systems/hydraulic/unit[2]/tank-press").getValue();

	if (int_trans<
		(-1)*fdm_node.getNode("systems/hydraulic/trans-max").getValue()
	)
	{
		int_trans=
			(-1)*fdm_node.getNode("systems/hydraulic/trans-max").getValue();
	}

	if (int_trans>
		fdm_node.getNode("systems/hydraulic/trans-max").getValue()
	)
	{
		int_trans=
			fdm_node.getNode("systems/hydraulic/trans-max").getValue();
	}

	fdm_node.getNode("systems/hydraulic/unit[2]/int-trans").setValue(int_trans);

	fdm_node.getNode("systems/hydraulic/unit[2]/system-input-calc").setValue(
		(-1)*
		(
			fdm_node.getNode("systems/hydraulic/rel-ext").getValue()+
			(
				fdm_node.getNode("surfaces/aileron/unit[0]/moving").getValue()*
				fdm_node.getNode("systems/hydraulic/control-ext").getValue()
			)+
			(
				fdm_node.getNode("surfaces/elevator/unit[0]/moving").getValue()*
				fdm_node.getNode("systems/hydraulic/control-ext").getValue()
			)+
			(
				fdm_node.getNode("surfaces/aileron/unit[1]/moving").getValue()*
				fdm_node.getNode("systems/hydraulic/control-ext").getValue()
			)+
			(
				fdm_node.getNode("surfaces/elevator/unit[1]/moving").getValue()*
				fdm_node.getNode("systems/hydraulic/control-ext").getValue()
			)+
			(
				fdm_node.getNode("surfaces/rudder/moving").getValue()*
				fdm_node.getNode("systems/hydraulic/control-ext").getValue()
			)+
			(
				fdm_node.getNode("surfaces/speedbrake/moving").getValue()*
				fdm_node.getNode("systems/hydraulic/control-ext").getValue()
			)+
			fdm_node.getNode("systems/hydraulic/unit[2]/int-trans").getValue()
		)
	);

	if (
		(
			(fdm_node.getNode("systems/hydraulic/unit[2]/system-input-calc").getValue()<0) and
			(fdm_node.getNode("systems/hydraulic/unit[2]/system-press").getValue()>0)
		) or
		(fdm_node.getNode("systems/hydraulic/unit[2]/system-input-calc").getValue()>0)
	)
	{
		fdm_node.getNode("systems/hydraulic/unit[2]/system-input").setValue(
			fdm_node.getNode("systems/hydraulic/unit[2]/system-input-calc").getValue()
		);
	}
	else
	{
		fdm_node.getNode("systems/hydraulic/unit[2]/system-input").setValue(0);
	}

	#tank floats

	fdm_node.getNode("systems/hydraulic/unit[2]/tank-input-calc").setValue(
		fdm_node.getNode("systems/hydraulic/unit[2]/int-trans").getValue()+
		(
			fdm_node.getNode("systems/hydraulic/pump-add").getValue()*
			fdm_node.getNode("systems/hydraulic/unit[2]/pump-on").getValue()*
			interpol.lin_inter(
				[
					[0.0,		0.0],
					[10.0,	0.0],
					[15.0,	0.05],
					[20.0,	0.1],
					[25.0,	0.25],
					[30.0,	1.0]
				],
				fdm_node.getNode("propulsion/engine[0]/n1").getValue()
			)
		)
	);

	fdm_node.getNode("systems/hydraulic/unit[2]/tank-return").setValue(
		fdm_node.getNode("systems/hydraulic/pressure-max").getValue()-
		fdm_node.getNode("systems/hydraulic/unit[2]/tank-press").getValue()
	);

	if (
		(
			(fdm_node.getNode("systems/hydraulic/unit[2]/tank-input-calc").getValue()<0) and
			(fdm_node.getNode("systems/hydraulic/unit[2]/tank-press").getValue()>0) and
			(fdm_node.getNode("systems/refill/on-switch").getValue()==0)
		) or
		(
			(fdm_node.getNode("systems/hydraulic/unit[2]/tank-input-calc").getValue()>0) and
			(fdm_node.getNode("systems/refill/on-switch").getValue()==0)
		)
	)
	{
		fdm_node.getNode("systems/hydraulic/unit[2]/tank-input").setValue(
			fdm_node.getNode("systems/hydraulic/unit[2]/tank-input-calc").getValue()
		);
	}
	else
	{
		if (fdm_node.getNode("systems/refill/on-switch").getValue()==1)
		{
			fdm_node.getNode("systems/hydraulic/unit[2]/tank-input").setValue(
				fdm_node.getNode("systems/hydraulic/unit[2]/tank-return").getValue()
			);
		}
		else
		{
			fdm_node.getNode("systems/hydraulic/unit[2]/tank-input").setValue(0);
		}
	}

	#pids substitutes, rough integrals

	fdm_node.getNode("systems/hydraulic/unit[2]/system-press").setValue(
		fdm_node.getNode("systems/hydraulic/unit[2]/system-press").getValue()+
		fdm_node.getNode("systems/hydraulic/unit[2]/system-input").getValue()*tick_sec
	);

	fdm_node.getNode("systems/hydraulic/unit[2]/tank-press").setValue(
		fdm_node.getNode("systems/hydraulic/unit[2]/tank-press").getValue()+
		fdm_node.getNode("systems/hydraulic/unit[2]/tank-input").getValue()*tick_sec
	);

	#Fourth system,  powers radar, ailerons, elevator, also rudder and speedbrakes

	#pump

	pump_on=0;

	if (
		(fdm_node.getNode("systems/hydraulic/serviceable").getValue()==1) and
			(fdm_node.getNode("propulsion/engine[1]/broken").getValue()==0) and
		(
			fdm_node.getNode("propulsion/engine[1]/n1").getValue()>=
			fdm_node.getNode("systems/hydraulic/min-engine-n").getValue()
		) and
		(fdm_node.getNode("systems/rightpanel/pump-first-switch").getValue()==1) and
		(
			fdm_node.getNode("systems/hydraulic/unit[3]/tank-press").getValue()<
			fdm_node.getNode("systems/hydraulic/pressure-min").getValue()
		)
	)
	{
		pump_on=1;
	}

	if (
		(fdm_node.getNode("systems/hydraulic/serviceable").getValue()==0) or
			(fdm_node.getNode("propulsion/engine[1]/broken").getValue()==1) or
		(
			fdm_node.getNode("propulsion/engine[1]/n1").getValue()<
			fdm_node.getNode("systems/hydraulic/min-engine-n").getValue()
		) or
		(fdm_node.getNode("systems/rightpanel/pump-first-switch").getValue()<1) and
		(
			fdm_node.getNode("systems/hydraulic/unit[3]/tank-press").getValue()>
			fdm_node.getNode("systems/hydraulic/pressure-max").getValue()
		)
	)
	{
		pump_on=0;
	}

	fdm_node.getNode("systems/hydraulic/unit[3]/pump-on").setValue(pump_on);

	#system floats

	int_trans=
		fdm_node.getNode("systems/hydraulic/unit[3]/system-press").getValue()-
		fdm_node.getNode("systems/hydraulic/unit[3]/tank-press").getValue();

	if (int_trans<
		(-1)*fdm_node.getNode("systems/hydraulic/trans-max").getValue()
	)
	{
		int_trans=
			(-1)*fdm_node.getNode("systems/hydraulic/trans-max").getValue();
	}

	if (int_trans>
		fdm_node.getNode("systems/hydraulic/trans-max").getValue()
	)
	{
		int_trans=
			fdm_node.getNode("systems/hydraulic/trans-max").getValue();
	}

	fdm_node.getNode("systems/hydraulic/unit[3]/int-trans").setValue(int_trans);

	fdm_node.getNode("systems/hydraulic/unit[3]/system-input-calc").setValue(
		(-1)*
		(
			fdm_node.getNode("systems/hydraulic/rel-ext").getValue()+
			(
				fdm_node.getNode("systems/radar/antenna-moving").getValue()*
				fdm_node.getNode("systems/hydraulic/radar-ext").getValue()
			)+
			(
				fdm_node.getNode("surfaces/aileron/unit[0]/moving").getValue()*
				fdm_node.getNode("systems/hydraulic/control-ext").getValue()
			)+
			(
				fdm_node.getNode("surfaces/elevator/unit[0]/moving").getValue()*
				fdm_node.getNode("systems/hydraulic/control-ext").getValue()
			)+
			(
				fdm_node.getNode("surfaces/aileron/unit[1]/moving").getValue()*
				fdm_node.getNode("systems/hydraulic/control-ext").getValue()
			)+
			(
				fdm_node.getNode("surfaces/elevator/unit[1]/moving").getValue()*
				fdm_node.getNode("systems/hydraulic/control-ext").getValue()
			)+
			(
				fdm_node.getNode("surfaces/rudder/moving").getValue()*
				fdm_node.getNode("systems/hydraulic/control-ext").getValue()
			)+
			(
				fdm_node.getNode("surfaces/speedbrake/moving").getValue()*
				fdm_node.getNode("systems/hydraulic/control-ext").getValue()
			)+
			fdm_node.getNode("systems/hydraulic/unit[3]/int-trans").getValue()
		)
	);

	if (
		(
			(fdm_node.getNode("systems/hydraulic/unit[3]/system-input-calc").getValue()<0) and
			(fdm_node.getNode("systems/hydraulic/unit[3]/system-press").getValue()>0)
		) or
		(fdm_node.getNode("systems/hydraulic/unit[3]/system-input-calc").getValue()>0)
	)
	{
		fdm_node.getNode("systems/hydraulic/unit[3]/system-input").setValue(
			fdm_node.getNode("systems/hydraulic/unit[3]/system-input-calc").getValue()
		);
	}
	else
	{
		fdm_node.getNode("systems/hydraulic/unit[3]/system-input").setValue(0);
	}

	#tank floats

	fdm_node.getNode("systems/hydraulic/unit[3]/tank-input-calc").setValue(
		fdm_node.getNode("systems/hydraulic/unit[3]/int-trans").getValue()+
		(
			fdm_node.getNode("systems/hydraulic/pump-add").getValue()*
			fdm_node.getNode("systems/hydraulic/unit[3]/pump-on").getValue()*
			interpol.lin_inter(
				[
					[0.0,		0.0],
					[10.0,	0.0],
					[15.0,	0.05],
					[20.0,	0.1],
					[25.0,	0.25],
					[30.0,	1.0]
				],
				fdm_node.getNode("propulsion/engine[1]/n1").getValue()
			)
		)
	);

	fdm_node.getNode("systems/hydraulic/unit[3]/tank-return").setValue(
		fdm_node.getNode("systems/hydraulic/pressure-max").getValue()-
		fdm_node.getNode("systems/hydraulic/unit[3]/tank-press").getValue()
	);

	if (
		(
			(fdm_node.getNode("systems/hydraulic/unit[3]/tank-input-calc").getValue()<0) and
			(fdm_node.getNode("systems/hydraulic/unit[3]/tank-press").getValue()>0) and
			(fdm_node.getNode("systems/refill/on-switch").getValue()==0)
		) or
		(
			(fdm_node.getNode("systems/hydraulic/unit[3]/tank-input-calc").getValue()>0) and
			(fdm_node.getNode("systems/refill/on-switch").getValue()==0)
		)
	)
	{
		fdm_node.getNode("systems/hydraulic/unit[3]/tank-input").setValue(
			fdm_node.getNode("systems/hydraulic/unit[3]/tank-input-calc").getValue()
		);
	}
	else
	{
		if (fdm_node.getNode("systems/refill/on-switch").getValue()==1)
		{
			fdm_node.getNode("systems/hydraulic/unit[3]/tank-input").setValue(
				fdm_node.getNode("systems/hydraulic/unit[3]/tank-return").getValue()
			);
		}
		else
		{
			fdm_node.getNode("systems/hydraulic/unit[3]/tank-input").setValue(0);
		}
	}

	#pids substitutes, rough integrals

	fdm_node.getNode("systems/hydraulic/unit[3]/system-press").setValue(
		fdm_node.getNode("systems/hydraulic/unit[3]/system-press").getValue()+
		fdm_node.getNode("systems/hydraulic/unit[3]/system-input").getValue()*tick_sec
	);

	fdm_node.getNode("systems/hydraulic/unit[3]/tank-press").setValue(
		fdm_node.getNode("systems/hydraulic/unit[3]/tank-press").getValue()+
		fdm_node.getNode("systems/hydraulic/unit[3]/tank-input").getValue()*tick_sec
	);

	settimer(func hydraulic(), 1.0); 

}

# initialisation  -------------------------------------------------

#timer is used to asyncronize fps load with other nasal systems

settimer(func hydraulic(), 0.25);
