#-----------------------------------------------------------------------
#Infoline

#Get prepared data and account everything for infoline target or runway course indication

runways_list_update=func
	{
		infoline_node=props.globals.getNode("fdm/jsbsim/systems/infoline");
		range = int(infoline_node.getNode("range-km").getValue()/1.852);
		airports = findAirportsWithinRange(range);
		id=0;
		if (airports!=nil)
		{
			foreach (var airport; airports)
			{
				if (airport.id!=nil)
				{
					if (airport.name!=nil)
					{
						foreach (var runway_name; keys(airport.runways))
						{
							if ((airport.runways[runway_name].lat!=nil)
								and (airport.runways[runway_name].lon!=nil)
								and (airport.elevation!=nil)
								and (airport.runways[runway_name].heading!=nil)
								)
							{
								setprop("fdm/jsbsim/systems/infoline/runways/unit["~id~"]/existed", 1);
								setprop("fdm/jsbsim/systems/infoline/runways/unit["~id~"]/airport-id", airport.id);
								setprop("fdm/jsbsim/systems/infoline/runways/unit["~id~"]/airport-name", airport.name);
								setprop("fdm/jsbsim/systems/infoline/runways/unit["~id~"]/runway-name", runway_name);
								setprop("fdm/jsbsim/systems/infoline/runways/unit["~id~"]/lat", 
									airport.runways[runway_name].lat);
								setprop("fdm/jsbsim/systems/infoline/runways/unit["~id~"]/lon", 
									airport.runways[runway_name].lon);
								setprop("fdm/jsbsim/systems/infoline/runways/unit["~id~"]/elevation", 
									airport.elevation);
								setprop("fdm/jsbsim/systems/infoline/runways/unit["~id~"]/heading",
									airport.runways[runway_name].heading);
								id=id+1;
							}
						}
					}
				}
			}
		}
		if (infoline_node.getNode("runways")!=nil)
		{
			foreach (var node; infoline_node.getNode("runways").getChildren("unit"))
			{
				if (node!=nil)
				{
					i=node.getIndex();
					if (i>=id)
					{
						setprop("fdm/jsbsim/systems/infoline/runways/unit["~id~"]/existed", 0);
						setprop("fdm/jsbsim/systems/infoline/runways/unit["~id~"]/airport-id", "");
						setprop("fdm/jsbsim/systems/infoline/runways/unit["~id~"]/airport-name", "");
						setprop("fdm/jsbsim/systems/infoline/runways/unit["~id~"]/runway-name", "");
						setprop("fdm/jsbsim/systems/infoline/runways/unit["~id~"]/lat", 0);
						setprop("fdm/jsbsim/systems/infoline/runways/unit["~id~"]/lon", 0);
						setprop("fdm/jsbsim/systems/infoline/runways/unit["~id~"]/elevation", 0);
						setprop("fdm/jsbsim/systems/infoline/runways/unit["~id~"]/heading", 0);				
					}
				}
			}
		}
	}

targets_list_update=func
	{
		infoline_node=props.globals.getNode("fdm/jsbsim/systems/infoline");
		if (props.globals.getNode("fdm/jsbsim/systems/mpdata/unit[0]")!=nil)
		{
			program_id=0;
			foreach (var node; props.globals.getNode("fdm/jsbsim/systems/mpdata").getChildren("unit"))
			{
				index=node.getIndex();
				if (index==nil)
				{
					index=0;
				}
				if (node.getNode("existed").getValue()==1)
				{
					setprop("fdm/jsbsim/systems/infoline/targets/unit["~program_id~"]/id", index);
						setprop("fdm/jsbsim/systems/infoline/targets/unit["~index~"]/existed", 1);
					program_id=program_id+1;
				}
			}

			if (program_id>0)
			{
				foreach (var node; infoline_node.getNode("targets").getChildren("unit"))
				{
					index=node.getIndex();
					if (index==nil)
					{
						index=0;
					}
					if (index>=program_id)
					{
						setprop("fdm/jsbsim/systems/infoline/targets/unit["~index~"]/id", -1);
						setprop("fdm/jsbsim/systems/infoline/targets/unit["~index~"]/existed", 0);
					}
				}
			}

		}
	}

targets_update=func
	{
		var return_array=[0,"",0,0,0,0,0,0];
		infoline_node=props.globals.getNode("fdm/jsbsim/systems/infoline");
		if (props.globals.getNode("fdm/jsbsim/systems/mpdata/unit[0]/existed")!=nil)
		{
			foreach (var node; props.globals.getNode("fdm/jsbsim/systems/mpdata").getChildren("unit"))
			{
				index=node.getIndex();
				if (index==nil)
				{
					index=0;
				}
				if (infoline_node.getNode("targets/unit[0]/existed")!=nil)
				{
					foreach (var target_node; infoline_node.getNode("targets").getChildren("unit"))
					{
						if (target_node.getNode("id").getValue()==index)
						{
							if ((node.getNode("existed").getValue()==1) and
								(node.getNode("altitude-m").getValue()>
									infoline_node.getNode("lower-range-m").getValue()))
							{
								target_node.getNode("existed", 1).setValue(1);
								target_node.getNode("callsign", 1).setValue(
									node.getNode("callsign").getValue());
								target_node.getNode("course-deg", 1).setValue(
									node.getNode("course-deg").getValue());
								target_node.getNode("distance-m", 1).setValue(
									node.getNode("distance-m").getValue());
								target_node.getNode("course-deg", 1).setValue(
									node.getNode("course-deg").getValue());
								target_node.getNode("altitude-sl-m", 1).setValue(
									node.getNode("altitude-sl-m").getValue());
								target_node.getNode("altitude-m", 1).setValue(
									node.getNode("altitude-m").getValue());
								if (target_node.getNode("airspeed-kmh")!=nil)
								{
									target_node.getNode("airspeed-kmh", 1).setValue(
										(
											target_node.getNode("airspeed-kmh").getValue()+
											(
												node.getNode("airspeed-kmh").getValue()-
												target_node.getNode("airspeed-kmh").getValue()
											)*0.1
										)
									);
									target_node.getNode("airspeed-kmh", 1).setValue(
										node.getNode("airspeed-kmh").getValue());
								}
								else
								{
									target_node.getNode("airspeed-kmh", 1).setValue(
										node.getNode("airspeed-kmh").getValue());
								}
								target_node.getNode("heading-deg", 1).setValue(
									node.getNode("heading-deg").getValue());
								if ((infoline_node.getNode("code").getValue()==0) and
									(infoline_node.getNode("lock/id").getValue()==index))
								{
									#as that target is locked, update lock information
									return_array[0]=1;
									return_array[1]=node.getNode("callsign").getValue();
									if (infoline_node.getNode("too-low-to-count").getValue()==0)
									{
										return_array[2]=node.getNode("course-deg").getValue();
										return_array[3]=node.getNode("distance-m").getValue();
									}
									return_array[4]=node.getNode("altitude-sl-m").getValue();
									return_array[5]=node.getNode("altitude-m").getValue();
									return_array[6]=target_node.getNode("airspeed-kmh").getValue();
									if (target_node.getNode("airspeed-kmh")!=nil)
									{
										return_array[6]=target_node.getNode("airspeed-kmh").getValue();
									}
									else
									{
										return_array[6]=1;
									}
									return_array[7]=node.getNode("heading-deg").getValue();
								}
							}
							else
							{
								target_node.getNode("existed", 1).setValue(0);
								target_node.getNode("callsign", 1).setValue("");
								target_node.getNode("course-deg", 1).setValue(0);
								target_node.getNode("distance-m", 1).setValue(0);
								target_node.getNode("altitude-sl-m", 1).setValue(0);
								target_node.getNode("altitude-m", 1).setValue(0);
								target_node.getNode("airspeed-kmh", 1).setValue(0);
								target_node.getNode("heading-deg", 1).setValue(0);
							}
						}
					}
				}
			}
		}
		return return_array;
	}

runway_update=func
	{
		var return_array=[0,"",0,0,0,0,0,0];
		infoline_node=props.globals.getNode("fdm/jsbsim/systems/infoline");
		if (infoline_node.getNode("runways/unit[0]/existed")!=nil)
		{
			coord=geo.aircraft_position();
			runway_coord=geo.Coord.new();
			foreach (var node; infoline_node.getNode("runways").getChildren("unit"))
			{
				index=node.getIndex();
				if (index==nil)
				{
					index=0;
				}
				if ((infoline_node.getNode("code").getValue()==2) and
					(infoline_node.getNode("lock/id").getValue()==index))
				{

					runway_coord.set_latlon(node.getNode("lat").getValue(),
						node.getNode("lon").getValue(),
						node.getNode("elevation").getValue());
					course_deg=coord.course_to(runway_coord);
					distance_m=coord.direct_distance_to(runway_coord);

					if (distance_m!=nil)
					{
						if ((infoline_node.getNode("too-low-to-count").getValue()==0) or
							(infoline_node.getNode("airport-range-m").getValue()>distance_m))
						{
							#as that runway is locked, update lock information
							return_array[0]=1;
							return_array[1]=
								node.getNode("airport-id").getValue()~", "~
								node.getNode("airport-name").getValue()~", "~
								node.getNode("runway-name").getValue();

							return_array[2]=course_deg;
							return_array[3]=distance_m;

							return_array[4]=node.getNode("elevation").getValue();
							return_array[5]=0;
							return_array[6]=0;
							return_array[7]=node.getNode("heading").getValue();
						}
					}
				}
			}
		}
		return return_array;
	}

buttons_update=func
	{

		fdm_node=props.globals.getNode("fdm/jsbsim");
		infoline_node=props.globals.getNode("fdm/jsbsim/systems/infoline");

#		#Serviceability
#
#		if (
#			(fdm_node.getNode("breakage/broken").getValue()==1)
#			 and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
#		)
#		{
#			infoline_node.getNode("serviceable").setValue(0);
#		}
#
#		if (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
#		{
#			infoline_node.getNode("serviceable").setValue(1);
#		}
#
#		#Controllability
#
#		infoline_node.getNode("controllable").setValue(
#			(1-fdm_node.getNode("breakage/pilot-knocked").getValue())
#		);
#
#		#On
#
#		if (
#			(infoline_node.getNode("power-switch").getValue()==1)
#			and (infoline_node.getNode("power-switch").getValue()==1)
#			and (fdm_node.getNode("systems/rightpanel/radio-switch").getValue()==1)
#			and (fdm_node.getNode("systems/rightpanel/course-system-switch").getValue()==1)
#			and (fdm_node.getNode("systems/electrical/conv-on").getValue()==1)
#			and (fdm_node.getNode("systems/electrical/some-alt-gen-on").getValue()==1)
#		)
#		{
#			infoline_node.getNode("on").setValue(1);
#		}
#		else
#		{
#			infoline_node.getNode("on").setValue(0);
#		}
#
#		#Light
#
#		if (
#			(infoline_node.getNode("on").getValue()==1)
#			and (infoline_node.getNode("serviceable").getValue()==1)
#			and (
#				fdm_node.getNode("systems/light/panel-left/factor").getValue()>
#				fdm_node.getNode("systems/light/cabine/factor").getValue()
#			)
#		)
#		{
#			infoline_node.getNode("light/factor").setValue(
#				fdm_node.getNode("systems/light/panel-left/factor").getValue()
#			);
#			infoline_node.getNode("light/red").setValue(
#				fdm_node.getNode("systems/light/panel-left/red").getValue()
#			);
#			infoline_node.getNode("light/green").setValue(
#				fdm_node.getNode("systems/light/panel-left/green").getValue()
#			);
#			infoline_node.getNode("light/blue").setValue(
#				fdm_node.getNode("systems/light/panel-left/blue").getValue()
#			);
#		}
#		else
#		{
#			infoline_node.getNode("light/factor").setValue(
#				fdm_node.getNode("systems/light/cabine/factor").getValue()
#			);
#			infoline_node.getNode("light/red").setValue(
#				fdm_node.getNode("systems/light/cabine/red").getValue()
#			);
#			infoline_node.getNode("light/green").setValue(
#				fdm_node.getNode("systems/light/cabine/green").getValue()
#			);
#			infoline_node.getNode("light/blue").setValue(
#				fdm_node.getNode("systems/light/cabine/blue").getValue()
#			);
#		}
#
#		#Switches
#
#		if (
#			(infoline_node.getNode("serviceable").getValue()==1)
#			and (infoline_node.getNode("controllable").getValue()==1)
#			and (fdm_node.getNode("systems/reset/on-switch").getValue()==0)
#		)
#		{
#			infoline_node.getNode("power-command").setValue(
#				infoline_node.getNode("power-input").getValue()
#			);
#			infoline_node.getNode("reset-command").setValue(
#				infoline_node.getNode("reset-input").getValue()
#			);
#			infoline_node.getNode("volume-command").setValue(
#				infoline_node.getNode("volume-input").getValue()
#			);
#			infoline_node.getNode("light-vern-pos").setValue(
#				infoline_node.getNode("light-vern-input").getValue()
#			);
#		}
#
#		if (
#			(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
#		)
#		{
#			infoline_node.getNode("power-command").setValue(0);
#			infoline_node.getNode("reset-command").setValue(0);
#			infoline_node.getNode("volume-command").setValue(0.5);
#			infoline_node.getNode("light-vern-command").setValue(0.5);
#		}
#
#		infoline_node.getNode("power-pos").setValue(
#			interpol.kin(
#				infoline_node.getNode("power-pos").getValue(),
#				infoline_node.getNode("power-command").getValue(),
#				0.2,
#				0.2
#			)
#		);
#
#		infoline_node.getNode("reset-pos").setValue(
#			interpol.kin(
#				infoline_node.getNode("reset-pos").getValue(),
#				infoline_node.getNode("reset-command").getValue(),
#				0.2,
#				0.2
#			)
#		);
#
#		infoline_node.getNode("reset-pos").setValue(
#			interpol.kin(
#				infoline_node.getNode("reset-pos").getValue(),
#				infoline_node.getNode("reset-command").getValue(),
#				0.2,
#				0.2
#			)
#		);
#
#		infoline_node.getNode("volume-pos").setValue(
#			interpol.kin(
#				infoline_node.getNode("volume-pos").getValue(),
#				infoline_node.getNode("volume-command").getValue(),
#				0.2,
#				0.2
#			)
#		);
#
#		if (
#			(infoline_node.getNode("serviceable").getValue()==0)
#			or (infoline_node.getNode("controllable").getValue()==0)
#			or  (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
#		)
#		{
#			infoline_node.getNode("power-input").setValue(
#				infoline_node.getNode("power-command").getValue()
#			);
#			infoline_node.getNode("reset-input").setValue(
#				infoline_node.getNode("reset-command").getValue()
#			);
#			infoline_node.getNode("volume-input").setValue(
#				infoline_node.getNode("volume-command").getValue()
#			);
#			infoline_node.getNode("light-vern-input").setValue(
#				infoline_node.getNode("light-vern-pos").getValue()
#			);
#		}
#
#		infoline_node.getNode("power-switch").setValue(
#			infoline_node.getNode("power-pos").getValue()>0.5
#		);
#
#		infoline_node.getNode("reset-switch").setValue(
#			infoline_node.getNode("reset-pos").getValue()>0.5
#		);
#
#		infoline_node.getNode("volume-switch").setValue(
#			infoline_node.getNode("volume-pos").getValue()>0.5
#		);
#
#		if (
#			(
#				(infoline_node.getNode("power-pos").getValue()>0.25)
#				and (infoline_node.getNode("power-pos").getValue()<0.75)
#			)
#			or (
#				(infoline_node.getNode("reset-pos").getValue()>0.25)
#				and (infoline_node.getNode("reset-pos").getValue()<0.75)
#			)
#		)
#		{
#			fdm_node.getNode("systems/sounds/click/on").setValue(1);
#		}
#
#		#Buttons
#
#		#Shift
#
#		foreach (var node; infoline_node.getNode("buttons/shift").getChildren("unit"))
#		{
#			index=node.getIndex();
#			if (index==nil)
#			{
#				index=0;
#			}
#
#			if (
#				(infoline_node.getNode("serviceable").getValue()==1)
#				and (infoline_node.getNode("controllable").getValue()==1)
#			)
#			{
#				node.getNode("command").setValue(
#					infoline_node.getNode("shift-input").getValue()==index
#				);
#			}
#
#			node.getNode("pos").setValue(
#				interpol.kin(
#					node.getNode("pos").getValue(),
#					node.getNode("command").getValue(),
#					0.2,
#					0.2
#				)
#			);
#
#			if (node.getNode("pos").getValue()>0.75)
#			{
#				infoline_node.getNode("shift").setValue(index);
#			}
#
#			if (
#				(infoline_node.getNode("shift").getValue()==index)
#				and (infoline_node.getNode("lock/existed").getValue()==1)
#				and (infoline_node.getNode("on").getValue()==1)
#			)
#			{
#				node.getNode("light").setValue(
#					infoline_node.getNode("light-vern-pos").getValue()
#				);
#			}	
#			else
#			{ 
#				node.getNode("light").setValue(0);
#			}
#
#			if (
#				(node.getNode("pos").getValue()>0.25)
#				and (node.getNode("pos").getValue()<0.75)
#			)
#			{
#				fdm_node.getNode("systems/sounds/click/on").setValue(1);
#			}
#
#		}
#
#		#Wave
#
#		foreach (var node; infoline_node.getNode("buttons/wave").getChildren("unit"))
#		{
#			index=node.getIndex();
#			if (index==nil)
#			{
#				index=0;
#			}
#
#			if (
#				(infoline_node.getNode("serviceable").getValue()==1)
#				and (infoline_node.getNode("controllable").getValue()==1)
#			)
#			{
#				node.getNode("command").setValue(
#					infoline_node.getNode("wave-input").getValue()==index
#				);
#			}
#
#			node.getNode("pos").setValue(
#				interpol.kin(
#					node.getNode("pos").getValue(),
#					node.getNode("command").getValue(),
#					0.2,
#					0.2
#				)
#			);
#
#			if (node.getNode("pos").getValue()>0.75)
#			{
#				infoline_node.getNode("wave").setValue(index);
#			}
#
#			if (
#				(infoline_node.getNode("wave").getValue()==index)
#				and (infoline_node.getNode("lock/existed").getValue()==1)
#				and (infoline_node.getNode("on").getValue()==1)
#			)
#			{
#				node.getNode("light").setValue(
#					infoline_node.getNode("light-vern-pos").getValue()
#				);
#			}	
#			else
#			{ 
#				node.getNode("light").setValue(0);
#			}
#
#			if (
#				(node.getNode("pos").getValue()>0.25)
#				and (node.getNode("pos").getValue()<0.75)
#			)
#			{
#				fdm_node.getNode("systems/sounds/click/on").setValue(1);
#			}
#
#		}
#
#		#Code
#
#		foreach (var node; infoline_node.getNode("buttons/code").getChildren("unit"))
#		{
#			index=node.getIndex();
#			if (index==nil)
#			{
#				index=0;
#			}
#
#			if (
#				(infoline_node.getNode("serviceable").getValue()==1)
#				and (infoline_node.getNode("controllable").getValue()==1)
#			)
#			{
#				node.getNode("command").setValue(
#					infoline_node.getNode("code-input").getValue()==index
#				);
#			}
#
#			node.getNode("pos").setValue(
#				interpol.kin(
#					node.getNode("pos").getValue(),
#					node.getNode("command").getValue(),
#					0.2,
#					0.2
#				)
#			);
#
#			if (node.getNode("pos").getValue()>0.75)
#			{
#				infoline_node.getNode("code").setValue(index);
#			}
#
#			if (
#				(infoline_node.getNode("code").getValue()==index)
#				and (infoline_node.getNode("lock/existed").getValue()==1)
#				and (infoline_node.getNode("on").getValue()==1)
#			)
#			{
#				node.getNode("light").setValue(
#					infoline_node.getNode("light-vern-pos").getValue()
#				);
#			}	
#			else
#			{ 
#				node.getNode("light").setValue(0);
#			}
#
#			if (
#				(node.getNode("pos").getValue()>0.25)
#				and (node.getNode("pos").getValue()<0.75)
#			)
#			{
#				fdm_node.getNode("systems/sounds/click/on").setValue(1);
#			}
#
#		}
#
#
#

		#Lights

		#Shift

		foreach (var node; infoline_node.getNode("buttons/shift").getChildren("unit"))
		{
			index=node.getIndex();
			if (index==nil)
			{
				index=0;
			}

			if (
				(infoline_node.getNode("shift").getValue()==index)
				and (infoline_node.getNode("lock/existed").getValue()==1)
				and (infoline_node.getNode("on").getValue()==1)
			)
			{
				node.getNode("light").setValue(
					infoline_node.getNode("light-vern-pos").getValue()
				);
			}	
			else
			{ 
				node.getNode("light").setValue(0);
			}

		}

		#Wave

		foreach (var node; infoline_node.getNode("buttons/wave").getChildren("unit"))
		{
			index=node.getIndex();
			if (index==nil)
			{
				index=0;
			}

			if (
				(infoline_node.getNode("wave").getValue()==index)
				and (infoline_node.getNode("lock/existed").getValue()==1)
				and (infoline_node.getNode("on").getValue()==1)
			)
			{
				node.getNode("light").setValue(
					infoline_node.getNode("light-vern-pos").getValue()
				);
			}	
			else
			{ 
				node.getNode("light").setValue(0);
			}

		}

		#Code

		foreach (var node; infoline_node.getNode("buttons/code").getChildren("unit"))
		{
			index=node.getIndex();
			if (index==nil)
			{
				index=0;
			}

			if (
				(infoline_node.getNode("code").getValue()==index)
				and (infoline_node.getNode("lock/existed").getValue()==1)
				and (infoline_node.getNode("on").getValue()==1)
			)
			{
				node.getNode("light").setValue(
					infoline_node.getNode("light-vern-pos").getValue()
				);
			}	
			else
			{ 
				node.getNode("light").setValue(0);
			}

		}

	}

infoline_update=func
	{
		#------------------------ update infoline information ------------------------

		infoline_node=props.globals.getNode("fdm/jsbsim/systems/infoline");

		altitude_m=props.globals.getNode("fdm/jsbsim/position/h-agl-ft").getValue()*0.3048;

		if (altitude_m<infoline_node.getNode("lower-range-m").getValue())
		{
			infoline_node.getNode("too-low-to-count").setValue(1);
		}
		else
		{
			infoline_node.getNode("too-low-to-count").setValue(0);
		}

		coord=geo.aircraft_position();

		if (infoline_node.getNode("on").getValue()==1)
		{

			#reset
			if (infoline_node.getNode("reset-switch").getValue()==1)
			{
				if (infoline_node.getNode("reset-programs").getValue()==0)
				{
					runways_list_update();
					targets_list_update();				
					setprop("fdm/jsbsim/systems/infoline/reset-programs", 1);
				}
			}
			else
			{
				setprop("fdm/jsbsim/systems/infoline/reset-programs", 0);
			}
			
			#get current id number on base of selected program,
			#and updet information

			var lock_array=[-1,"",0,0,0,0,0,0];

			lock_id=infoline_node.getNode("wave").getValue()*8+infoline_node.getNode("shift").getValue();
			infoline_node.getNode("lock/id").setValue(lock_id);

			if (infoline_node.getNode("code").getValue()==0)
			{
				#first code is for targets
				lock_array=targets_update();
			}
			else
			{
				targets_update();
			}

			if (infoline_node.getNode("code").getValue()==2)
			{
				#third code is for runways
				lock_array=runway_update();
			}
			else
			{
				runway_update();
			}

			#update lock information

			infoline_node.getNode("lock/existed").setValue(lock_array[0]);
			if ((lock_array[1]!=infoline_node.getNode("lock/name").getValue())
				and (lock_array[1]!=""))
			{
				if (infoline_node.getNode("volume-switch").getValue()==1)
				{
					screen.log.write("Selected: "~lock_array[1]);
				}
			}
			infoline_node.getNode("lock/name").setValue(lock_array[1]);
			infoline_node.getNode("lock/course-deg").setValue(lock_array[2]);
			infoline_node.getNode("lock/distance-m").setValue(lock_array[3]);
			infoline_node.getNode("lock/altitude-sl-m").setValue(lock_array[4]);
			infoline_node.getNode("lock/altitude-m").setValue(lock_array[5]);
			infoline_node.getNode("lock/airspeed-kmh").setValue(lock_array[6]);
			infoline_node.getNode("lock/heading-deg").setValue(lock_array[7]);
		}
		else
		{
			#clearing lock data, lock is off
			infoline_node.getNode("lock/id").setValue(-1);
			infoline_node.getNode("lock/existed").setValue(0);
			infoline_node.getNode("lock/name").setValue("");
			infoline_node.getNode("lock/course-deg").setValue(0);
			infoline_node.getNode("lock/distance-m").setValue(0);
			infoline_node.getNode("lock/altitude-sl-m").setValue(0);
			infoline_node.getNode("lock/altitude-m").setValue(0);
			infoline_node.getNode("lock/airspeed-kmh").setValue(0);
			infoline_node.getNode("lock/heading-deg").setValue(0);
		}

		buttons_update();

		settimer(func infoline_update(), 0.2);
	};

infoline_update();
