#-----------------------------------------------------------------------
#Mpdata

#Get multipleyer data and account relative angles, distances, speeds -
#everything needed for radar and course system

stop_mpdata_update=func
	{
		
	}

mpdata_update=func
	{
		speed_kt=getprop("velocities/airspeed-kt");
		pitch_deg=getprop("orientation/pitch-deg");
		roll_deg=getprop("orientation/roll-deg");
		heading_deg=getprop("orientation/heading-deg");
		time_sec=getprop("sim/time/elapsed-sec");
		coord=geo.aircraft_position();
		mp_coord=geo.Coord.new();
		ground_coord=geo.Coord.new();
		if ((coord.is_defined()==1) and
			(speed_kt != nil) and
			(pitch_deg != nil) and
			(roll_deg !=nil) and
			(heading_deg != nil) and
			(time_sec != nil) 
		)
		{
			if (props.globals.getNode("ai/models/multiplayer[0]/id")!=nil)
			{
				foreach (var node; props.globals.getNode("ai/models").getChildren("multiplayer"))
				{
					i=node.getIndex();
					if (i==nil)
					{
						i=0;
					}
					#check if next multiplayer model is presented in list
					id=node.getNode("id").getValue();
					callsign=node.getNode("callsign").getValue();
					if ((id != nil) and
						(callsign!= nil))
					{
						setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/callsign", callsign);
						#check if it is presnted really
						if (id==-1)
						{
							setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/mp-id", -1);
							setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/existed", 0);
							setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/higher-than-horison", 0);
							setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/hidden-by-mountain", 0);
							setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/background-m", 0);
							setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/back-semisphere", 0);
							setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/speed-kmh", 0);
							setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/airspeed-kmh", 0);
							setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/time-sec", time_sec);
							setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/distance-m", 0);
							setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/altitude-sl-m", 0);
							setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/altitude-m", 0);
							setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/alpha-deg", 0);
							setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/beta-deg", 0);
							setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/heading-deg", 0);
						}
						else
						{
							prev_dist=getprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/distance-m");
							prev_time=getprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/time-sec");
							if ((node.getNode("position/altitude-ft")!= nil) and
								(node.getNode("position/latitude-deg")!= nil) and
								(node.getNode("position/longitude-deg")!= nil) and
								(node.getNode("velocities/true-airspeed-kt")!= nil) and
								(node.getNode("orientation/pitch-deg")!= nil) and
								(node.getNode("orientation/roll-deg")!= nil) and
								(node.getNode("orientation/true-heading-deg")!= nil) and
								(prev_dist!= nil) and
								(prev_time!= nil)
							)
							{
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/mp-id", id);
								mp_altitude_sl_ft=node.getNode("position/altitude-ft").getValue();
								mp_latitude_deg=node.getNode("position/latitude-deg").getValue();
								mp_longitude_deg=node.getNode("position/longitude-deg").getValue();
								mp_airspeed_kt=node.getNode("velocities/true-airspeed-kt").getValue();
								mp_pitch_deg=node.getNode("orientation/pitch-deg").getValue();
								mp_roll_deg=node.getNode("orientation/roll-deg").getValue();
								mp_heading_deg=node.getNode("orientation/true-heading-deg").getValue();
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/existed", 1);
								mp_altitude_sl_m=mp_altitude_sl_ft*0.3048;
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/altitude-sl-m", mp_altitude_sl_m);
								#calculate real target altitude 
								mp_coord.set_latlon(mp_latitude_deg, mp_longitude_deg, mp_altitude_sl_m);
								elevation_m=geo.elevation(mp_latitude_deg, mp_longitude_deg);
								if (elevation_m==nil)
								{
									elevation_m=0;
								}
								mp_altitude_m=mp_altitude_sl_m-elevation_m;
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/altitude-m", mp_altitude_m);
								#calculate relative angles from craft to target
								distance_m=coord.direct_distance_to(mp_coord);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/distance-m", distance_m);
								airspeed_kmh=mp_airspeed_kt*1.852;
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/airspeed-kmh", airspeed_kmh);
								course_deg=coord.course_to(mp_coord);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/course-deg", course_deg);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/heading-deg", mp_heading_deg);
								if (course_deg>180)
								{
									course_deg=course_deg-360;
								}
								heights_rad=math.atan2((mp_altitude_sl_m-coord.alt()), distance_m);
								heights_deg=heights_rad/math.pi*180;
								alpha_init_deg=heights_rad/math.pi*180-pitch_deg;
								if (heading_deg>180)
								{
									heading_deg=heading_deg-360;
								}
								beta_init_deg=course_deg-heading_deg;
								if (beta_init_deg>180)
								{
									beta_init_deg=beta_init_deg-360;
								}
								if (beta_init_deg<-180)
								{
									beta_init_deg=beta_init_deg+360;
								}
								if ((beta_init_deg>-90) and
									(beta_init_deg<90))
								{
									setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/back-semisphere", 0);
								}
								else
								{
									setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/back-semisphere", 1);
								}
								alpha_init_rad=alpha_init_deg/180*math.pi;
								beta_init_rad=beta_init_deg/180*math.pi;
								alpha_init_vector=math.sin(alpha_init_rad);
								beta_init_vector=math.sin(beta_init_rad);
								sum_vector=math.sqrt(alpha_init_vector*alpha_init_vector+beta_init_vector*beta_init_vector);
								gamma_init_rad=math.atan2(beta_init_vector, alpha_init_vector);
								gamma_init_deg=gamma_init_rad/math.pi*180;
								gamma_rad=math.atan2(beta_init_vector, alpha_init_vector)-roll_deg/180*math.pi;
								gamma_deg=gamma_rad/math.pi*180;
								alpha_vector=sum_vector*math.cos(gamma_rad);
								beta_vector=sum_vector*math.sin(gamma_rad);
								if (alpha_vector>1)
								{
									alpha_vector=0.999999;
								}
								if (alpha_vector<-1)
								{
									alpha_vector=-0.999999;
								}
								if (beta_vector>1)
								{
									beta_vector=0.999999;
								}
								if (beta_vector<-1)
								{
									beta_vector=-0.999999;
								}
								alpha_side_vector=math.sqrt(1-math.pow(alpha_vector, 2));
								beta_side_vector=math.sqrt(1-math.pow(beta_vector, 2));
								alpha_rad=math.atan2(alpha_vector, alpha_side_vector);
								beta_rad=math.atan2(beta_vector, beta_side_vector);
								alpha_deg=alpha_rad/math.pi*180;
								beta_deg=beta_rad/math.pi*180;
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/alpha-deg", alpha_deg);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/beta-deg", beta_deg);
								#calculate relative speed
								if (time_sec!=prev_time)
								{
									speed_kmh=((prev_dist-distance_m)/(time_sec-prev_time))*3.6;
									setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/speed-kmh", speed_kmh);
									setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/time-sec", time_sec);
								}
								#find if target is higher than craft 
								if (heights_deg>=0)
								{
									setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/higher-than-horison", 1);
								}
								else
								{
									setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/higher-than-horison", 0);
								}
								#check if target is hidden behind mountain
								hidden_by_mountain=0;
								for (j=1; j<10; j+=1)
								{
									ground_latitude_deg=coord.lat()+(mp_coord.lat()-coord.lat())*j/10;
									ground_longitude_deg=coord.lon()+(mp_coord.lon()-coord.lon())*j/10;
									line_altitude_m=coord.alt()+(mp_coord.alt()-coord.alt())*j/10;
									ground_altitude_m=geo.elevation(ground_latitude_deg, ground_longitude_deg);
									if ((ground_altitude_m!=nil) and
										(line_altitude_m!=nil)
									)
									{
										if (ground_altitude_m>line_altitude_m)
										{
											hidden_by_mountain=1;
										}
									}
									setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/hidden-by-mountain", hidden_by_mountain);
								}
								#check how far is ground behind target
								background_m=0;
								if ((heights_deg<0) and (hidden_by_mountain==0))
								{
									for (j=1; j<10; j+=1)
									{
										ground_latitude_deg=coord.lat()+(mp_coord.lat()-coord.lat())*(coord.alt()/(coord.alt()-mp_altitude_sl_m))*j/10;
										ground_longitude_deg=coord.lon()+(mp_coord.lon()-coord.lon())*(coord.alt()/(coord.alt()-mp_altitude_sl_m))*j/10;
										line_altitude_m=coord.alt()+(mp_coord.alt()-coord.alt())*(coord.alt()/(coord.alt()-mp_altitude_sl_m))*j/10;
										ground_altitude_m=geo.elevation(ground_latitude_deg, ground_longitude_deg);
										if (
											(ground_altitude_m!=nil) and
											(line_altitude_m!=nil)
										)
										{
											if ((ground_altitude_m>line_altitude_m) and (background_m==0))
											{
												ground_coord.set_latlon(ground_latitude_deg, ground_longitude_deg, ground_altitude_m);
												background_m=coord.direct_distance_to(ground_coord);
											}
											setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/background-m", background_m);
										}
									}
									if (background_m==0)
									{
										ground_coord.set_latlon(ground_latitude_deg, ground_longitude_deg, 0);
										background_m=coord.direct_distance_to(ground_coord);
									}
									setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/background-m", background_m);
								}
								else
								{
									setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/background-m", 0);
								}
							}
							else
							{
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/mp-id", -1);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/existed", 0);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/higher-than-horison", 0);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/hidden-by-mountain", 0);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/background-m", 0);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/back-semisphere", 0);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/speed-kmh", 0);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/time-sec", time_sec);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/distance-m", 0);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/speed-kmh", 0);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/airspeed-kmh", 0);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/altitude-sl-m", 0);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/altitude-m", 0);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/alpha-deg", 0);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/beta-deg", 0);
								setprop("fdm/jsbsim/systems/mpdata/unit["~i~"]/heading-deg", 0);
							}
						}
					}
				}
			}
		}
		settimer(mpdata_update, 0.25);
	}
	
init_mpdata_update=func
{
}

init_mpdata_update();

mpdata_update();
