# -----------------------------------------------------------------------
# Su-15 JSBSim pneumatic system simplified nasal analog

pneumatic=func()
{

	fdm_node=props.globals.getNode("fdm/jsbsim");

	time_sec=props.globals.getNode("sim/time/elapsed-sec").getValue();
	time_sec_prev=fdm_node.getNode("systems/pneumatic/time-sec").getValue();
	tick_sec=time_sec-time_sec_prev;
	fdm_node.getNode("systems/pneumatic/time-sec").setValue(time_sec);

	#Serviceability

	if (
		(fdm_node.getNode("breakage/broken").getValue()==1) and
		(fdm_node.getNode("systems/repair/on-switch").getValue()==0)
		)
	{
		fdm_node.getNode("systems/pneumatic/serviceable").setValue(0);
	}

	if (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
	{
		fdm_node.getNode("systems/pneumatic/serviceable").setValue(1);
	}

	#One system has three cyls using sequentially
	#and refilled on refill and reset

	#cyl used

	cyl_used=fdm_node.getNode("systems/pneumatic/cyl-used").getValue();

	if (
		(fdm_node.getNode("systems/pneumatic/serviceable").getValue()==1) and
		(
			fdm_node.getNode("systems/pneumatic/cyl[0]/pressure").getValue()>
			fdm_node.getNode("systems/pneumatic/system-max").getValue()
		)
	)
	{
		cyl_used=0;
	}

	if (
		(fdm_node.getNode("systems/pneumatic/serviceable").getValue()==1) and
		(
			fdm_node.getNode("systems/pneumatic/cyl[0]/pressure").getValue()<
			fdm_node.getNode("systems/pneumatic/system-max").getValue()
		) and
		(
			fdm_node.getNode("systems/pneumatic/cyl[1]/pressure").getValue()>
			fdm_node.getNode("systems/pneumatic/system-max").getValue()
		)
	)
	{
		cyl_used=1;
	}

	if (
		(fdm_node.getNode("systems/pneumatic/serviceable").getValue()==1) and
		(
			fdm_node.getNode("systems/pneumatic/cyl[0]/pressure").getValue()<
			fdm_node.getNode("systems/pneumatic/system-max").getValue()
		) and
		(
			fdm_node.getNode("systems/pneumatic/cyl[1]/pressure").getValue()<
			fdm_node.getNode("systems/pneumatic/system-max").getValue()
		) and
		(
			fdm_node.getNode("systems/pneumatic/cyl[2]/pressure").getValue()>
			fdm_node.getNode("systems/pneumatic/system-max").getValue()
		)
	)
	{
		cyl_used=2;
	}

	fdm_node.getNode("systems/pneumatic/cyl-used").setValue(cyl_used);

	#pressure of flight altitude 
	#to pressure at sea level

	fdm_node.getNode("systems/pneumatic/altitude-press-norm").setValue(
		fdm_node.getNode("atmosphere/P-psf").getValue()/
		fdm_node.getNode("atmosphere/P-sl-psf").getValue()	
	);

	#cockpit pressure

	fdm_node.getNode("systems/pneumatic/cockpit/pressure-calc").setValue(
		interpol.sps_inter(
			[
				[
					[0.0,	0.9,	1.0],
					[0.0,	0.0,	0.4],
					[1.0,	1.0,	1.0]
				],
				[
					[1.0,	0.9,	1.0],
					[0.0,	0.0,	0.0],
					[1.0,	1.0,	1.0]
				]
			],
			fdm_node.getNode("systems/canopy/tored").getValue(),		
			fdm_node.getNode("systems/pneumatic/altitude-press-norm").getValue(),
			fdm_node.getNode("systems/canopy/slide-pos").getValue()
		)
	);

	fdm_node.getNode("systems/pneumatic/cockpit/input-calc").setValue(
		fdm_node.getNode("systems/pneumatic/cockpit/pressure-calc").getValue()-
		fdm_node.getNode("systems/pneumatic/cockpit/pressure").getValue()	
	);

	fdm_node.getNode("systems/pneumatic/cockpit/pressure-diff").setValue(
		fdm_node.getNode("systems/pneumatic/cockpit/pressure").getValue()-
		fdm_node.getNode("systems/pneumatic/altitude-press-norm").getValue()	
	);

	fdm_node.getNode("systems/pneumatic/cockpit/pressure-alt").setValue(
		interpol.lin_inter(
				[
					[0.06,	20000.0],
					[0.07,	19000.0],
					[0.08,	18000.0],
					[0.10,	17000.0],
					[0.12,	16000.0],
					[0.13,	15000.0],
					[0.16,	14000.0],
					[0.18,	13000.0],
					[0.21,	12000.0],
					[0.25,	11000.0],
					[0.28,	10000.0],
					[0.33,	9000.0],
					[0.37,	8000.0],
					[0.43,	7000.0],
					[0.49,	6000.0],
					[0.55,	5000.0],
					[0.63,	4000.0],
					[0.71,	3000.0],
					[0.80,	2000.0],
					[0.89,	1000.0],
					[1.0,		0.0]
				],
			fdm_node.getNode("systems/pneumatic/cockpit/pressure").getValue()
		)
	);

	if (
		(fdm_node.getNode("systems/pneumatic/cockpit/pressure-diff").getValue()<=0) or
		(fdm_node.getNode("systems/pneumatic/cockpit/input-calc").getValue()<=0) or
		(
			(fdm_node.getNode("systems/pneumatic/cockpit/pressure-diff").getValue()>0) and
			(fdm_node.getNode("systems/pneumatic/cockpit/input-calc").getValue()>0) and
			(
				fdm_node.getNode("systems/pneumatic/system-press").getValue()>
				fdm_node.getNode("systems/pneumatic/working-min").getValue()
			) and
			(fdm_node.getNode("systems/refill/on-switch").getValue()==0)
		) 
	)
	{
		fdm_node.getNode("systems/pneumatic/cockpit/input").setValue(
			fdm_node.getNode("systems/pneumatic/cockpit/input-calc").getValue()
		);
	}
	else
	{
		fdm_node.getNode("systems/pneumatic/cockpit/input").setValue(0);
	}

	#if cyls pressures greater than system pressure

	if (
		fdm_node.getNode("systems/pneumatic/cyl[0]/pressure").getValue()>
		fdm_node.getNode("systems/pneumatic/system-press").getValue()
	)
	{
		fdm_node.getNode("systems/pneumatic/cyl[0]/gr-than-sys").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/pneumatic/cyl[0]/gr-than-sys").setValue(0);
	}

	if (
		fdm_node.getNode("systems/pneumatic/cyl[1]/pressure").getValue()>
		fdm_node.getNode("systems/pneumatic/system-press").getValue()
	)
	{
		fdm_node.getNode("systems/pneumatic/cyl[1]/gr-than-sys").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/pneumatic/cyl[1]/gr-than-sys").setValue(0);
	}

	if (
		fdm_node.getNode("systems/pneumatic/cyl[2]/pressure").getValue()>
		fdm_node.getNode("systems/pneumatic/system-press").getValue()
	)
	{
		fdm_node.getNode("systems/pneumatic/cyl[2]/gr-than-sys").setValue(1);
	}
	else
	{
		fdm_node.getNode("systems/pneumatic/cyl[2]/gr-than-sys").setValue(0);
	}

	#system floats

	#resulted float into system, out floats going with minus

	fdm_node.getNode("systems/pneumatic/system-input-calc").setValue(
		(-1)*
		(
			fdm_node.getNode("systems/pneumatic/rel-ext").getValue()+
			(
				fdm_node.getNode("systems/pneumatic/cockpit/pressure-calc").getValue()-
				fdm_node.getNode("systems/pneumatic/altitude-press-norm").getValue()
			)*
			interpol.lin_inter(
				[
					[-1.0,			0.0],
					[0.0,				0.0],
					[0.000001,	1.0]
				],
			fdm_node.getNode("systems/pneumatic/cockpit/pressure-diff").getValue()
			)*
			fdm_node.getNode("systems/pneumatic/cockpit-ext").getValue()+
			(
				(
					fdm_node.getNode("gear/unit[0]/doors-moving").getValue()*
					fdm_node.getNode("systems/pneumatic/door-ext").getValue()
				)+
				(
					fdm_node.getNode("gear/unit[1]/doors-moving").getValue()*
					fdm_node.getNode("systems/pneumatic/door-ext").getValue()
				)+
				(
					fdm_node.getNode("gear/unit[2]/doors-moving").getValue()*
					fdm_node.getNode("systems/pneumatic/door-ext").getValue()
				)+
				(
					fdm_node.getNode("gear/unit[0]/strut-moving").getValue()*
					fdm_node.getNode("systems/pneumatic/strut-ext").getValue()
				)+
				(
					fdm_node.getNode("gear/unit[1]/strut-moving").getValue()*
					fdm_node.getNode("systems/pneumatic/strut-ext").getValue()
				)+
				(
					fdm_node.getNode("gear/unit[2]/strut-moving").getValue()*
					fdm_node.getNode("systems/pneumatic/strut-ext").getValue()
				)+
				(
					fdm_node.getNode("gear/unit[0]/broken").getValue()*
					fdm_node.getNode("systems/pneumatic/broken-ext").getValue()
				)+
				(
					fdm_node.getNode("gear/unit[1]/broken").getValue()*
					fdm_node.getNode("systems/pneumatic/broken-ext").getValue()
				)+
				(
					fdm_node.getNode("gear/unit[2]/broken").getValue()*
					fdm_node.getNode("systems/pneumatic/broken-ext").getValue()
				)
			)*
			fdm_node.getNode("systems/gearsemergencyhandle/handle-switch").getValue()+
			(
				fdm_node.getNode("gear/unit[0]/brake-moving").getValue()*
				fdm_node.getNode("systems/pneumatic/brake-ext").getValue()
			)+
			(
				fdm_node.getNode("gear/unit[1]/brake-moving").getValue()*
				fdm_node.getNode("systems/pneumatic/brake-ext").getValue()
			)+
			(
				fdm_node.getNode("gear/unit[2]/brake-moving").getValue()*
				fdm_node.getNode("systems/pneumatic/brake-ext").getValue()
			)+
			(
				(
					(
						fdm_node.getNode("surfaces/flap/unit[0]/moving").getValue()*
						fdm_node.getNode("systems/pneumatic/strut-ext").getValue()
					)+
					(
						fdm_node.getNode("surfaces/flap/unit[1]/moving").getValue()*
						fdm_node.getNode("systems/pneumatic/strut-ext").getValue()
					)+
					(
						fdm_node.getNode("surfaces/flap/unit[0]/broken").getValue()*
						fdm_node.getNode("systems/pneumatic/broken-ext").getValue()
					)+
					(
						fdm_node.getNode("surfaces/flap/unit[1]/broken").getValue()*
						fdm_node.getNode("systems/pneumatic/broken-ext").getValue()
					)
				)*
				fdm_node.getNode("systems/flapsemergencyhandle/handle-switch").getValue()
			)
		)
	);

	#input float needed to return system to maximal state

	fdm_node.getNode("systems/pneumatic/system-return").setValue(
		fdm_node.getNode("systems/pneumatic/system-max").getValue()-
		fdm_node.getNode("systems/pneumatic/system-press").getValue()
	);

	#calcualted floats into system from cyls

	fdm_node.getNode("systems/pneumatic/cyl[0]/sys-rest-float").setValue(
		(
			fdm_node.getNode("systems/pneumatic/system-input-calc").getValue()-
			fdm_node.getNode("systems/pneumatic/system-return").getValue()*
				interpol.lin_inter(
					[
						[0.0,			0.0],
						[0.0001,	1.0]
					],
					fdm_node.getNode("systems/pneumatic/system-return").getValue()
				)
		)*
		interpol.sqr_inter(
			[
				[0.0,	0.0,	1.0],
				[0.0,	0.0,	1.0],
				[1.0,	0.0,	0.0],
				[2.0,	0.0,	0.0]
			],
			fdm_node.getNode("systems/pneumatic/cyl-used").getValue(),
			fdm_node.getNode("systems/pneumatic/cyl[0]/gr-than-sys").getValue()
		)
	);

	fdm_node.getNode("systems/pneumatic/cyl[1]/sys-rest-float").setValue(
		(
			fdm_node.getNode("systems/pneumatic/system-input-calc").getValue()-
			fdm_node.getNode("systems/pneumatic/system-return").getValue()*
				interpol.lin_inter(
					[
						[0.0,			0.0],
						[0.0001,	1.0]
					],
					fdm_node.getNode("systems/pneumatic/system-return").getValue()
				)
		)*
		interpol.sqr_inter(
			[
				[0.0,	0.0,	1.0],
				[0.0,	0.0,	0.0],
				[1.0,	0.0,	1.0],
				[2.0,	0.0,	0.0]
			],
			fdm_node.getNode("systems/pneumatic/cyl-used").getValue(),
			fdm_node.getNode("systems/pneumatic/cyl[1]/gr-than-sys").getValue()
		)
	);

	fdm_node.getNode("systems/pneumatic/cyl[2]/sys-rest-float").setValue(
		(
			fdm_node.getNode("systems/pneumatic/system-input-calc").getValue()-
			fdm_node.getNode("systems/pneumatic/system-return").getValue()*
				interpol.lin_inter(
					[
						[0.0,			0.0],
						[0.0001,	1.0]
					],
					fdm_node.getNode("systems/pneumatic/system-return").getValue()
				)
		)*
		interpol.sqr_inter(
			[
				[0.0,	0.0,	1.0],
				[0.0,	0.0,	0.0],
				[1.0,	0.0,	0.0],
				[2.0,	0.0,	1.0]
			],
			fdm_node.getNode("systems/pneumatic/cyl-used").getValue(),
			fdm_node.getNode("systems/pneumatic/cyl[2]/gr-than-sys").getValue()
		)
	);

	#float into system from cyls

	int_trans=
		fdm_node.getNode("systems/pneumatic/cyl[0]/sys-rest-float").getValue()+
		fdm_node.getNode("systems/pneumatic/cyl[1]/sys-rest-float").getValue()+
		fdm_node.getNode("systems/pneumatic/cyl[2]/sys-rest-float").getValue();

	if (
		int_trans<
		((-1)*fdm_node.getNode("systems/pneumatic/trans-max").getValue())
	)
	{
		int_trans=(-1)*fdm_node.getNode("systems/pneumatic/trans-max").getValue();
	}

	fdm_node.getNode("systems/pneumatic/int-trans").setValue(int_trans);

	#cyl floats with refill on reset

	fdm_node.getNode("systems/pneumatic/cyl[0]/input").setValue(
		fdm_node.getNode("systems/pneumatic/int-trans").getValue()*
		interpol.sqr_inter(
			[
				[0.0,	0.0,	1.0],
				[0.0,	1.0,	0.0],
				[1.0,	0.0,	0.0],
				[2.0,	0.0,	0.0]
			],
			fdm_node.getNode("systems/pneumatic/cyl-used").getValue(),
			fdm_node.getNode("systems/refill/on-switch").getValue()
		)+
		(
			fdm_node.getNode("systems/pneumatic/pressure-max").getValue()-
			fdm_node.getNode("systems/pneumatic/cyl[0]/pressure").getValue()
		)*
		fdm_node.getNode("systems/refill/on-switch").getValue()
	);

	fdm_node.getNode("systems/pneumatic/cyl[1]/input").setValue(
		fdm_node.getNode("systems/pneumatic/int-trans").getValue()*
		interpol.sqr_inter(
			[
				[0.0,	0.0,	1.0],
				[0.0,	0.0,	0.0],
				[1.0,	1.0,	0.0],
				[2.0,	0.0,	0.0]
			],
			fdm_node.getNode("systems/pneumatic/cyl-used").getValue(),
			fdm_node.getNode("systems/refill/on-switch").getValue()
		)+
		(
			fdm_node.getNode("systems/pneumatic/pressure-max").getValue()-
			fdm_node.getNode("systems/pneumatic/cyl[1]/pressure").getValue()
		)*
		fdm_node.getNode("systems/refill/on-switch").getValue()
	);

	fdm_node.getNode("systems/pneumatic/cyl[2]/input").setValue(
		fdm_node.getNode("systems/pneumatic/int-trans").getValue()*
		interpol.sqr_inter(
			[
				[0.0,	0.0,	1.0],
				[0.0,	0.0,	0.0],
				[1.0,	0.0,	0.0],
				[2.0,	1.0,	0.0]
			],
			fdm_node.getNode("systems/pneumatic/cyl-used").getValue(),
			fdm_node.getNode("systems/refill/on-switch").getValue()
		)+
		(
			fdm_node.getNode("systems/pneumatic/pressure-max").getValue()-
			fdm_node.getNode("systems/pneumatic/cyl[2]/pressure").getValue()
		)*
		fdm_node.getNode("systems/refill/on-switch").getValue()
	);

	#resulted system float

	system_input=
		fdm_node.getNode("systems/pneumatic/system-input-calc").getValue()+
		(-1)*int_trans;

	if (
		(
			(system_input<=0) and
			(fdm_node.getNode("systems/pneumatic/system-press").getValue()>0) and
			(fdm_node.getNode("systems/refill/on-switch").getValue()==0)
		) or
		(
			(system_input>0) and
			(fdm_node.getNode("systems/refill/on-switch").getValue()==0)
		)
	)
	{
		fdm_node.getNode("systems/pneumatic/system-input").setValue(system_input);
	}
	else
	{
		if (fdm_node.getNode("systems/refill/on-switch").getValue()==1)
		{
			fdm_node.getNode("systems/pneumatic/system-input").setValue(
				fdm_node.getNode("systems/pneumatic/system-return").getValue()
			);
		}
		else
		{
			fdm_node.getNode("systems/pneumatic/system-input").setValue(0);
		}
	}

	#pids substitutes, rough integrators

	fdm_node.getNode("systems/pneumatic/system-press").setValue(
		fdm_node.getNode("systems/pneumatic/system-press").getValue()+
		fdm_node.getNode("systems/pneumatic/system-input").getValue()*tick_sec
	);

	fdm_node.getNode("systems/pneumatic/cyl[0]/pressure").setValue(
		fdm_node.getNode("systems/pneumatic/cyl[0]/pressure").getValue()+
		fdm_node.getNode("systems/pneumatic/cyl[0]/input").getValue()*tick_sec
	);

	fdm_node.getNode("systems/pneumatic/cyl[1]/pressure").setValue(
		fdm_node.getNode("systems/pneumatic/cyl[1]/pressure").getValue()+
		fdm_node.getNode("systems/pneumatic/cyl[1]/input").getValue()*tick_sec
	);

	fdm_node.getNode("systems/pneumatic/cyl[2]/pressure").setValue(
		fdm_node.getNode("systems/pneumatic/cyl[2]/pressure").getValue()+
		fdm_node.getNode("systems/pneumatic/cyl[2]/input").getValue()*tick_sec
	);

	fdm_node.getNode("systems/pneumatic/cockpit/pressure").setValue(
		fdm_node.getNode("systems/pneumatic/cockpit/pressure").getValue()+
		fdm_node.getNode("systems/pneumatic/cockpit/input").getValue()*
		tick_sec*
		0.1
	);

	settimer(func pneumatic(), 1.0); 

}

# initialisation  -------------------------------------------------

#timer is used to asyncronize fps load with other nasal systems

settimer(func pneumatic(), 0.25);
