# -----------------------------------------------------------------------
# Su-15 JSBSim right panle simplified nasal analog

powerpanel=func()
{

	fdm_node=props.globals.getNode("fdm/jsbsim");

	time_sec=props.globals.getNode("sim/time/elapsed-sec").getValue();
	time_sec_prev=fdm_node.getNode("systems/powerpanel/time-sec").getValue();
	tick_sec=time_sec-time_sec_prev;
	fdm_node.getNode("systems/powerpanel/time-sec").setValue(time_sec);
	fdm_node.getNode("systems/powerpanel/tick-sec").setValue(tick_sec);

	#Serviceability

	if (
		(fdm_node.getNode("breakage/broken").getValue()==1)
		 and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
	)
	{
		fdm_node.getNode("systems/powerpanel/serviceable").setValue(0);
	}

	if (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
	{
		fdm_node.getNode("systems/powerpanel/serviceable").setValue(1);
	}

	#Controllability

	fdm_node.getNode("systems/powerpanel/controllable").setValue(
		(1-fdm_node.getNode("breakage/pilot-knocked").getValue())
	);

	#First accumulator

	if (
		(fdm_node.getNode("systems/electrical/acc-first-pers").getValue()>10)
		and (fdm_node.getNode("systems/powerpanel/serviceable").getValue()==1)
		and (fdm_node.getNode("systems/powerpanel/controllable").getValue()==1)
		and  (fdm_node.getNode("systems/reset/on-switch").getValue()==0)
	)
	{
		fdm_node.getNode("systems/powerpanel/acc-first-command").setValue(
			fdm_node.getNode("systems/powerpanel/acc-first-input").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/electrical/acc-first-pers").getValue()<=10)
		or (fdm_node.getNode("systems/electrical/acc-first-heat").getValue()>=90)
		or (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/acc-first-command").setValue(0);
	}

	fdm_node.getNode("systems/powerpanel/acc-first-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/powerpanel/acc-first-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/acc-first-command").getValue(),
			0.2,
			tick_sec
		)
	);

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==0)
		or (fdm_node.getNode("systems/powerpanel/controllable").getValue()==0)
		or  (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/acc-first-input").setValue(
			fdm_node.getNode("systems/powerpanel/acc-first-command").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/electrical/acc-first-pers").getValue()<=10)
		or (fdm_node.getNode("systems/electrical/acc-first-heat").getValue()>=90)
	)
	{
		fdm_node.getNode("systems/powerpanel/acc-first-inpur").setValue(0);
	}

	fdm_node.getNode("systems/powerpanel/acc-first-switch").setValue(
		fdm_node.getNode("systems/powerpanel/acc-first-pos").getValue()>0.5
	);

	#Second accumulator

	if (
		(fdm_node.getNode("systems/electrical/acc-second-pers").getValue()>10)
		and (fdm_node.getNode("systems/powerpanel/serviceable").getValue()==1)
		and (fdm_node.getNode("systems/powerpanel/controllable").getValue()==1)
		and  (fdm_node.getNode("systems/reset/on-switch").getValue()==0)
	)
	{
		fdm_node.getNode("systems/powerpanel/acc-second-command").setValue(
			fdm_node.getNode("systems/powerpanel/acc-second-input").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/electrical/acc-second-pers").getValue()<=10)
		or (fdm_node.getNode("systems/electrical/acc-second-heat").getValue()>=90)
		or (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/acc-second-command").setValue(0);
	}

	fdm_node.getNode("systems/powerpanel/acc-second-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/powerpanel/acc-second-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/acc-second-command").getValue(),
			0.2,
			tick_sec
		)
	);

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==0)
		or (fdm_node.getNode("systems/powerpanel/controllable").getValue()==0)
		or  (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/acc-second-input").setValue(
			fdm_node.getNode("systems/powerpanel/acc-second-command").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/electrical/acc-second-pers").getValue()<=10)
		or (fdm_node.getNode("systems/electrical/acc-second-heat").getValue()>=90)
	)
	{
		fdm_node.getNode("systems/powerpanel/acc-second-inpur").setValue(0);
	}

	fdm_node.getNode("systems/powerpanel/acc-second-switch").setValue(
		fdm_node.getNode("systems/powerpanel/acc-second-pos").getValue()>0.5
	);

	#First ac generator

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==1)
		and (fdm_node.getNode("systems/powerpanel/controllable").getValue()==1)
		and  (fdm_node.getNode("systems/reset/on-switch").getValue()==0)
	)
	{
		fdm_node.getNode("systems/powerpanel/alt-gen-first-command").setValue(
			fdm_node.getNode("systems/powerpanel/alt-gen-first-input").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/alt-gen-first-command").setValue(0);
	}

	fdm_node.getNode("systems/powerpanel/alt-gen-first-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/powerpanel/alt-gen-first-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/alt-gen-first-command").getValue(),
			0.2,
			tick_sec
		)
	);

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==0)
		or (fdm_node.getNode("systems/powerpanel/controllable").getValue()==0)
		or  (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/alt-gen-first-input").setValue(
			fdm_node.getNode("systems/powerpanel/alt-gen-first-command").getValue()
		);
	}

	fdm_node.getNode("systems/powerpanel/alt-gen-first-switch").setValue(
		fdm_node.getNode("systems/powerpanel/alt-gen-first-pos").getValue()>0.5
	);

	#Second ac generator

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==1)
		and (fdm_node.getNode("systems/powerpanel/controllable").getValue()==1)
		and  (fdm_node.getNode("systems/reset/on-switch").getValue()==0)
	)
	{
		fdm_node.getNode("systems/powerpanel/alt-gen-second-command").setValue(
			fdm_node.getNode("systems/powerpanel/alt-gen-second-input").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/alt-gen-second-command").setValue(0);
	}

	fdm_node.getNode("systems/powerpanel/alt-gen-second-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/powerpanel/alt-gen-second-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/alt-gen-second-command").getValue(),
			0.2,
			tick_sec
		)
	);

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==0)
		or (fdm_node.getNode("systems/powerpanel/controllable").getValue()==0)
		or  (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/alt-gen-second-input").setValue(
			fdm_node.getNode("systems/powerpanel/alt-gen-second-command").getValue()
		);
	}

	fdm_node.getNode("systems/powerpanel/alt-gen-second-switch").setValue(
		fdm_node.getNode("systems/powerpanel/alt-gen-second-pos").getValue()>0.5
	);

	#First dc generator

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==1)
		and (fdm_node.getNode("systems/powerpanel/controllable").getValue()==1)
		and  (fdm_node.getNode("systems/reset/on-switch").getValue()==0)
	)
	{
		fdm_node.getNode("systems/powerpanel/const-gen-first-command").setValue(
			fdm_node.getNode("systems/powerpanel/const-gen-first-input").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/const-gen-first-command").setValue(0);
	}

	fdm_node.getNode("systems/powerpanel/const-gen-first-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/powerpanel/const-gen-first-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/const-gen-first-command").getValue(),
			0.2,
			tick_sec
		)
	);

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==0)
		or (fdm_node.getNode("systems/powerpanel/controllable").getValue()==0)
		or  (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/const-gen-first-input").setValue(
			fdm_node.getNode("systems/powerpanel/const-gen-first-command").getValue()
		);
	}

	fdm_node.getNode("systems/powerpanel/const-gen-first-switch").setValue(
		fdm_node.getNode("systems/powerpanel/const-gen-first-pos").getValue()>0.5
	);

	#Second dc generator

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==1)
		and (fdm_node.getNode("systems/powerpanel/controllable").getValue()==1)
		and  (fdm_node.getNode("systems/reset/on-switch").getValue()==0)
	)
	{
		fdm_node.getNode("systems/powerpanel/const-gen-second-command").setValue(
			fdm_node.getNode("systems/powerpanel/const-gen-second-input").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/const-gen-second-command").setValue(0);
	}

	fdm_node.getNode("systems/powerpanel/const-gen-second-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/powerpanel/const-gen-second-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/const-gen-second-command").getValue(),
			0.2,
			tick_sec
		)
	);

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==0)
		or (fdm_node.getNode("systems/powerpanel/controllable").getValue()==0)
		or  (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/const-gen-second-input").setValue(
			fdm_node.getNode("systems/powerpanel/const-gen-second-command").getValue()
		);
	}

	fdm_node.getNode("systems/powerpanel/const-gen-second-switch").setValue(
		fdm_node.getNode("systems/powerpanel/const-gen-second-pos").getValue()>0.5
	);

	#First registrator

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==1)
		and (fdm_node.getNode("systems/powerpanel/controllable").getValue()==1)
		and  (fdm_node.getNode("systems/reset/on-switch").getValue()==0)
	)
	{
		fdm_node.getNode("systems/powerpanel/reg-first-command").setValue(
			fdm_node.getNode("systems/powerpanel/reg-first-input").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/reg-first-command").setValue(0.5);
	}

	fdm_node.getNode("systems/powerpanel/reg-first-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/powerpanel/reg-first-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/reg-first-command").getValue(),
			0.2,
			tick_sec
		)
	);

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==0)
		or (fdm_node.getNode("systems/powerpanel/controllable").getValue()==0)
		or  (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/reg-first-input").setValue(
			fdm_node.getNode("systems/powerpanel/reg-first-command").getValue()
		);
	}

	fdm_node.getNode("systems/powerpanel/reg-first-switch").setValue(
		interpol.lin_inter(
			[
				[0.0,		0.0],
				[0.25,	0.0],
				[0.333,	0.5],
				[0.5,		0.5],
				[0.66,	0.5],
				[0.75,	1.0],
				[1.0,		1.0]
			],
			fdm_node.getNode("systems/powerpanel/reg-first-pos").getValue()
		)
	);

	#Second registrator

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==1)
		and (fdm_node.getNode("systems/powerpanel/controllable").getValue()==1)
		and  (fdm_node.getNode("systems/reset/on-switch").getValue()==0)
	)
	{
		fdm_node.getNode("systems/powerpanel/reg-second-command").setValue(
			fdm_node.getNode("systems/powerpanel/reg-second-input").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/reg-second-command").setValue(0.5);
	}

	fdm_node.getNode("systems/powerpanel/reg-second-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/powerpanel/reg-second-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/reg-second-command").getValue(),
			0.2,
			tick_sec
		)
	);

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==0)
		or (fdm_node.getNode("systems/powerpanel/controllable").getValue()==0)
		or  (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/reg-second-input").setValue(
			fdm_node.getNode("systems/powerpanel/reg-second-command").getValue()
		);
	}

	fdm_node.getNode("systems/powerpanel/reg-second-switch").setValue(
		interpol.lin_inter(
			[
				[0.0,		0.0],
				[0.25,	0.0],
				[0.333,	0.5],
				[0.5,		0.5],
				[0.66,	0.5],
				[0.75,	1.0],
				[1.0,		1.0]
			],
			fdm_node.getNode("systems/powerpanel/reg-second-pos").getValue()
		)
	);

	#First jet flap mode checker

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==1)
		and (fdm_node.getNode("systems/powerpanel/controllable").getValue()==1)
		and  (fdm_node.getNode("systems/reset/on-switch").getValue()==0)
	)
	{
		fdm_node.getNode("systems/powerpanel/jet-flap-first-command").setValue(
			fdm_node.getNode("systems/powerpanel/jet-flap-first-input").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/jet-flap-first-command").setValue(0);
	}

	fdm_node.getNode("systems/powerpanel/jet-flap-first-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/powerpanel/jet-flap-first-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/jet-flap-first-command").getValue(),
			0.2,
			tick_sec
		)
	);

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==0)
		or (fdm_node.getNode("systems/powerpanel/controllable").getValue()==0)
		or  (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/jet-flap-first-input").setValue(
			fdm_node.getNode("systems/powerpanel/jet-flap-first-command").getValue()
		);
	}

	fdm_node.getNode("systems/powerpanel/jet-flap-first-switch").setValue(
		fdm_node.getNode("systems/powerpanel/jet-flap-first-pos").getValue()>0.5
	);

	#Second jet flap mode checker

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==1)
		and (fdm_node.getNode("systems/powerpanel/controllable").getValue()==1)
		and  (fdm_node.getNode("systems/reset/on-switch").getValue()==0)
	)
	{
		fdm_node.getNode("systems/powerpanel/jet-flap-second-command").setValue(
			fdm_node.getNode("systems/powerpanel/jet-flap-second-input").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/jet-flap-second-command").setValue(0);
	}

	fdm_node.getNode("systems/powerpanel/jet-flap-second-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/powerpanel/jet-flap-second-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/jet-flap-second-command").getValue(),
			0.2,
			tick_sec
		)
	);

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==0)
		or (fdm_node.getNode("systems/powerpanel/controllable").getValue()==0)
		or  (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/jet-flap-second-input").setValue(
			fdm_node.getNode("systems/powerpanel/jet-flap-second-command").getValue()
		);
	}

	fdm_node.getNode("systems/powerpanel/jet-flap-second-switch").setValue(
		fdm_node.getNode("systems/powerpanel/jet-flap-second-pos").getValue()>0.5
	);

	#First ac generator relay

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==1)
		and (fdm_node.getNode("systems/powerpanel/controllable").getValue()==1)
		and  (fdm_node.getNode("systems/reset/on-switch").getValue()==0)
		and (
			(fdm_node.getNode("systems/electrical/alt-gen-first-cons").getValue()<=1)
			or (fdm_node.getNode("systems/electrical/alt-gen-first-on").getValue()==0)
		)
	)
	{
		fdm_node.getNode("systems/powerpanel/gen-relay-first-command").setValue(
			fdm_node.getNode("systems/powerpanel/gen-relay-first-input").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/electrical/alt-gen-first-cons").getValue()>1)
		and (fdm_node.getNode("systems/electrical/alt-gen-first-on").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/gen-relay-first-command").setValue(1);
	}

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/gen-relay-first-command").setValue(0);
	}

	fdm_node.getNode("systems/powerpanel/gen-relay-first-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/powerpanel/gen-relay-first-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/gen-relay-first-command").getValue(),
			0.4,
			tick_sec
		)
	);

	fdm_node.getNode("systems/powerpanel/gen-relay-first-switch-pos").setValue(
		interpol.sqr_inter(
			[
				[0.0,		0.0,	1.0],
				[0.0,		0.0,	0.0],
				[0.125,	0.65,	0.0],
				[0.25,	0.84,	0.0],
				[0.5,		1.0,	0.0],
				[0.75,	1.0,	0.5],
				[1.0,		1.0,	1.0]
			],
			fdm_node.getNode("systems/powerpanel/gen-relay-first-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/gen-relay-first-command").getValue()
		)
	);

	fdm_node.getNode("systems/powerpanel/gen-relay-first-cover-pos").setValue(
		interpol.sqr_inter(
			[
				[0.0,		0.0,	1.0],
				[0.0,		0.0,	0.0],
				[0.5,		0.5,	1.0],
				[1.0,		1.0,	1.0]
			],
			fdm_node.getNode("systems/powerpanel/gen-relay-first-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/gen-relay-first-command").getValue()
		)
	);

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==0)
		or (fdm_node.getNode("systems/powerpanel/controllable").getValue()==0)
		or  (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/gen-relay-first-input").setValue(
			fdm_node.getNode("systems/powerpanel/gen-relay-first-command").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/electrical/alt-gen-first-cons").getValue()>1)
		and (fdm_node.getNode("systems/electrical/alt-gen-first-on").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/gen-relay-first-input").setValue(1);
	}

	fdm_node.getNode("systems/powerpanel/gen-relay-first-switch").setValue(
		fdm_node.getNode("systems/powerpanel/gen-relay-first-pos").getValue()>0.75
	);

	#second ac generator relay

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==1)
		and (fdm_node.getNode("systems/powerpanel/controllable").getValue()==1)
		and  (fdm_node.getNode("systems/reset/on-switch").getValue()==0)
		and (
			(fdm_node.getNode("systems/electrical/alt-gen-second-cons").getValue()<=1)
			or (fdm_node.getNode("systems/electrical/alt-gen-second-on").getValue()==0)
		)
	)
	{
		fdm_node.getNode("systems/powerpanel/gen-relay-second-command").setValue(
			fdm_node.getNode("systems/powerpanel/gen-relay-second-input").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/electrical/alt-gen-second-cons").getValue()>1)
		and (fdm_node.getNode("systems/electrical/alt-gen-second-on").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/gen-relay-second-command").setValue(1);
	}

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/gen-relay-second-command").setValue(0);
	}

	fdm_node.getNode("systems/powerpanel/gen-relay-second-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/powerpanel/gen-relay-second-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/gen-relay-second-command").getValue(),
			0.4,
			tick_sec
		)
	);

	fdm_node.getNode("systems/powerpanel/gen-relay-second-switch-pos").setValue(
		interpol.sqr_inter(
			[
				[0.0,		0.0,	1.0],
				[0.0,		0.0,	0.0],
				[0.125,	0.65,	0.0],
				[0.25,	0.84,	0.0],
				[0.5,		1.0,	0.0],
				[0.75,	1.0,	0.5],
				[1.0,		1.0,	1.0]
			],
			fdm_node.getNode("systems/powerpanel/gen-relay-second-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/gen-relay-second-command").getValue()
		)
	);

	fdm_node.getNode("systems/powerpanel/gen-relay-second-cover-pos").setValue(
		interpol.sqr_inter(
			[
				[0.0,		0.0,	1.0],
				[0.0,		0.0,	0.0],
				[0.5,		0.5,	1.0],
				[1.0,		1.0,	1.0]
			],
			fdm_node.getNode("systems/powerpanel/gen-relay-second-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/gen-relay-second-command").getValue()
		)
	);

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==0)
		or (fdm_node.getNode("systems/powerpanel/controllable").getValue()==0)
		or  (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/gen-relay-second-input").setValue(
			fdm_node.getNode("systems/powerpanel/gen-relay-second-command").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/electrical/alt-gen-second-cons").getValue()>1)
		and (fdm_node.getNode("systems/electrical/alt-gen-second-on").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/gen-relay-second-input").setValue(1);
	}

	fdm_node.getNode("systems/powerpanel/gen-relay-second-switch").setValue(
		fdm_node.getNode("systems/powerpanel/gen-relay-second-pos").getValue()>0.75
	);


	#Converter relay

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==1)
		and (fdm_node.getNode("systems/powerpanel/controllable").getValue()==1)
		and  (fdm_node.getNode("systems/reset/on-switch").getValue()==0)
		and (
			(fdm_node.getNode("systems/electrical/alt-gen-second-cons").getValue()<=1)
			or (fdm_node.getNode("systems/electrical/alt-gen-second-on").getValue()==0)
		)
	)
	{
		fdm_node.getNode("systems/powerpanel/conv-relay-command").setValue(
			fdm_node.getNode("systems/powerpanel/conv-relay-input").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/electrical/alt-gen-second-cons").getValue()>1)
		and (fdm_node.getNode("systems/electrical/alt-gen-second-on").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/conv-relay-command").setValue(1);
	}

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/conv-relay-command").setValue(0);
	}

	fdm_node.getNode("systems/powerpanel/conv-relay-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/powerpanel/conv-relay-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/conv-relay-command").getValue(),
			0.4,
			tick_sec
		)
	);

	fdm_node.getNode("systems/powerpanel/conv-relay-switch-pos").setValue(
		interpol.sqr_inter(
			[
				[0.0,		0.0,	1.0],
				[0.0,		0.0,	0.0],
				[0.125,	0.65,	0.0],
				[0.25,	0.84,	0.0],
				[0.5,		1.0,	0.0],
				[0.75,	1.0,	0.5],
				[1.0,		1.0,	1.0]
			],
			fdm_node.getNode("systems/powerpanel/conv-relay-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/conv-relay-command").getValue()
		)
	);

	fdm_node.getNode("systems/powerpanel/conv-relay-cover-pos").setValue(
		interpol.sqr_inter(
			[
				[0.0,		0.0,	1.0],
				[0.0,		0.0,	0.0],
				[0.5,		0.5,	1.0],
				[1.0,		1.0,	1.0]
			],
			fdm_node.getNode("systems/powerpanel/conv-relay-pos").getValue(),
			fdm_node.getNode("systems/powerpanel/conv-relay-command").getValue()
		)
	);

	if (
		(fdm_node.getNode("systems/powerpanel/serviceable").getValue()==0)
		or (fdm_node.getNode("systems/powerpanel/controllable").getValue()==0)
		or  (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/conv-relay-input").setValue(
			fdm_node.getNode("systems/powerpanel/conv-relay-command").getValue()
		);
	}

	if (
		(fdm_node.getNode("systems/electrical/alt-gen-second-cons").getValue()>1)
		and (fdm_node.getNode("systems/electrical/alt-gen-second-on").getValue()==1)
	)
	{
		fdm_node.getNode("systems/powerpanel/conv-relay-input").setValue(1);
	}

	fdm_node.getNode("systems/powerpanel/conv-relay-switch").setValue(
		fdm_node.getNode("systems/powerpanel/conv-relay-pos").getValue()>0.75
	);

	#Click

	if (
		(
			(fdm_node.getNode("systems/powerpanel/acc-first-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/powerpanel/acc-first-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/powerpanel/acc-second-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/powerpanel/acc-second-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/powerpanel/alt-gen-first-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/powerpanel/alt-gen-first-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/powerpanel/alt-gen-second-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/powerpanel/alt-gen-second-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/powerpanel/const-gen-first-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/powerpanel/const-gen-first-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/powerpanel/const-gen-second-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/powerpanel/const-gen-second-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/powerpanel/reg-first-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/powerpanel/reg-first-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/powerpanel/reg-second-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/powerpanel/reg-second-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/powerpanel/gen-relay-first-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/powerpanel/gen-relay-first-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/powerpanel/gen-relay-second-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/powerpanel/gen-relay-second-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/powerpanel/conv-relay-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/powerpanel/conv-relay-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/powerpanel/jet-flap-first-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/powerpanel/jet-flap-first-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/powerpanel/jet-flap-second-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/powerpanel/jet-flap-second-pos").getValue()<=0.75)
		)
	)
	{
		fdm_node.getNode("systems/sounds/click/on").setValue(1);
	}

	settimer(func powerpanel(), 0.2);

}

# initialisation  -------------------------------------------------

#timer is used to asyncronize fps load with other nasal systems

settimer(func powerpanel(), 0.55);
