# -----------------------------------------------------------------------
# Su-15 JSBSim right panle simplified nasal analog

rightpanel=func()
{

	fdm_node=props.globals.getNode("fdm/jsbsim");

	time_sec=props.globals.getNode("sim/time/elapsed-sec").getValue();
	time_sec_prev=fdm_node.getNode("systems/rightpanel/time-sec").getValue();
	tick_sec=time_sec-time_sec_prev;
	fdm_node.getNode("systems/rightpanel/time-sec").setValue(time_sec);
	fdm_node.getNode("systems/rightpanel/tick-sec").setValue(tick_sec);

	#Serviceability

	if (
		(fdm_node.getNode("breakage/broken").getValue()==1)
		 and (fdm_node.getNode("systems/repair/on-switch").getValue()==0)
	)
	{
		fdm_node.getNode("systems/rightpanel/serviceable").setValue(0);
	}

	if (fdm_node.getNode("systems/repair/on-switch").getValue()==1)
	{
		fdm_node.getNode("systems/rightpanel/serviceable").setValue(1);
	}

	#Controllability

	fdm_node.getNode("systems/rightpanel/controllable").setValue(
		(1-fdm_node.getNode("breakage/pilot-knocked").getValue())
	);

	#Handle

	fdm_node.getNode("systems/rightpanel/handle-pos").setValue(
		fdm_node.getNode("systems/rightpanel/handle-pos").getValue()
		+(
			fdm_node.getNode("systems/rightpanel/handle-command").getValue()-
			fdm_node.getNode("systems/rightpanel/handle-pos").getValue()
		)*fdm_node.getNode("systems/rightpanel/tick-sec").getValue()/0.75
	);


	fdm_node.getNode("systems/rightpanel/handle-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/handle-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/handle-command").getValue(),
			0.2472,
			tick_sec
		)
	);

	if (fdm_node.getNode("systems/rightpanel/handle-pos").getValue()>=0.95)
	{
		fdm_node.getNode("systems/rightpanel/handle-input").setValue(0);
	}

	#Reset

	if (fdm_node.getNode("systems/reset/on-switch").getValue()==1)
	{
		fdm_node.getNode("systems/rightpanel/handle-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/radio-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/blcs-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/gears-control-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/gears-signal-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/brake-chute-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/hydrosystem-control-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/arthorizon-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/course-system-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/drop-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/emergency-drop-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/fire-control-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/hanger-signal-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/fire-left-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/fire-right-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/radiocompass-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/heating-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/radar-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/pump-second-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/control-instrumentation-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/engine-start-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/blcs-signal-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/airstart-left-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/airstart-right-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/reheat-left-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/reheat-right-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/intake-left-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/intake-right-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/pump-first-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/transfer-pump-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/converter-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/fuelometer-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/power-control-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/generator-first-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/generator-second-command").setValue(0);
		fdm_node.getNode("systems/rightpanel/light-command").setValue(0);
	}

	#Switches by handle

	if (fdm_node.getNode("systems/rightpanel/handle-pos").getValue()>=0.191)
	{
		fdm_node.getNode("systems/rightpanel/radio-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/blcs-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/gears-control-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/gears-signal-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/brake-chute-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/hydrosystem-control-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/arthorizon-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/course-system-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/drop-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/emergency-drop-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/fire-control-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/hanger-signal-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/fire-left-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/fire-right-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/radiocompass-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/heating-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/radar-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/pump-second-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/control-instrumentation-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/engine-start-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/blcs-signal-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/airstart-left-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/airstart-right-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/reheat-left-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/reheat-right-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/intake-left-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/intake-right-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/pump-first-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/transfer-pump-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/converter-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/fuelometer-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/power-control-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/generator-first-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/generator-second-input").setValue(1);
		fdm_node.getNode("systems/rightpanel/light-input").setValue(1);
	}

	#Move allowed

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==0)
		and (fdm_node.getNode("systems/rightpanel/serviceable").getValue()==1)
		and (fdm_node.getNode("systems/rightpanel/controllable").getValue()==1)
	)
	{
		fdm_node.getNode("systems/rightpanel/handle-command").setValue(
			fdm_node.getNode("systems/rightpanel/handle-input").getValue());
		fdm_node.getNode("systems/rightpanel/radio-command").setValue(
			fdm_node.getNode("systems/rightpanel/radio-input").getValue());
		fdm_node.getNode("systems/rightpanel/blcs-command").setValue(
			fdm_node.getNode("systems/rightpanel/blcs-input").getValue());
		fdm_node.getNode("systems/rightpanel/gears-control-command").setValue(
			fdm_node.getNode("systems/rightpanel/gears-control-input").getValue());
		fdm_node.getNode("systems/rightpanel/gears-signal-command").setValue(
			fdm_node.getNode("systems/rightpanel/gears-signal-input").getValue());
		fdm_node.getNode("systems/rightpanel/brake-chute-command").setValue(
			fdm_node.getNode("systems/rightpanel/brake-chute-input").getValue());
		fdm_node.getNode("systems/rightpanel/hydrosystem-control-command").setValue(
			fdm_node.getNode("systems/rightpanel/hydrosystem-control-input").getValue());
		fdm_node.getNode("systems/rightpanel/arthorizon-command").setValue(
			fdm_node.getNode("systems/rightpanel/arthorizon-input").getValue());
		fdm_node.getNode("systems/rightpanel/course-system-command").setValue(
			fdm_node.getNode("systems/rightpanel/course-system-input").getValue());
		fdm_node.getNode("systems/rightpanel/drop-command").setValue(
			fdm_node.getNode("systems/rightpanel/drop-input").getValue());
		fdm_node.getNode("systems/rightpanel/emergency-drop-command").setValue(
			fdm_node.getNode("systems/rightpanel/emergency-drop-input").getValue());
		fdm_node.getNode("systems/rightpanel/fire-control-command").setValue(
			fdm_node.getNode("systems/rightpanel/fire-control-input").getValue());
		fdm_node.getNode("systems/rightpanel/hanger-signal-command").setValue(
			fdm_node.getNode("systems/rightpanel/hanger-signal-input").getValue());
		fdm_node.getNode("systems/rightpanel/fire-left-command").setValue(
			fdm_node.getNode("systems/rightpanel/fire-left-input").getValue());
		fdm_node.getNode("systems/rightpanel/fire-right-command").setValue(
			fdm_node.getNode("systems/rightpanel/fire-right-input").getValue());
		fdm_node.getNode("systems/rightpanel/radiocompass-command").setValue(
			fdm_node.getNode("systems/rightpanel/radiocompass-input").getValue());
		fdm_node.getNode("systems/rightpanel/heating-command").setValue(
			fdm_node.getNode("systems/rightpanel/heating-input").getValue());
		fdm_node.getNode("systems/rightpanel/radar-command").setValue(
			fdm_node.getNode("systems/rightpanel/radar-input").getValue());
		fdm_node.getNode("systems/rightpanel/pump-second-command").setValue(
			fdm_node.getNode("systems/rightpanel/pump-second-input").getValue());
		fdm_node.getNode("systems/rightpanel/control-instrumentation-command").setValue(
			fdm_node.getNode("systems/rightpanel/control-instrumentation-input").getValue());
		fdm_node.getNode("systems/rightpanel/engine-start-command").setValue(
			fdm_node.getNode("systems/rightpanel/engine-start-input").getValue());
		fdm_node.getNode("systems/rightpanel/blcs-signal-command").setValue(
			fdm_node.getNode("systems/rightpanel/blcs-signal-input").getValue());
		fdm_node.getNode("systems/rightpanel/airstart-left-command").setValue(
			fdm_node.getNode("systems/rightpanel/airstart-left-input").getValue());
		fdm_node.getNode("systems/rightpanel/airstart-right-command").setValue(
			fdm_node.getNode("systems/rightpanel/airstart-right-input").getValue());
		fdm_node.getNode("systems/rightpanel/reheat-left-command").setValue(
			fdm_node.getNode("systems/rightpanel/reheat-left-input").getValue());
		fdm_node.getNode("systems/rightpanel/reheat-right-command").setValue(
			fdm_node.getNode("systems/rightpanel/reheat-right-input").getValue());
		fdm_node.getNode("systems/rightpanel/intake-left-command").setValue(
			fdm_node.getNode("systems/rightpanel/intake-left-input").getValue());
		fdm_node.getNode("systems/rightpanel/intake-right-command").setValue(
			fdm_node.getNode("systems/rightpanel/intake-right-input").getValue());
		fdm_node.getNode("systems/rightpanel/pump-first-command").setValue(
			fdm_node.getNode("systems/rightpanel/pump-first-input").getValue());
		fdm_node.getNode("systems/rightpanel/transfer-pump-command").setValue(
			fdm_node.getNode("systems/rightpanel/transfer-pump-input").getValue());
		fdm_node.getNode("systems/rightpanel/converter-command").setValue(
			fdm_node.getNode("systems/rightpanel/converter-input").getValue());
		fdm_node.getNode("systems/rightpanel/fuelometer-command").setValue(
			fdm_node.getNode("systems/rightpanel/fuelometer-input").getValue());
		fdm_node.getNode("systems/rightpanel/power-control-command").setValue(
			fdm_node.getNode("systems/rightpanel/power-control-input").getValue());
		fdm_node.getNode("systems/rightpanel/generator-first-command").setValue(
			fdm_node.getNode("systems/rightpanel/generator-first-input").getValue());
		fdm_node.getNode("systems/rightpanel/generator-second-command").setValue(
			fdm_node.getNode("systems/rightpanel/generator-second-input").getValue());
		fdm_node.getNode("systems/rightpanel/light-command").setValue(
			fdm_node.getNode("systems/rightpanel/light-input").getValue());
	}

	#Move not allowed

	if (
		(fdm_node.getNode("systems/reset/on-switch").getValue()==1)
		or (fdm_node.getNode("systems/rightpanel/serviceable").getValue()==0)
		or (fdm_node.getNode("systems/rightpanel/controllable").getValue()==0)
	)
	{
		fdm_node.getNode("systems/rightpanel/handle-input").setValue(
			fdm_node.getNode("systems/rightpanel/handle-command").getValue());
		fdm_node.getNode("systems/rightpanel/radio-input").setValue(
			fdm_node.getNode("systems/rightpanel/radio-command").getValue());
		fdm_node.getNode("systems/rightpanel/blcs-input").setValue(
			fdm_node.getNode("systems/rightpanel/blcs-command").getValue());
		fdm_node.getNode("systems/rightpanel/gears-control-input").setValue(
			fdm_node.getNode("systems/rightpanel/gears-control-command").getValue());
		fdm_node.getNode("systems/rightpanel/gears-signal-input").setValue(
			fdm_node.getNode("systems/rightpanel/gears-signal-command").getValue());
		fdm_node.getNode("systems/rightpanel/brake-chute-input").setValue(
			fdm_node.getNode("systems/rightpanel/brake-chute-command").getValue());
		fdm_node.getNode("systems/rightpanel/hydrosystem-control-input").setValue(
			fdm_node.getNode("systems/rightpanel/hydrosystem-control-command").getValue());
		fdm_node.getNode("systems/rightpanel/arthorizon-input").setValue(
			fdm_node.getNode("systems/rightpanel/arthorizon-command").getValue());
		fdm_node.getNode("systems/rightpanel/course-system-input").setValue(
			fdm_node.getNode("systems/rightpanel/course-system-command").getValue());
		fdm_node.getNode("systems/rightpanel/drop-input").setValue(
			fdm_node.getNode("systems/rightpanel/drop-command").getValue());
		fdm_node.getNode("systems/rightpanel/emergency-drop-input").setValue(
			fdm_node.getNode("systems/rightpanel/emergency-drop-command").getValue());
		fdm_node.getNode("systems/rightpanel/fire-control-input").setValue(
			fdm_node.getNode("systems/rightpanel/fire-control-command").getValue());
		fdm_node.getNode("systems/rightpanel/hanger-signal-input").setValue(
			fdm_node.getNode("systems/rightpanel/hanger-signal-command").getValue());
		fdm_node.getNode("systems/rightpanel/fire-left-input").setValue(
			fdm_node.getNode("systems/rightpanel/fire-left-command").getValue());
		fdm_node.getNode("systems/rightpanel/fire-right-input").setValue(
			fdm_node.getNode("systems/rightpanel/fire-right-command").getValue());
		fdm_node.getNode("systems/rightpanel/radiocompass-input").setValue(
			fdm_node.getNode("systems/rightpanel/radiocompass-command").getValue());
		fdm_node.getNode("systems/rightpanel/heating-input").setValue(
			fdm_node.getNode("systems/rightpanel/heating-command").getValue());
		fdm_node.getNode("systems/rightpanel/radar-input").setValue(
			fdm_node.getNode("systems/rightpanel/radar-command").getValue());
		fdm_node.getNode("systems/rightpanel/pump-second-input").setValue(
			fdm_node.getNode("systems/rightpanel/pump-second-command").getValue());
		fdm_node.getNode("systems/rightpanel/control-instrumentation-input").setValue(
			fdm_node.getNode("systems/rightpanel/control-instrumentation-command").getValue());
		fdm_node.getNode("systems/rightpanel/engine-start-input").setValue(
			fdm_node.getNode("systems/rightpanel/engine-start-command").getValue());
		fdm_node.getNode("systems/rightpanel/blcs-signal-input").setValue(
			fdm_node.getNode("systems/rightpanel/blcs-signal-command").getValue());
		fdm_node.getNode("systems/rightpanel/airstart-left-input").setValue(
			fdm_node.getNode("systems/rightpanel/airstart-left-command").getValue());
		fdm_node.getNode("systems/rightpanel/airstart-right-input").setValue(
			fdm_node.getNode("systems/rightpanel/airstart-right-command").getValue());
		fdm_node.getNode("systems/rightpanel/reheat-left-input").setValue(
			fdm_node.getNode("systems/rightpanel/reheat-left-command").getValue());
		fdm_node.getNode("systems/rightpanel/reheat-right-input").setValue(
			fdm_node.getNode("systems/rightpanel/reheat-right-command").getValue());
		fdm_node.getNode("systems/rightpanel/intake-left-input").setValue(
			fdm_node.getNode("systems/rightpanel/intake-left-command").getValue());
		fdm_node.getNode("systems/rightpanel/intake-right-input").setValue(
			fdm_node.getNode("systems/rightpanel/intake-right-command").getValue());
		fdm_node.getNode("systems/rightpanel/pump-first-input").setValue(
			fdm_node.getNode("systems/rightpanel/pump-first-command").getValue());
		fdm_node.getNode("systems/rightpanel/transfer-pump-input").setValue(
			fdm_node.getNode("systems/rightpanel/transfer-pump-command").getValue());
		fdm_node.getNode("systems/rightpanel/converter-input").setValue(
			fdm_node.getNode("systems/rightpanel/converter-command").getValue());
		fdm_node.getNode("systems/rightpanel/fuelometer-input").setValue(
			fdm_node.getNode("systems/rightpanel/fuelometer-command").getValue());
		fdm_node.getNode("systems/rightpanel/power-control-input").setValue(
			fdm_node.getNode("systems/rightpanel/power-control-command").getValue());
		fdm_node.getNode("systems/rightpanel/generator-first-input").setValue(
			fdm_node.getNode("systems/rightpanel/generator-first-command").getValue());
		fdm_node.getNode("systems/rightpanel/generator-second-input").setValue(
			fdm_node.getNode("systems/rightpanel/generator-second-command").getValue());
		fdm_node.getNode("systems/rightpanel/light-input").setValue(
			fdm_node.getNode("systems/rightpanel/light-command").getValue());
	}

	#Move

	fdm_node.getNode("systems/rightpanel/radio-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/radio-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/radio-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/blcs-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/blcs-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/blcs-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/gears-control-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/gears-control-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/gears-control-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/gears-signal-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/gears-signal-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/gears-signal-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/brake-chute-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/brake-chute-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/brake-chute-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/hydrosystem-control-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/hydrosystem-control-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/hydrosystem-control-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/arthorizon-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/arthorizon-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/arthorizon-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/course-system-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/course-system-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/course-system-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/drop-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/drop-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/drop-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/emergency-drop-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/emergency-drop-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/emergency-drop-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/fire-control-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/fire-control-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/fire-control-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/hanger-signal-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/hanger-signal-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/hanger-signal-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/fire-left-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/fire-left-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/fire-left-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/fire-right-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/fire-right-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/fire-right-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/radiocompass-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/radiocompass-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/radiocompass-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/heating-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/heating-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/heating-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/radar-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/radar-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/radar-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/pump-second-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/pump-second-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/pump-second-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/control-instrumentation-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/control-instrumentation-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/control-instrumentation-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/engine-start-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/engine-start-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/engine-start-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/blcs-signal-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/blcs-signal-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/blcs-signal-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/airstart-left-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/airstart-left-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/airstart-left-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/airstart-right-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/airstart-right-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/airstart-right-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/reheat-left-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/reheat-left-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/reheat-left-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/reheat-right-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/reheat-right-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/reheat-right-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/intake-left-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/intake-left-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/intake-left-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/intake-right-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/intake-right-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/intake-right-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/pump-first-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/pump-first-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/pump-first-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/transfer-pump-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/transfer-pump-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/transfer-pump-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/converter-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/converter-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/converter-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/fuelometer-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/fuelometer-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/fuelometer-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/power-control-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/power-control-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/power-control-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/generator-first-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/generator-first-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/generator-first-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/generator-second-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/generator-second-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/generator-second-command").getValue(),
			0.2,
			tick_sec
		)
	);

	fdm_node.getNode("systems/rightpanel/light-pos").setValue(
		interpol.kin(
			fdm_node.getNode("systems/rightpanel/light-pos").getValue(),
			fdm_node.getNode("systems/rightpanel/light-command").getValue(),
			0.2,
			tick_sec
		)
	);

	#Switches

	fdm_node.getNode("systems/rightpanel/radio-switch").setValue(
		fdm_node.getNode("systems/rightpanel/radio-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/blcs-switch").setValue(
		fdm_node.getNode("systems/rightpanel/blcs-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/gears-control-switch").setValue(
		fdm_node.getNode("systems/rightpanel/gears-control-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/gears-signal-switch").setValue(
		fdm_node.getNode("systems/rightpanel/gears-signal-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/brake-chute-switch").setValue(
		fdm_node.getNode("systems/rightpanel/brake-chute-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/hydrosystem-control-switch").setValue(
		fdm_node.getNode("systems/rightpanel/hydrosystem-control-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/arthorizon-switch").setValue(
		fdm_node.getNode("systems/rightpanel/arthorizon-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/course-system-switch").setValue(
		fdm_node.getNode("systems/rightpanel/course-system-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/drop-switch").setValue(
		fdm_node.getNode("systems/rightpanel/drop-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/emergency-drop-switch").setValue(
		fdm_node.getNode("systems/rightpanel/emergency-drop-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/fire-control-switch").setValue(
		fdm_node.getNode("systems/rightpanel/fire-control-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/hanger-signal-switch").setValue(
		fdm_node.getNode("systems/rightpanel/hanger-signal-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/fire-left-switch").setValue(
		fdm_node.getNode("systems/rightpanel/fire-left-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/fire-right-switch").setValue(
		fdm_node.getNode("systems/rightpanel/fire-right-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/radiocompass-switch").setValue(
		fdm_node.getNode("systems/rightpanel/radiocompass-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/heating-switch").setValue(
		fdm_node.getNode("systems/rightpanel/heating-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/radar-switch").setValue(
		fdm_node.getNode("systems/rightpanel/radar-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/pump-second-switch").setValue(
		fdm_node.getNode("systems/rightpanel/pump-second-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/control-instrumentation-switch").setValue(
		fdm_node.getNode("systems/rightpanel/control-instrumentation-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/engine-start-switch").setValue(
		fdm_node.getNode("systems/rightpanel/engine-start-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/blcs-signal-switch").setValue(
		fdm_node.getNode("systems/rightpanel/blcs-signal-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/airstart-left-switch").setValue(
		fdm_node.getNode("systems/rightpanel/airstart-left-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/airstart-right-switch").setValue(
		fdm_node.getNode("systems/rightpanel/airstart-right-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/reheat-left-switch").setValue(
		fdm_node.getNode("systems/rightpanel/reheat-left-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/reheat-right-switch").setValue(
		fdm_node.getNode("systems/rightpanel/reheat-right-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/intake-left-switch").setValue(
		fdm_node.getNode("systems/rightpanel/intake-left-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/intake-right-switch").setValue(
		fdm_node.getNode("systems/rightpanel/intake-right-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/pump-first-switch").setValue(
		fdm_node.getNode("systems/rightpanel/pump-first-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/transfer-pump-switch").setValue(
		fdm_node.getNode("systems/rightpanel/transfer-pump-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/converter-switch").setValue(
		fdm_node.getNode("systems/rightpanel/converter-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/fuelometer-switch").setValue(
		fdm_node.getNode("systems/rightpanel/fuelometer-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/power-control-switch").setValue(
		fdm_node.getNode("systems/rightpanel/power-control-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/generator-first-switch").setValue(
		fdm_node.getNode("systems/rightpanel/generator-first-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/generator-second-switch").setValue(
		fdm_node.getNode("systems/rightpanel/generator-second-pos").getValue()>0.5
	);

	fdm_node.getNode("systems/rightpanel/light-switch").setValue(
		fdm_node.getNode("systems/rightpanel/light-pos").getValue()>0.5
	);

	#Click

	if (
		(
			(fdm_node.getNode("systems/rightpanel/radio-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/radio-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/blcs-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/blcs-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/gears-control-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/gears-control-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/gears-signal-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/gears-signal-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/brake-chute-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/brake-chute-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/hydrosystem-control-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/hydrosystem-control-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/arthorizon-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/arthorizon-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/course-system-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/course-system-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/drop-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/drop-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/emergency-drop-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/emergency-drop-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/fire-control-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/fire-control-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/hanger-signal-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/hanger-signal-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/fire-left-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/fire-left-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/fire-right-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/fire-right-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/radiocompass-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/radiocompass-pos").getValue()>=0.25)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/heating-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/heating-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/radar-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/radar-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/pump-second-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/pump-second-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/control-instrumentation-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/control-instrumentation-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/engine-start-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/engine-start-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/blcs-signal-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/blcs-signal-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/airstart-left-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/airstart-left-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/airstart-right-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/airstart-right-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/reheat-left-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/reheat-left-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/reheat-right-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/reheat-right-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/intake-left-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/intake-left-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/intake-right-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/intake-right-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/pump-first-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/pump-first-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/transfer-pump-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/transfer-pump-pos").getValue()>=0.25)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/converter-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/converter-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/fuelometer-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/fuelometer-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/power-control-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/power-control-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/generator-first-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/generator-first-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/generator-second-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/generator-second-pos").getValue()<=0.75)
		)
		or (
			(fdm_node.getNode("systems/rightpanel/light-pos").getValue()>=0.25)
			and (fdm_node.getNode("systems/rightpanel/light-pos").getValue()<=0.75)
		)
	)
	{
		fdm_node.getNode("systems/sounds/click/on").setValue(1);
	}

	settimer(func rightpanel(), 0.2); 

}

# initialisation  -------------------------------------------------

#timer is used to asyncronize fps load with other nasal systems

settimer(func rightpanel(), 0.22);
