#Common bit swap function
bitswap = func (bit_name)
	{
		set_pos=getprop(bit_name);
		if (!((set_pos==1) or (set_pos==0)))
		{
			return (0); 
		}
		else
		{
			swap_pos=1-abs(set_pos);
			setprop(bit_name, swap_pos);
			return (1); 
		}
	}

#--------------------------------------------------------------------
#Due problems with controlling FG properties from JSB, 
# it's needed to transfers JSB properties change to FG.
#Listeners do not work in that case, so timer is used.

#Propulsion system listener

stop_propulsionlistentimer = func 
	{
	}

propulsionlistentimer = func 
	{
		# check state
		in_service = getprop("timers/propulsion/enabled" );
		if (in_service == nil)
		{
			return ( stop_propulsionlistentimer );
	 		return ( settimer(propulsionlistentimer, 0.1) ); 
		}
		if ( in_service != 1 )
		{
			return ( stop_propulsionlistentimer );
	 		return ( settimer(propulsionlistentimer, 0.1) ); 
		}

		propulsion_node=props.globals.getNode("fdm/jsbsim/propulsion");

		# get and set engines values
		foreach (var node; propulsion_node.getChildren("engine"))
		{
			index=node.getIndex();
			if (index==nil)
			{
				index=0;
			}

			if ((index>=0)
				and (index<=1))
			{
				setprop("controls/engines/engine["~index~"]/starter", 
					node.getNode("starter").getValue());
				setprop("controls/engines/engine["~index~"]/cutoff", 
					node.getNode("cutoff").getValue());
			}
			else
			{
				setprop("controls/engines/engine["~index~"]/starter", 
					0);
				setprop("controls/engines/engine["~index~"]/cutoff", 
					1);
			}

		}

		# get and set tanks values
		foreach (var node; propulsion_node.getChildren("tank"))
		{
			index=node.getIndex();
			if (index==nil)
			{
				index=0;
			}

			setprop("consumables/fuel/tank["~index~"]/level-lbs", 
				node.getNode("update-lbs").getValue());
		}

		return ( settimer(propulsionlistentimer, 0.1) ); 
	}

init_propulsionlistentimer = func 
{
	setprop("timers/propulsion/enabled", 1);
	return ( settimer(propulsionlistentimer, 0.1) ); 
}

#--------------------------------------------------------------------
#Init main view angles since FG not sets it correctly on itself

init_view = func 
{
	setprop("sim/current-view/field-of-view", 85);
	setprop("sim/current-view/config/default-field-of-view-deg", 85);
	setprop("sim/view/config/default-field-of-view-deg", 85);
	return (0); 
}

#--------------------------------------------------------------------
#JSB do not know what is FG ground type, so to things as
# rolling from runway it's needed to transfers FG properties to JSB.
#Again, timer is used.

stop_groundtypetimer = func 
	{
	}

groundtypetimer = func 
	{
		lat = getprop("position/latitude-deg");
		lon = getprop("position/longitude-deg");
		if (
			(lat == nil)
			or (lon==nil)
		)
		{
			stop_groundtypetimer();
	 		return ( settimer(groundtypetimer, 0.2) ); 
		}
		info = geodinfo(lat, lon);
		if (info == nil)
		{
			stop_groundtypetimer();
	 		return ( settimer(groundtypetimer, 0.2) ); 
		}
		if (
			(info[0] == nil)
			or (info[1] == nil)
		)
		{
			stop_groundtypetimer();
	 		return ( settimer(groundtypetimer, 0.2) ); 
		}
		setprop("fdm/jsbsim/gear/ground-info/height", info[0]);
		setprop("fdm/jsbsim/gear/ground-info/light_coverage", info[1].light_coverage);
		setprop("fdm/jsbsim/gear/ground-info/bumpiness", info[1].bumpiness);
		setprop("fdm/jsbsim/gear/ground-info/load_resistance", info[1].load_resistance);
		setprop("fdm/jsbsim/gear/ground-info/solid", info[1].solid);
		i=0;
		foreach(terrain_name; info[1].names)
		{
			setprop("fdm/jsbsim/gear/ground-info/names["~i~"]", terrain_name);
			i=i+1;
		}
		setprop("fdm/jsbsim/gear/ground-info/friction_factor", info[1].friction_factor);
		setprop("fdm/jsbsim/gear/ground-info/rolling_friction", info[1].rolling_friction);
 		return ( settimer(groundtypetimer, 0.2) ); 
	}

init_groundtypetimer = func 
{
	return ( settimer(groundtypetimer, 0.2) ); 
}

#--------------------------------------------------------------------
#Set seat listener

reenable_redout = func 
	{
		rest=getprop("/listeners/seat/rest");
		if (rest != nil)
		{
			setprop("/sim/rendering/headshake/enabled", rest);
			setprop("/sim/current-view/dynamic-view", rest);
			setprop("/sim/view/dynamic-view", rest);
			if (rest==1)
			{
				setprop("/sim/rendering/redout/parameters/blackout-complete-g", 4.5);
			}
			else
			{
				setprop("/sim/rendering/redout/parameters/blackout-complete-g", 10.0);
			}
		}
		setprop("/sim/rendering/redout/enabled", 1);
	}


stop_seatlistener = func 
	{
	}

seatlistener = func 
	{
		# check state
		in_service = getprop("/listeners/seat/enabled" );
		if (in_service == nil)
		{
			return ( stop_seatlistener );
		}
		if (in_service != 1)
		{
			return ( stop_seatlistener );
		}
		#get seat restraine handle value
		rest=getprop("/listeners/seat/rest");
		rest_res=getprop("/listeners/seat/rest-res");
		cup=getprop("/listeners/seat/cup");
		cup_res=getprop("/listeners/seat/cup-res");
		view_offset=getprop("/listeners/seat/view-offset");
		view_shift=getprop("/listeners/seat/view-shift");
		view_number=getprop("/sim/current-view/view-number");
		view_number_res=getprop("/listeners/seat/view-number-res");
		if (
			(rest==nil)
			or (rest_res==nil)
			or (cup==nil)
			or (cup_res==nil)
			or (view_offset==nil)
			or (view_shift==nil)
			or (view_number==nil)
			or (view_number_res==nil)
		)
		{
			return ( stop_seatlistener );
		}
		if (rest != rest_res)
		{
			if (rest==1)
			{
				setprop("/sim/rendering/redout/parameters/blackout-complete-g", 4.5);
				setprop("/sim/rendering/redout/enabled", 0);
				setprop("/sim/rendering/headshake/enabled", 0);
				setprop("/sim/current-view/dynamic-view", 0);
				setprop("/sim/view/dynamic-view", 0);
				settimer(reenable_redout, 0.2); 
			}
			else
			{
				setprop("/sim/rendering/redout/parameters/blackout-complete-g", 10.0);
				setprop("/sim/rendering/redout/enabled", 0);
				setprop("/sim/rendering/headshake/enabled", 0);
				setprop("/sim/current-view/dynamic-view", 0);
				setprop("/sim/view/dynamic-view", 0);
				settimer(reenable_redout, 0.2); 
			}
			setprop("/listeners/seat/rest_res", rest);
		}
		if ((cup != cup_res) or (view_number != view_number_res))
		{
			view_pos=view_offset+(cup-0.5)*view_shift;
			if ((view_number==0) or (view_number==1))
			{
				setprop("/sim/current-view/y-offset-m", view_pos);
			}
			if (cup != cup_res)
			{
				setprop("/listeners/seat/cup-res", cup);
			}
			if (view_number != view_number_res)
			{
				setprop("/listeners/seat/view-number-res", view_number);
			}
		}
 		return;
	}		

init_seatlistener = func 
{
	setprop("/listeners/seat/enabled", 1);
	setlistener("/listeners/seat/rest", seatlistener);
	setlistener("/listeners/seat/cup", seatlistener);
	setlistener("/sim/current-view/view-number", seatlistener);
}

init_seatlistener();

#--------------------------------------------------------------------
#Aircraft restrat function

end_aircraftrestart=func
	{
		#Aircraft reset
		setprop("fdm/jsbsim/systems/reset/on-input", 1);
		#Start break jsbsim listeners
		setprop("fdm/jsbsim/init/nasal-init", 1);
		#Unlock replay
		setprop("sim/replay/disable", 0);
		setprop("sim/menubar/default/menu[1]/item[8]/enabled", 1);
	}

aircraftrestart_freeze=func
	{
		#Get freeze values
		sim_clock=getprop("sim/freeze/state-saved/clock");
		sim_master=getprop("sim/freeze/state-saved/master");
		if (
			(sim_clock!=nil)
			and (sim_master!=nil)
		)
		{
			#Lock controls and freeze main clock
			setprop("sim/freeze/clock", 1);
			setprop("sim/freeze/master", 1);
			#Lock replay
			setprop("sim/replay/disable", 1);
			setprop("sim/menubar/default/menu[1]/item[8]/enabled", 0);
			#Aircraft initialization
			setprop("fdm/jsbsim/simulation/reset", 1);
			#Return controls and clock to previous state
			setprop("sim/freeze/clock", sim_clock);
			setprop("sim/freeze/master", sim_master);
			#Set listener to await full repair
			settimer(end_aircraftrestart, 1);
		}
	}

aircraft_restart=func
	{
		#Get freeze values
		sim_clock=getprop("sim/freeze/clock");
		sim_master=getprop("sim/freeze/master");
		if (
			(sim_clock!=nil)
			and (sim_master!=nil)
		)
		{
			#Stop break jsbsim listeners
			setprop("fdm/jsbsim/init/nasal-init", 0);
			#Set clock an master control stored states
			setprop("sim/freeze/state-saved/clock", sim_clock);
			setprop("sim/freeze/state-saved/master", sim_master);
			#Set listener to await changes before freeze
			settimer(aircraftrestart_freeze, 1);
		}
	}

setprop("sim/freeze/state-saved/clock", 0);
setprop("sim/freeze/state-saved/master", 0);

#-----------------------------------------------------------------------
#Property tree dump

dump_properties=func ()
	{
		fg_home = getprop("sim/fg-home" );
		if (fg_home!=nil)
		{
			io.write_properties(fg_home~"/state/properties-dump.xml", "/");
		}
	}


#-----------------------------------------------------------------------
#Rain

rain = func()
	{
		aircraft.rain.update();
		rain_norm = getprop ("environment/metar/rain-norm");
		setprop ("environment/rain-norm", rain_norm);
		settimer(rain, 0.2);
	}

#-----------------------------------------------------------------------
#Init reset

init_reset=func ()
	{
		setprop("fdm/jsbsim/systems/reset/on-input", 1);
		setprop("fdm/jsbsim/init/nasal-init", 1);
	}

#-----------------------------------------------------------------------
#

test_print=func ()
	{
		fdm_node=props.globals.getNode("fdm/jsbsim");
		pure_val=int(fdm_node.getNode("systems/speedometer/indicated-kmh").getValue());
		round_val=int(pure_val/100)*100;
		if (
			(fdm_node.getNode("systems/powerpanel/reg-second-switch").getValue()==1) and
			(round_val==pure_val)
		)
		{
			print (
				" speed="~sprintf("%03.2f", fdm_node.getNode("systems/speedometer/indicated-kmh").getValue())~
				" alt="~sprintf("%05.1f", fdm_node.getNode("systems/altimeter/altitude-indicated-m").getValue())~
				" el_pos="~sprintf("%01.3f", fdm_node.getNode("surfaces/elevator/unit[0]/pos-norm").getValue())
			);
		}
		settimer(test_print, 0.1);
	}

#--------------------------------------------------------------------
#Startup function
startup = func ()
	{
			init_view();
			init_propulsionlistentimer();
			init_groundtypetimer();
			init_reset();
			aircraft.tyresmoke_system.new(0, 1, 2);
			aircraft.rain.init();
			rain();
			return (0);
	}
